-- Destinations

local Addon =
{
	Name = "Destinations",
	Author = "|c990000Snowman|r|cFFFFFFDK|r",
	Version = "|cFFFFFF1.6.28|r",
}

local MapDataStoreIndex = Destinations.MapDataStoreIndex
local MapDataStore = Destinations.MapDataStore
local ACHDataIndex = Destinations.ACHDataIndex
local ACHDataStore = Destinations.ACHDataStore
local ACHids = Destinations.ACHids
local QuestDataIndex = Destinations.QuestDataIndex
local QuestDataStore = Destinations.QuestDataStore
local QuestTableIndex = Destinations.QuestTableIndex
local QuestTableStore = Destinations.QuestTableStore
local ChampionTableIndex = Destinations.ChampionTableIndex
local ChampionTableStore = Destinations.ChampionTableStore
local BorderDataIndex = Destinations.BorderDataIndex
local BorderDataStore = Destinations.BorderDataStore
local CollectibleDataIndex = Destinations.CollectibleDataIndex
local CollectibleDataStore = Destinations.CollectibleDataStore
local CollectibleIDs = Destinations.COLLECTIBLEids
local FishLocationsIndex = Destinations.FishLocationsIndex
local FishLocationsStore = Destinations.FishLocationsStore
local FISHids = Destinations.FISHids

local DestinationsSV, localLanguage, TempTag
local LMP = LibStub("LibMapPins-1.0")

local PINS_UNKNOWN = "DEST_PinSet_Unknown"
local PINS_KNOWN = "DEST_PinSet_Known"

local PINS_LB_GTTP_CP = "DEST_PinSet_Other"
local PINS_LB_GTTP_CP_DONE = "DEST_PinSet_Other_Done"
local PINS_MAIQ = "DEST_PinSet_Maiq"
local PINS_MAIQ_DONE = "DEST_PinSet_Maiq_Done"
local PINS_PEACEMAKER = "DEST_PinSet_Peacemaker"
local PINS_PEACEMAKER_DONE = "DEST_PinSet_Peacemaker_Done"
local PINS_NOSEDIVER = "DEST_PinSet_Nosediver"
local PINS_NOSEDIVER_DONE = "DEST_PinSet_Nosediver_Done"
local PINS_EARTHLYPOS = "DEST_PinSet_Earthly_Possessions"
local PINS_EARTHLYPOS_DONE = "DEST_PinSet_Earthly_Possessions_Done"
local PINS_ON_ME = "DEST_PinSet_This_Ones_On_Me"
local PINS_ON_ME_DONE = "DEST_PinSet_This_Ones_On_Me_Done"
local PINS_ACHIEVEMENTS_COMPASS = "DEST_Compass_Achievements"
local SHOW_COMPLETED_ACHIEVEMENTS = "DEST_Show_Completed_Achievements"
local PINS_ADD_ENGLISH = "DEST_Add_English"

local PINS_AYLEID = "DEST_PinSet_Ayleid"
local PINS_DWEMER = "DEST_PinSet_Dwemer"
local PINS_CHAMPION = "DEST_PinSet_Champion"
local PINS_MISC_COMPASS = "DEST_Compass_Misc"
local PINS_BORDER = "DEST_Pin_Border"
local PINS_BORDER_COMPASS = "DEST_Compass_Border"

local PINS_WWVAMP = "DEST_PinSet_WWVamp"
local PINS_VAMPIRE_ALTAR = "DEST_PinSet_Vampire_Alter"
local PINS_WEREWOLF_SHRINE = "DEST_PinSet_Werewolf_Shrine"
local PINS_VWW_COMPASS = "DEST_Compass_WWVamp"

local PINS_REALUNKNOWNWAYSHRINE = "DEST_Pin_RealUnknownWayshrine"
local PINS_REALUNKNOWNAOI = "DEST_Pin_RealUnknownAOI"
local PINS_REALUNKNOWNPUBLICDUNGEON = "DEST_Pin_RealUnknownPublicDungeon"
local PINS_REALUNKNOWNMUNDUS = "DEST_Pin_RealUnknownMundus"
local PINS_REALUNKNOWNDOLMEN = "DEST_Pin_RealUnknownDolmen"
local PINS_REALUNKNOWNGROUPBOSS = "DEST_Pin_RealUnknownGroupBoss"
local PINS_REALUNKNOWNGROUPDUNGEON = "DEST_Pin_RealUnknownGroupDungeon"
local PINS_REALUNKNOWNQUESTHUB = "DEST_Pin_RealUnknownQuestHub"
local PINS_REALUNKNOWNCRAFTING = "DEST_Pin_RealUnknownCrafting"
local PINS_REALUNKNOWNSOLODUNGEON = "DEST_Pin_RealUnknownSoloDungeon"
local PINS_REALUNKNOWNGROUPEVENT = "DEST_Pin_RealUnknownGroupEvent"
local PINS_REALUNKNOWNGROUPDELVE = "DEST_Pin_RealUnknownGroupDelve"
local PINS_REALUNKNOWNTRIAL = "DEST_Pin_RealUnknownTrial"
local PINS_REALUNKNOWNWAYSHRINETRADER = "DEST_Pin_RealUnknownWayshrineTrader"
local PINS_REALUNKNOWNGROUPDUNGEON2 = "DEST_Pin_RealUnknownPublicDungeon2"
local PINS_REALUNKNOWN = "DEST_Pin_RealUnknown"

local PINS_QUESTS_UNDONE = "DEST_Pin_Quest_Giver"
local PINS_QUESTS_IN_PROGRESS = "DEST_Pin_Quest_In_Progress"
local PINS_QUESTS_DONE = "DEST_Pin_Quest_Done"
local PINS_QUESTS_COMPASS = "DEST_Compass_Quest_Giver"
local REGISTER_QUESTS = "DEST_Register_Quests"

local PINS_COLLECTIBLES = "DEST_Pin_Collectibles"
local PINS_COLLECTIBLES_COMPASS = "DEST_Compass_Collectibles"
local PINS_COLLECTIBLESDONE = "DEST_Pin_Collectibles_Done"
local PINS_COLLECTIBLES_SHOW_ITEM = "DEST_Compass_Collectibles_Show_Item"
local PINS_COLLECTIBLES_SHOW_MOBNAME = "DEST_Compass_Collectibles_Show_MobName"

local PINS_FISHING = "DEST_Pin_Fishing"
local PINS_FISHING_COMPASS = "DEST_Compass_Fishing"
local PINS_FISHINGDONE = "DEST_Pin_Fishing_Done"
local PINS_FISHING_SHOW_BAIT = "DEST_Compass_Fishing_Show_Bait"
local PINS_FISHING_SHOW_WATER = "DEST_Compass_Fishing_Show_Water"
local PINS_FISHING_SHOW_FISHNAME = "DEST_Compass_Fishing_Show_FishName"

local updating = false
local EditingQuests = false
local getQuestInfo = false
local mapTextureName = nil

-- Define Defaults
local defaults = {
	pins = {
		pinTextureUnknown = {
		type = 3,
		size = 40,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
		textcolorEN = {1, 1, 1},
		textcolorTrader = {1, 1, 1},
	},
		pinTextureKnown = {
		type = 1,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
		textcolorEN = {1, 1, 1},
		textcolorTrader = {1, 1, 1},
	},
		pinTextureOther = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureOtherDone = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureMaiq = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureMaiqDone = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTexturePeacemaker = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTexturePeacemakerDone = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureNosediver = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureNosediverDone = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureEarthlyPos = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureEarthlyPosDone = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureOnMe = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureOnMeDone = {
		type = 6,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureAyleid = {
		type = 5,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureDwemer = {
		type = 7,
		size = 26,
		level = 145,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureChampion = {
		type = 1,
		size = 26,
		level = 30,
		maxDistance = 1,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureWWVamp = {
		type = 5,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureWWShrine = {
		type = 5,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureVampAltar = {
		type = 5,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureBorder = {
		type = 1,
		size = 42,
		level = 30,
		maxDistance = 0.01,
		texture = "Destinations/pins/border.dds",
		tint = {1, 0, 0, 1},
	},
		pinTextureQuestsUndone = {
		type = 1,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureQuestsInProgress = {
		type = 1,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureQuestsDone = {
		type = 1,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
	},
		pinTextureCollectible = {
		type = 2,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
		textcolortitle = {1, 1, 1},
	},
		pinTextureCollectibleDone = {
		type = 2,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
		textcolortitle = {1, 1, 1},
	},
		pinTextureFish = {
		type = 1,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
		textcolortitle = {1, 1, 1},
		textcolorBait = {1, 1, 1},
		textcolorWater = {1, 1, 1},
	},
		pinTextureFishDone = {
		type = 1,
		size = 26,
		level = 30,
		maxDistance = 0.05,
		texture = "",
		tint = {1, 1, 1, 1},
		textcolor = {1, 1, 1},
		textcolortitle = {1, 1, 1},
		textcolorBait = {1, 1, 1},
		textcolorWater = {1, 1, 1},
	},
	},
	miscColorCodes = {
		settingsTextAccountWide =		ZO_ColorDef:New("FFFF00"),
		settingsTextUnknown =			ZO_ColorDef:New("993333"),
		settingsTextKnown =				ZO_ColorDef:New("005500"),
		settingsTextEnglish =			ZO_ColorDef:New("AA5500"),
		settingsTextOnlyText =			ZO_ColorDef:New("CCCC00"),
		settingsTextWarn =				ZO_ColorDef:New("FF3333"),
		settingsTextEvenLine = 			ZO_ColorDef:New("EDEDCC"),
		settingsTextOddLine = 			ZO_ColorDef:New("FFFFFF"),
		settingsTextAchievements =		ZO_ColorDef:New("008800"),
		settingsTextMiscellaneous =		ZO_ColorDef:New("00CC00"),
		settingsTextVWW =				ZO_ColorDef:New("44DD44"),
		settingsTextQuests =			ZO_ColorDef:New("66FF66"),
		settingsTextCollectibles =		ZO_ColorDef:New("99FF99"),
		settingsTextFish =				ZO_ColorDef:New("CCFFCC"),
		settingsTextInstructions =		ZO_ColorDef:New("CCFFFF"),
		settingsTextReloadWarning =		ZO_ColorDef:New("FF0000"),
	},
	settings = {
		useAccountWide = false
	},
	filters = {
		[PINS_UNKNOWN] = true,
		[PINS_KNOWN] = false,
		[PINS_ADD_ENGLISH] = true,

		[PINS_LB_GTTP_CP] = false,
		[PINS_MAIQ] = false,
		[PINS_PEACEMAKER] = false,
		[PINS_NOSEDIVER] = false,
		[PINS_EARTHLYPOS] = false,
		[PINS_ON_ME] = false,

		[PINS_LB_GTTP_CP_DONE] = false,
		[PINS_MAIQ_DONE] = false,
		[PINS_PEACEMAKER_DONE] = false,
		[PINS_NOSEDIVER_DONE] = false,
		[PINS_EARTHLYPOS_DONE] = false,
		[PINS_ON_ME_DONE] = false,

		[PINS_ACHIEVEMENTS_COMPASS] = true,
		[SHOW_COMPLETED_ACHIEVEMENTS] = false,

		[PINS_DWEMER] = false,
		[PINS_AYLEID] = false,
		[PINS_CHAMPION] = false,
		[PINS_MISC_COMPASS] = true,

		[PINS_BORDER] = true,
		[PINS_BORDER_COMPASS] = true,

		[PINS_WWVAMP] = false,
		[PINS_VAMPIRE_ALTAR] = false,
		[PINS_WEREWOLF_SHRINE] = false,
		[PINS_VWW_COMPASS] = true,

		[PINS_QUESTS_UNDONE] = false,
		[PINS_QUESTS_IN_PROGRESS] = false,
		[PINS_QUESTS_DONE] = false,
		[PINS_QUESTS_COMPASS] = false,
		[REGISTER_QUESTS] = false,

		[PINS_COLLECTIBLES] = false,
		[PINS_COLLECTIBLESDONE] = false,
		[PINS_COLLECTIBLES_SHOW_ITEM] = false,
		[PINS_COLLECTIBLES_SHOW_MOBNAME] = false,
		[PINS_COLLECTIBLES_COMPASS] = false,

		[PINS_FISHING] = false,
		[PINS_FISHINGDONE] = false,
		[PINS_FISHING_SHOW_BAIT] = false,
		[PINS_FISHING_SHOW_WATER] = false,
		[PINS_FISHING_SHOW_FISHNAME] = false,
		[PINS_FISHING_COMPASS] = false,

		[PINS_REALUNKNOWNWAYSHRINE] = true,
		[PINS_REALUNKNOWNAOI] = true,
		[PINS_REALUNKNOWNPUBLICDUNGEON] = true,
		[PINS_REALUNKNOWNMUNDUS] = true,
		[PINS_REALUNKNOWNDOLMEN] = true,
		[PINS_REALUNKNOWNGROUPBOSS] = true,
		[PINS_REALUNKNOWNGROUPDUNGEON] = true,
		[PINS_REALUNKNOWNQUESTHUB] = true,
		[PINS_REALUNKNOWNCRAFTING] = true,
		[PINS_REALUNKNOWNSOLODUNGEON] = true,
		[PINS_REALUNKNOWNGROUPEVENT] = true,
		[PINS_REALUNKNOWNGROUPDELVE] = true,
		[PINS_REALUNKNOWNTRIAL] = true,
		[PINS_REALUNKNOWNWAYSHRINETRADER] = true,
		[PINS_REALUNKNOWNGROUPDUNGEON2] = true,
		[PINS_REALUNKNOWN] = true,
	},

	Quests = {},
	QuestsDone = {},
	TEMPPINDATA = {},
}

local function d(...)
	CHAT_SYSTEM:AddMessage(...)
end

local pinTexturesListUnknown = {
	"Asghaard's Croix",
	"Asghaard's Aura",
	"Semi-Real",
	"X",
	"Old Red X",
	"Old Yellow Exclamation Mark",
}
local pinTexturesListKnown = {
	defaults.miscColorCodes.settingsTextOnlyText:Colorize(GetString(GLOBAL_SETTINGS_SELECT_TEXT_ONLY)),
	"Asghaard's Aura",
	"Asghaard's Croix",
	"X",
	"Old Green X",
	"Old Green Exclamation Mark",
}
local pinTexturesListOther = {
	"Robber Mask",
	"Vendetta Mask",
	"Robber",
	"X",
	"Old Colored Robber",
	"Old Red Circled Robber",
}
local pinTexturesListMaiq = {
	"M'aiq",
	"Hood",
	"Asghaard's Croix",
	"X",
	"Old Colored M'aiq",
	"Old Red Circled M'aiq",
}
local pinTexturesListPeacemaker = {
	"Dove",
	"Peace Sign",
	"Peace Logo",
	"X",
	"Old Colored Dove",
	"Old Red Circled Dove",
}
local pinTexturesListNosediver = {
	"Nose 1",
	"Nose 2",
	"Diver",
	"X",
	"Old Colored Nose",
	"Old Red Circled Nose",
}
local pinTexturesListEarthlyPos = {
	"Pouch",
	"Gold",
	"Chest",
	"X",
	"Old Colored Gold",
	"Old Red Circled Gold",
}
local pinTexturesListOnMe = {
	"Cocktail 1",
	"Cocktail 2",
	"Wine",
	"X",
	"Old Colored Drink",
	"Old Red Circled Drink",
}
local pinTexturesListAyleid = {
	"Well",
	"Well inverted",
	"Well 2",
	"Asghaard's Aura",
	"Old Colored Well",
	"Old Red Circled Well",
}
local pinTexturesListDwemer = {
	defaults.miscColorCodes.settingsTextOnlyText:Colorize(GetString(GLOBAL_SETTINGS_SELECT_TEXT_ONLY)),
	"Helmet",
	"Real Dwemer Cog",
	"Asghaard's Aura",
	"Old Colored Dwemer Helm",
	"Old Red Circled Dwemer Helm",
	"Old Colored Spider",
	"Old Red Circled Spider",
	"Dwemer Cog",
}
local pinTexturesListChampion = {
	"Skull",
	"Helmet",
	"Asghaard's Aura",
}
local pinTexturesListWWVamp = {
	"Werewolf",
	"Werewolf inverted",
	"Vampire",
	"Vampire inverted",
	"Old Colored Werewolf",
	"Old Colored Vampire",
	"Old Red Circled Werewolf",
	"Old Red Circled Vampire",
}
local pinTexturesListWWShrine = {
	"Werewolf",
	"Werewolf Shrine 1",
	"Werewolf Shrine 2",
	"Asghaard's Aura",
	"Old Colored Shrine",
	"Old Red Circled Shrine",
}
local pinTexturesListVampAltar = {
	"Vampire Skull",
	"Vampire Altar 1",
	"Vampire Altar 2",
	"Asghaard's Aura",
	"Old Colored Altar",
	"Old Red Circled Altar",
}
local pinTexturesListBorder = {
	"Round",
}
local pinTexturesListQuests = {
	"Original Quest (Black)",
	"Original Quest (White)",
	"Original Quest (Glow)",
	"Straight Custom Quest",
	"Tilted Custom Quest",
	"Exclamation Mark",
}
local pinTexturesListCollectible = {
	"Skull",
	"Dwemer Cog",
	"Mudcrab",
	"Asghaard's Aura",
	"Old Trophy",
}
local pinTexturesListFish = {
	"Fish 1",
	"Fish 1 inverted",
	"Fish 2",
	"Fish 2 inverted",
	"Old Colored Fish",
}

local pinTextures = {
	Unknown = {
		[1] = "Destinations/pins/A_Global_Asghaard-croix_black.dds",
		[2] = "Destinations/pins/A_Global_Asghaard-aura.dds",
		[3] = "Destinations/pins/semireal/POI_RealUnknownWayshrine.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/X-Red.dds",
		[6] = "Destinations/pins/old/exclaimYellow.dds",
	},
	Known = {
		[1] = "Destinations/pins/a_dummy.dds",
		[2] = "Destinations/pins/A_Global_Asghaard-aura.dds",
		[3] = "Destinations/pins/A_Global_Asghaard-croix_white.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/X-Green.dds",
		[6] = "Destinations/pins/old/exclaimGreen.dds",
	},
	UnknownRealNew = {
		 [1] = "/esoui/art/icons/poi/poi_wayshrine_complete.dds",
		 [2] = "/esoui/art/icons/poi/poi_areaofinterest_complete.dds",
		 [3] = "/esoui/art/icons/poi/poi_cave_complete.dds", --test
		 [4] = "/esoui/art/icons/poi/poi_mundus_complete.dds",
		 [5] = "/esoui/art/icons/poi/poi_dolmen_complete.dds", --test
		 [6] = "/esoui/art/icons/poi/poi_groupboss_complete.dds",
		 [7] = "/esoui/art/icons/poi/poi_groupinstance_complete.dds",
		 [8] = "/esoui/art/icons/poi/poi_ruin_complete.dds", --test
		 [9] = "/esoui/art/icons/poi/poi_crafting_complete.dds",
		[10] = "/esoui/art/icons/poi/poi_dungeon_complete.dds",	
		[11] = "/esoui/art/icons/poi/poi_mine_compete.dds", --test
		[12] = "/esoui/art/icons/poi/poi_portal_complete.dds", --test
		[13] = "/esoui/art/icons/poi/poi_tower_complete.dds", --test
		[14] = "/esoui/art/icons/poi/poi_town_complete.dds", --test
		[15] = "/esoui/art/icons/poi/poi_grove_complete.dds", --test
		[16] = "/esoui/art/icons/poi/poi_farm_complete.dds", --test
		[17] = "Destinations/pins/semireal/POI_reserved.dds",
		[18] = "Destinations/pins/semireal/POI_reserved.dds",
		[19] = "Destinations/pins/semireal/POI_reserved.dds",
		[20] = "Destinations/pins/semireal/POI_reserved.dds",
		[21] = "Destinations/pins/semireal/POI_reserved.dds",
		[22] = "Destinations/pins/semireal/POI_RealUnknown.dds", --test
	},
	UnknownReal = {
		 [1] = "Destinations/pins/semireal/POI_RealUnknownWayshrine.dds",
		 [2] = "Destinations/pins/semireal/POI_RealUnknownAOI.dds",
		 [3] = "Destinations/pins/semireal/POI_RealUnknownPublicDungeon.dds",
		 [4] = "Destinations/pins/semireal/POI_RealUnknownMundus.dds",
		 [5] = "Destinations/pins/semireal/POI_RealUnknownDolmen.dds",
		 [6] = "Destinations/pins/semireal/POI_RealUnknownGroupBoss.dds",
		 [7] = "Destinations/pins/semireal/POI_RealUnknownGroupDungeon.dds",
		 [8] = "Destinations/pins/semireal/POI_RealUnknownQuestHub.dds",
		 [9] = "Destinations/pins/semireal/POI_RealUnknownCrafting.dds",
		[10] = "Destinations/pins/semireal/POI_RealUnknownSoloDungeon.dds",	
		[11] = "Destinations/pins/semireal/POI_RealUnknownGroupEvent.dds",	--?
		[12] = "Destinations/pins/semireal/POI_RealUnknownGroupDelve.dds",	--?
		[13] = "Destinations/pins/semireal/POI_RealUnknownTrial.dds",
		[14] = "Destinations/pins/semireal/POI_RealUnknownGuildTrader.dds",
		[15] = "Destinations/pins/semireal/POI_RealUnknownWayshrineTrader.dds",
		[16] = "Destinations/pins/semireal/POI_RealUnknownGroupDungeon2.dds",
		[17] = "Destinations/pins/semireal/POI_reserved.dds",
		[18] = "Destinations/pins/semireal/POI_reserved.dds",
		[19] = "Destinations/pins/semireal/POI_reserved.dds",
		[20] = "Destinations/pins/semireal/POI_reserved.dds",
		[21] = "Destinations/pins/semireal/POI_reserved.dds",
		[22] = "Destinations/pins/semireal/POI_RealUnknown.dds",
	},

	Other = {
		[1] = "Destinations/pins/Achievement_Other_robber_mask.dds",
		[2] = "Destinations/pins/Achievement_Other_vendetta.dds",
		[3] = "Destinations/pins/Achievement_Other_robber.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Other_colored.dds",
		[6] = "Destinations/pins/old/Achievement_Other_colored_Red.dds",
	},
	OtherDone = {
		[1] = "Destinations/pins/Achievement_Other_robber_mask.dds",
		[2] = "Destinations/pins/Achievement_Other_vendetta.dds",
		[3] = "Destinations/pins/Achievement_Other_robber.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Other_colored-complete.dds",
		[6] = "Destinations/pins/old/Achievement_Other_colored-complete.dds",
	},
	Maiq = {
		[1] = "Destinations/pins/Achievement_Maiq_Maiq.dds",
		[2] = "Destinations/pins/Achievement_Maiq_Hood.dds",
		[3] = "Destinations/pins/A_Global_Asghaard-croix_white.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Maiq_colored.dds",
		[6] = "Destinations/pins/old/Achievement_Maiq_colored_Red.dds",
	},
	MaiqDone = {
		[1] = "Destinations/pins/Achievement_Maiq_Maiq.dds",
		[2] = "Destinations/pins/Achievement_Maiq_Hood.dds",
		[3] = "Destinations/pins/A_Global_Asghaard-croix_white.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Maiq_colored-complete.dds",
		[6] = "Destinations/pins/old/Achievement_Maiq_colored-complete.dds",
	},
	Peacemaker = {
		[1] = "Destinations/pins/Achievement_Peacemaker_Dove.dds",
		[2] = "Destinations/pins/Achievement_Peacemaker_Peacesign.dds",
		[3] = "Destinations/pins/Achievement_Peacemaker_Peacelogo.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Peacemaker_colored.dds",
		[6] = "Destinations/pins/old/Achievement_Peacemaker_colored_Red.dds",
	},
	PeacemakerDone = {
		[1] = "Destinations/pins/Achievement_Peacemaker_Dove.dds",
		[2] = "Destinations/pins/Achievement_Peacemaker_Peacesign.dds",
		[3] = "Destinations/pins/Achievement_Peacemaker_Peacelogo.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Peacemaker_colored-complete.dds",
		[6] = "Destinations/pins/old/Achievement_Peacemaker_colored-complete.dds",
	},
	Nosediver = {
		[1] = "Destinations/pins/Achievement_Nosediver_Nose_1.dds",
		[2] = "Destinations/pins/Achievement_Nosediver_Nose_2.dds",
		[3] = "Destinations/pins/Achievement_Nosediver_Diver.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Nosediver_colored.dds",
		[6] = "Destinations/pins/old/Achievement_Nosediver_colored_Red.dds",
	},
	NosediverDone = {
		[1] = "Destinations/pins/Achievement_Nosediver_Nose_1.dds",
		[2] = "Destinations/pins/Achievement_Nosediver_Nose_2.dds",
		[3] = "Destinations/pins/Achievement_Nosediver_Diver.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_Nosediver_colored-complete.dds",
		[6] = "Destinations/pins/old/Achievement_Nosediver_colored-complete.dds",
	},
	Earthlypos = {
		[1] = "Destinations/pins/Achievement_EarthlyPossessions_Pouch.dds",
		[2] = "Destinations/pins/Achievement_EarthlyPossessions_Gold.dds",
		[3] = "Destinations/pins/Achievement_EarthlyPossessions_Chest.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_EarthlyPossessions_Gold.dds",
		[6] = "Destinations/pins/old/Achievement_EarthlyPossessions_Gold_Red.dds",
	},
	EarthlyposDone = {
		[1] = "Destinations/pins/Achievement_EarthlyPossessions_Pouch.dds",
		[2] = "Destinations/pins/Achievement_EarthlyPossessions_Gold.dds",
		[3] = "Destinations/pins/Achievement_EarthlyPossessions_Chest.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_EarthlyPossessions_Gold-complete.dds",
		[6] = "Destinations/pins/old/Achievement_EarthlyPossessions_Gold-complete.dds",
	},
	OnMe = {
		[1] = "Destinations/pins/Achievement_ThisOnesOnMe_Coctail_1.dds",
		[2] = "Destinations/pins/Achievement_ThisOnesOnMe_Coctail_2.dds",
		[3] = "Destinations/pins/Achievement_ThisOnesOnMe_Wine.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_ThisOnesOnMe_colored.dds",
		[6] = "Destinations/pins/old/Achievement_ThisOnesOnMe_colored_Red.dds",
	},
	OnMeDone = {
		[1] = "Destinations/pins/Achievement_ThisOnesOnMe_Coctail_1.dds",
		[2] = "Destinations/pins/Achievement_ThisOnesOnMe_Coctail_2.dds",
		[3] = "Destinations/pins/Achievement_ThisOnesOnMe_Wine.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Achievement_ThisOnesOnMe_colored-complete.dds",
		[6] = "Destinations/pins/old/Achievement_ThisOnesOnMe_colored-complete.dds",
	},

	ayleid = {
		[1] = "Destinations/pins/Ayleid_Well_1.dds",
		[2] = "Destinations/pins/Ayleid_Well_1_inverted.dds",
		[3] = "Destinations/pins/Ayleid_Well_2.dds",
		[4] = "Destinations/pins/A_Global_Asghaard-aura.dds",
		[5] = "Destinations/pins/old/Ayleid_Well_colored.dds",
		[6] = "Destinations/pins/old/Ayleid_Well_colored_Red.dds",
	},
	dwemer = {
		[1] = "Destinations/pins/dummy.dds",
		[2] = "Destinations/pins/Dwemer_Helmet.dds",
		[3] = "Destinations/pins/Dwemer_Cog.dds",
		[4] = "Destinations/pins/A_Global_Asghaard-aura.dds",
		[5] = "Destinations/pins/old/Dwemer_Helm.dds",
		[6] = "Destinations/pins/old/Dwemer_Helm_Red_Circle.dds",
		[7] = "Destinations/pins/old/Dwemer_Spider_colored.dds",
		[8] = "Destinations/pins/old/Dwemer_Spider_Red_Circle.dds",
		[9] = "Destinations/pins/Collectible_Dwemer_Cog.dds",
	},
	champion = {
		[1] = "Destinations/pins/Collectible_Skull.dds",
		[2] = "Destinations/pins/Dwemer_Helmet.dds",
		[3] = "Destinations/pins/A_Global_Asghaard-aura.dds",
	},
	border = {
		[1] = "Destinations/pins/border.dds",
	},

	wwvamp = {
		[1] = "Destinations/pins/VampWW_Werewolf.dds",
		[2] = "Destinations/pins/VampWW_Werewolf_inverted.dds",
		[3] = "Destinations/pins/VampWW_Vampire.dds",
		[4] = "Destinations/pins/VampWW_Vampire_inverted.dds",
		[5] = "Destinations/pins/old/VampWW_Werewolf.dds",
		[6] = "Destinations/pins/old/VampWW_Vampire.dds",
		[7] = "Destinations/pins/old/VampWW_Werewolf_Red.dds",
		[8] = "Destinations/pins/old/VampWW_Vampire_Red.dds",
	},
	vampirealtar = {
		[1] = "Destinations/pins/Vampire_Altar_VampireSkull.dds",
		[2] = "Destinations/pins/Vampire_Altar_1.dds",
		[3] = "Destinations/pins/Vampire_Altar_2.dds",
		[4] = "Destinations/pins/A_Global_Asghaard-aura.dds",
		[5] = "Destinations/pins/old/Vampire_Altar.dds",
		[6] = "Destinations/pins/old/Vampire_Altar_Red_Circle.dds",
	},
	werewolfshrine = {
		[1] = "Destinations/pins/Werewolf_Wolf.dds",
		[2] = "Destinations/pins/Werewolf_Shrine_1.dds",
		[3] = "Destinations/pins/Werewolf_Shrine_2.dds",
		[4] = "Destinations/pins/A_Global_Asghaard-aura.dds",
		[5] = "Destinations/pins/old/Werewolf_Shrine.dds",
		[6] = "Destinations/pins/old/Werewolf_Shrine_Red.dds",
	},

	Quests = {
		[1] = "esoui/art/compass/quest_icon.dds",
		[2] = "esoui/art/compass/quest_icon_assisted.dds",
		[3] = "esoui/art/compass/quest_available_icon.dds",
		[4] = "Destinations/pins/Quest_1.dds",
		[5] = "Destinations/pins/Quest_2.dds",
		[6] = "Destinations/pins/Quest_3.dds",
	},

	collectible = {
		[1] = "Destinations/pins/Collectible_Skull.dds",
		[2] = "Destinations/pins/Collectible_Dwemer_Cog.dds",
		[3] = "Destinations/pins/Collectible_Mudcrab.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Collectible_colored.dds",
		[6] = "Destinations/pins/old/Collectible_Trophy.dds",
	},
	collectibledone = {
		[1] = "Destinations/pins/Collectible_Skull.dds",
		[2] = "Destinations/pins/Collectible_Dwemer_Cog.dds",
		[3] = "Destinations/pins/Collectible_Mudcrab.dds",
		[4] = "Destinations/pins/A_Global_X.dds",
		[5] = "Destinations/pins/old/Collectible_colored-complete.dds",
		[6] = "Destinations/pins/old/Collectible_Trophy.dds",
	},

	fish = {
		[1] = "Destinations/pins/Fish_1.dds",
		[2] = "Destinations/pins/Fish_2.dds",
		[3] = "Destinations/pins/Fish_3.dds",
		[4] = "Destinations/pins/Fish_4.dds",
		[5] = "Destinations/pins/old/Fish_colored.dds",
	},
	fishdone = {
		[1] = "Destinations/pins/Fish_1.dds",
		[2] = "Destinations/pins/Fish_2.dds",
		[3] = "Destinations/pins/Fish_3.dds",
		[4] = "Destinations/pins/Fish_4.dds",
		[5] = "Destinations/pins/old/Fish_colored-complete.dds",
	},
}

local poiTypes = {
	[1] = GetString(POITYPE_WAYSHRINE),
	[2] = GetString(POITYPE_AOI),
	[3] = GetString(POITYPE_PUBLICDUNGEON),
	[4] = GetString(POITYPE_MUNDUS),
	[5] = GetString(POITYPE_DOLMEN),
	[6] = GetString(POITYPE_GROUPBOSS),
	[7] = GetString(POITYPE_GROUPDUNGEON),
	[8] = GetString(POITYPE_QUESTHUB),
	[9] = GetString(POITYPE_CRAFTING),
	[10] = GetString(POITYPE_SOLODUNGEON),
	[11] = GetString(POITYPE_GROUPEVENT),
	[12] = GetString(POITYPE_GROUPDELVE),
	[13] = GetString(POITYPE_TRIALINSTANCE),
	[14] = GetString(POITYPE_GUILDTRADERS),
	[22] = GetString(POITYPE_UNKNOWN),
}

local function GetPoiTypeName(poiTypeId)
	return poiTypes[poiTypeId] or poiTypes[22]
end

-- Data copied from Garkin's "English POI and Keep Names" -----------------------------------------------------------------------
local englishPOINames = {}
englishPOINames[18] = {		--Alik'r Desert
	[1] = "Sentinel Docks",
	[2] = "Ancestor's Landing",
	[3] = "Rain Catcher Fields",
	[4] = "Morwha's Bounty",
	[5] = "Tu'whacca's Throne",
	[6] = "Kulati Mines",
	[7] = "Leki's Blade",
	[8] = "Sep's Spine",
	[9] = "Bergama",
	[10] = "Tava's Blessing",
	[11] = "HoonDing's Watch",
	[12] = "Satakalaam",
	[13] = "Kozanset",
	[14] = "Sentinel",
	[15] = "Salas En",
	[16] = "Motalion Necropolis",
	[17] = "Morwha's Bounty Wayshrine",
	[18] = "Sentinel Wayshrine",
	[19] = "Bergama Wayshrine",
	[20] = "Leki's Blade Wayshrine",
	[21] = "Satakalaam Wayshrine",
	[22] = "Santaki",
	[23] = "Divad's Chagrin Mine",
	[24] = "Aldunz",
	[25] = "Coldrock Diggings",
	[26] = "Sandblown Mine",
	[27] = "Yldzuun",
	[28] = "Lost City of the Na-Totambu",
	[29] = "Divad's Chagrin Mine Wayshrine",
	[30] = "Kulati Mines Wayshrine",
	[31] = "Aswala Stables Wayshrine",
	[32] = "Sep's Spine Wayshrine",
	[33] = "Ogre's Bluff",
	[34] = "Shrikes' Aerie Wayshrine",
	[35] = "HoonDing's Watch Wayshrine",
	[36] = "Myrkwasa Dolmen",
	[37] = "Hollow Waste Dolmen",
	[38] = "Tigonus Dolmen",
	[39] = "The Warrior",
	[40] = "The Ritual",
	[41] = "The Thief",
	[42] = "Dungeon: Volenfell",
	[43] = "Goat's Head Oasis Wayshrine",
	[44] = "Lost Caravan",
	[45] = "Lesser Circle",
	[46] = "Giant Camp",
	[47] = "Forsaken Hearts Cave",
	[48] = "Hag Camp",
	[49] = "King's Rest",
	[50] = "Saltwalker Militia Camp",
	[51] = "Aswala's Remembrance",
	[52] = "Tears of the Dishonored",
	[53] = "Ragnthar",
	[54] = "Rkulftzel",
	[55] = "Alezer Kotu",
	[56] = "Easterly Aerie",
	[57] = "Hatiha's Camp",
	[58] = "Na-Totambu's Landing",
	[59] = "Artisan's Oasis",
	[60] = "Duneripper Downs",
	[61] = "Wayfarer's Wharf",
}
englishPOINames[179] = {	--Auridon
	[1] = "Ezduiin",
	[2] = "Tanzelwil",
	[3] = "South Beacon",
	[4] = "Glister Vale",
	[5] = "Del's Claim",
	[6] = "Ondil",
	[7] = "Entila's Folly",
	[8] = "Wansalen",
	[9] = "Silsailen",
	[10] = "Mehrunes' Spite",
	[11] = "Bewan",
	[12] = "The Lady",
	[13] = "Firsthold",
	[14] = "Phaer",
	[15] = "Shattered Grove",
	[16] = "North Beacon",
	[17] = "Vulkhel Guard",
	[18] = "Torinaan",
	[19] = "Mathiisen",
	[20] = "Vulkhel Guard Wayshrine",
	[21] = "Greenwater Cove",
	[22] = "The Lover",
	[23] = "Phaer Wayshrine",
	[24] = "Tanzelwil Wayshrine",
	[25] = "Firsthold Wayshrine",
	[26] = "Mathiisen Wayshrine",
	[27] = "Skywatch Wayshrine",
	[28] = "Quendeluun Wayshrine",
	[29] = "College Wayshrine",
	[30] = "Greenwater Wayshrine",
	[31] = "Quendeluun",
	[32] = "College of Aldmeri Propriety",
	[33] = "Windy Glade Wayshrine",
	[34] = "Dawnbreak",
	[35] = "Castle Rilis",
	[36] = "Skywatch",
	[37] = "Iluvamir Dolmen",
	[38] = "Calambar Dolmen",
	[39] = "Vafe Dolmen",
	[40] = "Toothmaul Gully",
	[41] = "Dungeon: The Banished Cells",
	[42] = "The Harborage",
	[43] = "Soulfire Plateau",
	[44] = "Seaside Scarp Camp",
	[45] = "Wreck of the Raptor",
	[46] = "Heretic's Summons",
	[47] = "Nestmother's Den",
	[48] = "Heritance Proving Ground",
	[49] = "Maormer Invasion Camp",
	[50] = "Hightide Keep",
	[51] = "Buraniim Isle",
	[52] = "Errinorne Isle",
	[53] = "Nine-Prow Landing",
	[54] = "Isle of Contemplation",
	[55] = "Beacon Falls",
	[56] = "Eastshore Islets Camp",
	[57] = "Monkey's Rest",
	[58] = "Smuggler's Cove",
	[59] = "Vulkhel Docks",
}
englishPOINames[295] = {	--Khenrati's Roost
	[1] = "Eagle's Strand",
	[2] = "Temple of the Mourning Springs",
	[3] = "Shattered Shoals",
	[4] = "Mistral",
	[5] = "Khenarthi's Roost Wayshrine",
	[6] = "Mistral Wayshrine",
	[7] = "Hazak's Hollow",
	[8] = "Cat's Eye Quay",
	[9] = "Windcatcher Plantation",
	[10] = "Speckled Shell Plantation",
	[11] = "Laughing Moons Plantation",
	[12] = "Bolga's Hunting Camp",
	[13] = "Temple of the Crescent Moons",
	[14] = "Temple of Two-Moons Dance",
	[15] = "Temple of the Dark Moon",
	[16] = "Rid-Thar's Solace",
}
englishPOINames[15] = {		--Bangkorai
	[1] = "Jackdaw Cove",
	[2] = "Northglen",
	[3] = "Halcyon Lake",
	[4] = "Pelin Graveyard",
	[5] = "Fallen Grotto",
	[6] = "Nilata Ruins",
	[7] = "Hall of Heroes",
	[8] = "Kerbol's Hollow",
	[9] = "Hallin's Stand",
	[10] = "Onsi's Breath",
	[11] = "Qharroa Ruins",
	[12] = "Bangkorai Garrison",
	[13] = "Martyr's Crossing",
	[14] = "Evermore",
	[15] = "Viridian Woods",
	[16] = "Razak's Wheel",
	[17] = "The Steed",
	[18] = "The Apprentice",
	[19] = "Evermore Wayshrine",
	[20] = "Troll's Toothpick Wayshrine",
	[21] = "Viridian Woods Wayshrine",
	[22] = "Bangkorai Pass Wayshrine",
	[23] = "Nilata Ruins Wayshrine",
	[24] = "Hallin's Stand Wayshrine",
	[25] = "Old Tower Wayshrine",
	[26] = "Onsi's Breath Wayshrine",
	[27] = "Sunken Road Wayshrine",
	[28] = "Old Tower",
	[29] = "Murcien's Hamlet",
	[30] = "Torog's Spite",
	[31] = "Troll's Toothpick",
	[32] = "Viridian Watch",
	[33] = "Crypt of the Exiles",
	[34] = "Klathzgar",
	[35] = "Rubble Butte",
	[36] = "Dungeon: Blackheart Haven",
	[37] = "Mournoth Dolmen",
	[38] = "Ephesus Dolmen",
	[39] = "Fallen Wastes Dolmen",
	[40] = "Eastern Evermore Wayshrine",
	[41] = "Halcyon Lake Wayshrine",
	[42] = "Blighted Isle",
	[43] = "Lakewatch Tower",
	[44] = "Arlimahera's Sanctum",
	[45] = "Summoner's Camp",
	[46] = "Nilata Falls",
	[47] = "Telesubi Ruins",
	[48] = "Damar Farmstead",
	[49] = "Silaseli Ruins",
	[50] = "Sunken Road",
	[51] = "Yanurah's Respite",
	[52] = "Ash'abahs' Oasis",
	[53] = "Gjarma's Rock",
	[54] = "Strastnoc's Landing",
	[55] = "Viridian Hideaway",
	[56] = "Basking Grounds",
	[57] = "Wethers' Cleft",
	[58] = "Sacred Springs",
	[59] = "Howlers' Nook",
--	[60] = "The Parley",
}
englishPOINames[155] = {	--Coldharbour
	[1] = "The Everfull Flagon",
	[2] = "The Lost Fleet",
	[3] = "Cliffs of Failure",
	[4] = "The Moonless Walk",
	[5] = "Library of Dusk Wayshrine",
	[6] = "Great Shackle Wayshrine",
	[7] = "The Chasm Wayshrine",
	[8] = "Hollow City Wayshrine",
	[9] = "Endless Stair Wayshrine",
	[10] = "Everfull Flagon Wayshrine",
	[11] = "Moonless Walk Wayshrine",
	[12] = "Haj Uxith Wayshrine",
	[13] = "Manor of Revelry Wayshrine",
	[14] = "Reaver Citadel Wayshrine",
	[15] = "The Orchard Wayshrine",
	[16] = "Aba-Loria",
	[17] = "The Grotto of Depravity",
	[18] = "The Cave of Trophies",
	[19] = "Vault of Haman Forgefire",
	[20] = "Mal Sorra's Tomb",
	[21] = "The Wailing Maw",
	[22] = "Tower of Lies",
	[23] = "Haj Uxith",
	[24] = "Court of Contempt",
	[25] = "The Chasm",
	[26] = "The Orchard",
	[27] = "Shrouded Plains Wayshrine",
	[28] = "The Black Forge",
	[29] = "Court of Contempt Wayshrine",
	[30] = "The Vile Laboratory",
	[31] = "Library of Dusk",
	[32] = "Spurned Peak",
	[33] = "The Lightless Oubliette",
	[34] = "The Manor of Revelry",
	[35] = "The Reaver Citadel",
	[36] = "The Hollow City",
	[37] = "The Great Shackle",
	[38] = "The Endless Stair",
	[39] = "Dungeon: Vaults of Madness",
	[40] = "Village of the Lost",
	[41] = "Aba-Darre",
	[42] = "Duriatundur's Killing Field",
	[43] = "Zemarek's Hollow",
	[44] = "Daedroth Larder",
	[45] = "Risen Court",
	[46] = "Cynhamoth's Grove",
	[47] = "Deathspinner's Lair",
	[48] = "Cadwell's Hovel",
	[49] = "Shrine of Kyne",
	[50] = "Endless Overlook",
	[51] = "Forsaken Village",
	[52] = "Survivor's Camp",
--	[53] = "",
	[54] = "Mages Guildhall",
	[55] = "Fighters Guildhall",
	[56] = "Font of Schemes",
}
englishPOINames[353] = {	--Craglorn
	[1] = "",
	[2] = "Rahni'Za, School of Warriors",
	[3] = "",
	[4] = "Molavar",
	[5] = "",
	[6] = "",
	[7] = "",
	[8] = "Rkundzelft",
	[9] = "",
	[10] = "Hero's End",
	[11] = "Serpent's Nest",
	[12] = "The Seeker's Archive",
	[13] = "Ruins of Kardala",
	[14] = "Ilthag's Undertower",
	[15] = "Shada's Tear",
	[16] = "",
	[17] = "",
	[18] = "",
	[19] = "",
	[20] = "",
	[21] = "",
	[22] = "Loth'Na Caverns",
	[23] = "Rkhardahrk",
	[24] = "Haddock's Market",
	[25] = "Chiselshriek Mine",
	[26] = "Buried Sands",
	[27] = "Mtharnaz",
	[28] = "The Howling Sepulchers",
	[29] = "Balamath",
	[30] = "Fearfangs Cavern",
	[31] = "Exarch's Stronghold",
	[32] = "Zalgaz's Den",
	[33] = "Tombs of the Na-Totambu",
	[34] = "Hircine's Haunt",
	[35] = "Magical Anomaly",
	[36] = "Magical Anomaly",
	[37] = "Magical Anomaly",
	[38] = "Magical Anomaly",
	[39] = "Anka-Ra Burial Site",
	[40] = "Anka-Ra Burial Site",
	[41] = "Anka-Ra Burial Site",
	[42] = "Anka-Ra Burial Site",
	[43] = "",
	[44] = "Belkarth",
	[45] = "Seeker's Archive Wayshrine",
	[46] = "Sandy Path Wayshrine",
	[47] = "Shada's Tear Wayshrine",
	[48] = "Anka-Ra Burial Site",
	[49] = "Magical Anomaly",
	[50] = "Belkarth Wayshrine",
	[51] = "",
	[52] = "",
	[53] = "",
	[54] = "",
	[55] = "",
	[56] = "",
	[57] = "Elinhir",
	[58] = "Spellscar",
	[59] = "",
	[60] = "Trial: Hel Ra Citadel",
	[61] = "Trial: Aetherian Archive",
	[62] = "Elinhir Wayshrine",
	[63] = "Spellscar Wayshrine",
	[64] = "Mountain Overlook Wayshrine",
	[65] = "Inazzur's Hold Wayshrine",
	[66] = "Proving Grounds Dolmen",
	[67] = "Bangkorai Gate",
	[68] = "Taborra's Camp",
	[69] = "Inazzur's Hold",
	[70] = "Thunder Falls Camp",
	[71] = "Scorpion Ravine",
	[72] = "Lake of Teeth",
	[73] = "Ogondar's Winery",
	[74] = "Dragonstar",
	[75] = "Dragonstar Arena",
	[76] = "Iron Orc Nirncrux Mine",
	[77] = "Iron Orc Nirncrux Mine",
	[78] = "Iron Orc Nirncrux Mine",
	[79] = "Iron Orc Nirncrux Mine",
	[80] = "Iron Orc Nirncrux Mine",
	[81] = "Skyreach Pinnacle",
	[82] = "Skyreach Catacombs",
	[83] = "Skyreach Hold",
	[84] = "Lanista's Waystation",
	[85] = "Trial: Sanctum Ophidia",
	[86] = "Dragonstar Wayshrine",
	[87] = "Skyreach Wayshrine",
	[88] = "Valley of Scars Wayshrine",
	[89] = "Crossroads Encampment",
	[90] = "Skyreach Overlook",
	[91] = "Sunken Lair",
	[92] = "Atelier of the Twice-Born Star",
}
englishPOINames[38] = {		--Cyrodiil
	[1] = "Sardavar Leed",
	[2] = "Gray Viper Outpost",
	[3] = "Homestead Ruins",
	[4] = "Culotte",
	[5] = "Juras' Fall",
	[6] = "Vlastarus",
	[7] = "Howling Cave",
	[8] = "Ceyatatar",
	[9] = "Haynote Cave",
	[10] = "Lunar Fang Docks",
	[11] = "Pothole Cavern",
	[12] = "Newt Cave",
	[13] = "Abbey of the Eight",
	[14] = "Nornalhorst",
	[15] = "Nisin Cave",
	[16] = "Narsinfel",
	[17] = "Wooden Hand Outlook",
	[18] = "Fanacasecul",
	[19] = "Hackdirt",
	[20] = "Wenyandawik",
	[21] = "Bloodmayne Cave",
	[22] = "Chorrol",
	[23] = "Red Ruby Cave",
	[24] = "Capstone Cave",
	[25] = "Ninendava",
	[26] = "Moranda",
	[27] = "Piukanda",
	[28] = "Sercen",
	[29] = "Anga",
	[30] = "Hrotanda Vale",
	[31] = "Echo Cave",
	[32] = "Lindai",
	[33] = "Empire Tower",
	[34] = "Lake Mist Ruins",
	[35] = "Waterside Mine",
	[36] = "Lipsand Tarn",
	[37] = "Cracked Wood Cave",
	[38] = "Kingscrest Cavern",
	[39] = "Muck Valley Cavern",
	[40] = "Quickwater Cave",
	[41] = "Vahtacen",
	[42] = "Breakneck Cave",
	[43] = "Serpent Hollow Cave",
	[44] = "Nornal",
	[45] = "Cheydinhal",
	[46] = "Harlun's Watch",
	[47] = "Belda",
	[48] = "Burned Estate",
	[49] = "Cropsford",
	[50] = "Bruma",
	[51] = "Temple of the Ancestor Moths",
	[52] = "NorthHighrock Gate Wayshrine",
	[53] = "South Highrock Gate Wayshrine",
	[54] = "Eastern Elsweyr Gate Wayshrine",
	[55] = "Western Elsweyr Gate Wayshrine",
	[56] = "North Morrowind Gate Wayshrine",
	[57] = "South Morrowind Gate Wayshrine",
	[58] = "Greenmead Dolmen",
	[59] = "Great Forest Dolmen",
	[60] = "Nibenay Valley Dolmen",
	[61] = "Applewatch Wood Dolmen",
	[62] = "Winter's Reach Dolmen",
	[63] = "Northwestern Shore Dolmen",
	[64] = "Eastern Shore Dolmen",
	[65] = "Niben Basin Dolmen",
	[66] = "Cheydinhal Foothills Dolmen",
	[67] = "The Apprentice",
	[68] = "The Atronach",
	[69] = "The Lady",
	[70] = "The Warrior",
	[71] = "The Mage",
	[72] = "The Thief",
	[73] = "The Lover",
	[74] = "The Serpent",
	[75] = "The Ritual",
	[76] = "The Tower",
	[77] = "The Steed",
	[78] = "The Shadow",
	[79] = "Cloud Ruler Temple",
	[80] = "Riverwatch",
	[81] = "Zimar's Winery",
	[82] = "Thalara's Winery",
	[83] = "Wilminn's Winery",
	[84] = "Sedor",
	[85] = "Coldcorn Ruin",
	[86] = "Fanacas",
	[87] = "Hedoran Estate",
	[88] = "Weynon Priory",
	[89] = "Crooked Finger Redoubt",
	[90] = "Underpall Cave",
	[91] = "Highlander Camp",
	[92] = "Ice-Heart Home",
	[93] = "Weye",
	[94] = "Shurgak Clan Estate",
	[95] = "Toadstool Hollow",
	[96] = "Abandoned Orchard",
	[97] = "Nagastani",
	[98] = "Barren Cave",
	[99] = "Moffka's Lament",
	[100] = "White Fall Mountain",
}
englishPOINames[11] = {		--Deshaan
	[1] = "Malak's Maw",
	[2] = "Silent Mire",
	[3] = "Muth Gnaar",
	[4] = "Deepcrag Den",
	[5] = "Quarantine Serk",
	[6] = "Narsis",
	[7] = "Tal'Deic Fortress",
	[8] = "Mzithumz",
	[9] = "Vale of the Ghost Snake",
	[10] = "Obsidian Gorge",
	[11] = "Eidolon's Hollow",
	[12] = "Mournhold",
	[13] = "Tribunal Temple",
	[14] = "The Tower",
	[15] = "The Mage",
	[16] = "The Lord",
	[17] = "Shrine of Saint Veloth",
	[18] = "Shad Astula",
	[19] = "Selfora",
	[20] = "Forgotten Crypts",
	[21] = "Dungeon: Darkshade Caverns",
	[22] = "West Narsis Wayshrine",
	[23] = "Muth Gnarr Hills Wayshrine",
	[24] = "Quarantine Serk Wayshrine",
	[25] = "Ghost Snake Vale Wayshrine",
	[26] = "Mournhold Wayshrine",
	[27] = "Tal'Deic Grounds Wayshrine",
	[28] = "Obsidian Gorge Wayshrine",
	[29] = "Mzithumz Wayshrine",
	[30] = "Selfora Wayshrine",
	[31] = "Silent Mire Wayshrine",
	[32] = "Eidolon's Hollow Wayshrine",
	[33] = "Lady Llarel's Shelter",
	[34] = "Lower Bthanual",
	[35] = "Triple Circle Mine",
	[36] = "Taleon's Crag",
	[37] = "Knife Ear Grotto",
	[38] = "The Corpse Garden",
	[39] = "Bthanual",
	[40] = "Redolent Loam Dolmen",
	[41] = "Lagomere Dolmen",
	[42] = "Siltreen Dolmen",
	[43] = "Shad Astula Wayshrine",
	[44] = "Short-Tusk's Hillock",
	[45] = "Grove of the Abomination",
	[46] = "Dire Bramblepatch",
	[47] = "Mabrigash Burial Circle",
	[48] = "Druitularg's Ritual Altar",
	[49] = "Caravan Crest",
	[50] = "House Dres Farmstead",
	[51] = "Avayan's Farm",
	[52] = "Lake Hlaalu Retreat",
	[53] = "Berezan's Mine",
	[54] = "Old Ida's Cottage",
	[55] = "Shrine to Saint Rilms",
	[56] = "Coiled Path Landing",
	[57] = "Smuggler's Slip",
	[58] = "Redoran Pier",
	[59] = "Hlanii's Hovel",
}
englishPOINames[16] = {		--Eastmarch
	[1] = "Thulvald's Logging Camp",
	[2] = "The Thief",
	[3] = "The Warrior",
	[4] = "The Ritual",
	[5] = "Lower Yorgrim",
	[6] = "Kynesgrove",
	[7] = "Windhelm",
	[8] = "Fort Morvunskar",
	[9] = "Cradlecrush",
	[10] = "Mzulft",
	[11] = "Wittestadr",
	[12] = "Bonestrewn Crest",
	[13] = "Fort Amol",
	[14] = "Windhelm Wayshrine",
	[15] = "Fort Morvunskar Wayshrine",
	[16] = "Kynesgrove Wayshrine",
	[17] = "Voljar Meadery Wayshrine",
	[18] = "Cradlecrush Wayshrine",
	[19] = "Fort Amol Wayshrine",
	[20] = "Wittestadr Wayshrine",
	[21] = "Mistwatch Wayshrine",
	[22] = "Jorunn's Stand Wayshrine",
	[23] = "Logging Camp Wayshrine",
	[24] = "Skuldafn Wayshrine",
	[25] = "Mistwatch",
	[26] = "The Chill Hollow",
	[27] = "Icehammer's Vault",
	[28] = "Old Sord's Cave",
	[29] = "The Frigid Grotto",
	[30] = "Stormcrag Crypt",
	[31] = "The Bastard's Tomb",
	[32] = "Voljar's Meadery",
	[33] = "Lost Knife Cave",
	[34] = "Cragwallow",
	[35] = "Jorunn's Stand",
	[36] = "Skuldafn",
	[37] = "Hall of the Dead",
	[38] = "Giant's Run Dolmen",
	[39] = "Frostwater Tundra Dolmen",
	[40] = "Icewind Peaks Dolmen",
	[41] = "Dungeon: Direfrost Keep",
	[42] = "Rageclaw's Den",
	[43] = "Dragon Mound",
	[44] = "Ratmaster's Prowl",
	[45] = "Dragon's Hallow",
	[46] = "Ammabani's Pride",
	[47] = "Swiftblade's Camp",
	[48] = "Darkwater Crossing",
	[49] = "Giant's Heart",
	[50] = "Ragnthar",
	[51] = "Cragwallow Cave",
	[52] = "Hammerhome",
	[53] = "Bitterblade's Camp",
	[54] = "Tinkerer Tobin's Workshop",
	[55] = "Crimson Kada's Crafting Cavern",
	[56] = "Hermit's Hideout",
	[57] = "Thane Jeggi's Drinking Hole",
}
englishPOINames[2] = {		--Glenumbra
	[1] = "Red Rook Camp",
	[2] = "Hag Fen",
	[3] = "Burial Mounds",
	[4] = "Daggerfall",
	[5] = "Deleyn's Mill",
	[6] = "Aldcroft",
	[7] = "Shrieking Scar",
	[8] = "Glenumbra Moors",
	[9] = "Westtry",
	[10] = "Lion Guard Redoubt",
	[11] = "Vale of the Guardians",
	[12] = "Eagle's Brook",
	[13] = "Camlorn",
	[14] = "Beldama Wyrd Tree",
	[15] = "Tomb of Lost Kings",
	[16] = "Crosswych",
	[17] = "Cath Bedraud",
	[18] = "Dresan Keep",
	[19] = "Baelborne Rock",
	[20] = "Ilessan Tower",
	[21] = "Silumm",
	[22] = "Mines of Khuras",
	[23] = "Enduum",
	[24] = "Ebon Crypt",
	[25] = "Cryptwatch Fort",
	[26] = "Wyrd Tree Wayshrine",
	[27] = "Aldcroft Wayshrine",
	[28] = "Deleyn's Mill Wayshrine",
	[29] = "Eagle's Brook Wayshrine",
	[30] = "North Hag Fen Wayshrine",
	[31] = "Lion Guard Redoubt Wayshrine",
	[32] = "Crosswych Wayshrine",
	[33] = "Farwatch Wayshrine",
	[34] = "Baelborne Rock Wayshrine",
	[35] = "Daggerfall Wayshrine",
	[36] = "Burial Tombs Wayshrine",
	[37] = "The Lover",
	[38] = "The Lady",
	[39] = "Dwynnarth Ruins",
	[40] = "Cambray Pass",
	[41] = "Bad Man's Hallows",
	[42] = "Dungeon: Spindleclutch",
	[43] = "Daenia Dolmen",
	[44] = "Cambray Hills Dolmen",
	[45] = "King's Guard Dolmen",
	[46] = "The Harborage",
	[47] = "Seaview Point",
	[48] = "Western Overlook",
	[49] = "The Wolf's Camp",
	[50] = "North Shore Point",
	[51] = "Trapjaw's Cove",
	[52] = "Balefire Island",
	[53] = "Valewatch Tower",
	[54] = "Merovec's Folly",
	[55] = "Tangle Rock",
	[56] = "Mesanthano's Tower",
	[57] = "Mire Falls",
	[58] = "Miltrin's Fishing Cabin",
	[59] = "Gaudet Farm",
	[60] = "Chill House",
	[61] = "Par Molag",
	[62] = "Dourstone Isle",
	[63] = "Hag Fen Wayshrine",
	[64] = "Daggerfall Southern Docks",
}
englishPOINames[294] = {	--Betnikh
	[1] = "Grimfield",
	[2] = "Carved Hills",
	[3] = "Stonetooth Wayshrine",
	[4] = "Grimfield Wayshrine",
	[5] = "Carved Hills Wayshrine",
	[6] = "Moriseli",
	[7] = "Carzog's Demise",
	[8] = "Gilbard's Nook",
	[9] = "Eyearata",
}
englishPOINames[293] = {	--Stros M'Kai
	[1] = "Saintsport",
	[2] = "Bthzark",
	[3] = "Port Hunding",
	[4] = "Port Hunding Wayshrine",
	[5] = "The Grave",
	[6] = "Sandy Grotto Wayshrine",
	[7] = "Saintsport Wayshrine",
	[8] = "Rash Merchant's Plummet",
	[9] = "Dogeater Goblin Camp",
	[10] = "Pillar of the Singing Sun",
}
englishPOINames[181] = {	--Grahtwood
	[1] = "Reliquary of Stars",
	[2] = "Root Sunder Ruins",
	[3] = "Haven",
	[4] = "Reman's Bluff",
	[5] = "Bone Orchard",
	[6] = "Gil-Var-Delle",
	[7] = "Cave of Broken Sails",
	[8] = "Dungeon: Elden Hollow",
	[9] = "The Gray Mire",
	[10] = "Brackenleaf",
	[11] = "Ossuary of Telacar",
	[12] = "The Tower",
	[13] = "The Mage",
	[14] = "The Lord",
	[15] = "Elden Root Wayshrine",
	[16] = "Gil-Var-Delle Wayshrine",
	[17] = "Elden Root Temple Wayshrine",
	[18] = "Haven Wayshrine",
	[19] = "Redfur Trading Post Wayshrine",
	[20] = "Southpoint Wayshrine",
	[21] = "Cormount Wayshrine",
	[22] = "Ossuary Wayshrine",
	[23] = "Laeloria",
	[24] = "Elden Root",
	[25] = "Southpoint",
	[26] = "Long Coast Dolmen",
	[27] = "Green Hall Dolmen",
	[28] = "Tarlain Heights Dolmen",
	[29] = "Falinesti Winter Site",
	[30] = "Karthdar",
	[31] = "Cormount",
	[32] = "Redfur Trading Post",
	[33] = "Goldfolly",
	[34] = "Ne Salas",
	[35] = "The Scuttle Pit",
	[36] = "Vinedeath Cave",
	[37] = "Burroot Kwama Mine",
	[38] = "Wormroot Depths",
	[39] = "Mobar Mine",
	[40] = "Gray Mire Wayshrine",
	[41] = "Falinesti Winter Wayshrine",
	[42] = "Hircine's Henge",
	[43] = "Nindaeril's Perch",
	[44] = "Lady Solace's Fen",
	[45] = "Poacher Camp",
	[46] = "Thugrub's Cave",
	[47] = "Valanir's Rest",
	[48] = "Tarlain Bandit Camp",
	[49] = "Vineshade Lodge",
	[50] = "Boar's Run Overlook",
	[51] = "Battle of Cormount Memorial",
	[52] = "Temple of the Eight",
	[53] = "Sweetbreeze Cottage",
	[54] = "Sacred Leap Grotto",
	[55] = "Fisherman's Isle",
	[56] = "Forked Root Camp",
	[57] = "Faltonia's Mine",
}
englishPOINames[19] = {		--Greenshade
	[1] = "Rulanyil's Fall",
	[2] = "Bramblebreach",
	[3] = "Woodhearth",
	[4] = "Rootwater Grove",
	[5] = "Verrant Morass",
	[6] = "Shademist Moors",
	[7] = "Moonhenge",
	[8] = "Shadows Crawl",
	[9] = "Driladan Pass",
	[10] = "Shrouded Vale",
	[11] = "Serpent's Grotto",
	[12] = "Spinner's Cottage",
	[13] = "Seaside Sanctuary",
	[14] = "Greenheart",
	[15] = "Dread Vullain",
	[16] = "Hectahame",
	[17] = "Greenheart Wayshrine",
	[18] = "Marbruk Wayshrine",
	[19] = "Labyrinth Wayshrine",
	[20] = "Falinesti Wayshrine",
	[21] = "Seaside Sanctuary Wayshrine",
	[22] = "Verrant Morass Wayshrine",
	[23] = "Woodhearth Wayshrine",
	[24] = "Moonhenge Wayshrine",
	[25] = "Serpent's Grotto Wayshrine",
	[26] = "The Atronach",
	[27] = "The Serpent",
	[28] = "The Shadow",
	[29] = "Green's Marrow Dolmen",
	[30] = "Drowned Coast Dolmen",
	[31] = "Wilderking Court Dolmen",
	[32] = "Marbruk",
	[33] = "Gurzag's Mine",
	[34] = "Carac Dena",
	[35] = "Naril Nagaia",
	[36] = "The Underroot",
	[37] = "Harridan's Lair",
	[38] = "Barrow Trench",
	[39] = "Dungeon: City of Ash",
	[40] = "Reconnaissance Camp",
	[41] = "Pelda Tarn",
	[42] = "Gathongor's Mire",
	[43] = "Rootwater Spring",
	[44] = "Thodundor's View",
	[45] = "Maormer Camp",
	[46] = "Falinesti Spring Site",
	[47] = "Seaside Overlook",
	[48] = "Twin Falls Rest",
	[49] = "Echo Pond",
	[50] = "Lanalda Pond",
	[51] = "Hollow Den",
	[52] = "Arananga",
	[53] = "Tower Rocks Vale",
	[54] = "Camp Gushnukbur",
	[55] = "Rootwatch Tower",
	[56] = "Fisherman's Point",
	[57] = "Labyrinth",
}
englishPOINames[12] = {		--Malabal Tor
	[1] = "Ouze",
	[2] = "Dra'Bul Wayshrine",
	[3] = "Ilayas Ruins Wayshrine",
	[4] = "Velyn Harbor Wayshrine",
	[5] = "Vulkwasten Wayshrine",
	[6] = "Abamath Wayshrine",
	[7] = "Wilding Vale Wayshrine",
	[8] = "Baandari Tradepost Wayshrine",
	[9] = "Bloodtoil Valley Wayshrine",
	[10] = "Valeguard Wayshrine",
	[11] = "The Thief",
	[12] = "The Ritual",
	[13] = "The Warrior",
	[14] = "Jathsogur",
	[15] = "Bloodtoil Valley",
	[16] = "Wilding Run",
	[17] = "Vulkwasten",
	[18] = "Fuller's Break",
	[19] = "Jode's Pocket",
	[20] = "Silvenar",
	[21] = "Ilayas Ruins",
	[22] = "Abamath",
	[23] = "Dra'bul",
	[24] = "Treehenge",
	[25] = "Valeguard",
	[26] = "Velyn Harbor",
	[27] = "Baandari Tradepost",
	[28] = "Deepwoods",
	[29] = "Dead Man's Drop",
	[30] = "Black Vine Ruins",
	[31] = "Roots of Silvenar",
	[32] = "Shael Ruins",
	[33] = "Falinesti Summer Site",
	[34] = "Hoarvor Pit",
	[35] = "Tomb of the Apostates",
	[36] = "Belarata",
	[37] = "Crimson Cove",
	[38] = "Broken Coast Dolmen",
	[39] = "Xylo River Basin Dolmen",
	[40] = "Silvenar Vale Dolmen",
	[41] = "Dungeon: Tempest Island",
	[42] = "Bone Grappler's Nest",
	[43] = "Bitterpoint Strand",
	[44] = "Dugan's Knoll",
	[45] = "River Edge",
	[46] = "Jagged Grotto",
	[47] = "Windshriek Strand",
	[48] = "Horseshoe Island",
	[49] = "Supplication House",
	[50] = "Ogrim's Yawn",
	[51] = "Tanglehaven",
	[52] = "Falinesti Summer Site",
	[53] = "Sleepy Senche Overlook",
	[54] = "Stranglewatch",
	[55] = "Ragnthar",
	[56] = "Chancel of Divine Entreaty",
	[57] = "Starwalk Cavern",
	[58] = "Matthild's Last Venture",
	[59] = "Four Quarry Islet",
}
englishPOINames[180] = {	--Reaper's March
	[1] = "Thormar",
	[2] = "Fort Grimwatch",
	[3] = "Moonmont",
	[4] = "Vinedusk Village",
	[5] = "Senalana",
	[6] = "Falinesti Autumn Site",
	[7] = "S'ren-ja",
	[8] = "Do'Krin Monastery",
	[9] = "Dune",
	[10] = "Hadran's Caravan",
	[11] = "Greenhill",
	[12] = "Pa'alat",
	[13] = "Arenthia",
	[14] = "Thizzrini Arena",
	[15] = "Kuna's Delve",
	[16] = "Thibaut's Cairn",
	[17] = "Weeping Wind Cave",
	[18] = "Claw's Strike",
	[19] = "Fadir's Folly",
	[20] = "Jode's Light",
	[21] = "Two Moons Path",
	[22] = "Willowgrove",
	[23] = "The Vile Manse",
	[24] = "Northern Woods Dolmen",
	[25] = "Jodewood Dolmen",
	[26] = "Dawnmead Dolmen",
	[27] = "The Steed",
	[28] = "The Apprentice",
	[29] = "Dungeon: Selene's Web",
	[30] = "Vinedusk Wayshrine",
	[31] = "Fort Grimwatch Wayshrine",
	[32] = "Fort Sphinxmoth Wayshrine",
	[33] = "Rawl'kha",
	[34] = "Arenthia Wayshrine",
	[35] = "Dune Wayshrine",
	[36] = "Willowgrove Wayshrine",
	[37] = "Moonmont Wayshrine",
	[38] = "Rawl'kha Wayshrine",
	[39] = "Sren-ja Wayshrine",
	[40] = "Fort Sphinxmoth",
	[41] = "Deathsong Cleft",
	[42] = "Big Ozur's Valley",
	[43] = "Waterdancer Falls",
	[44] = "Reaper's Henge",
	[45] = "Old S'ren-ja Docks",
	[46] = "Ushmal's Rest",
	[47] = "Willowgrove Cavern",
	[48] = "Old Town Cavern",
	[49] = "Researcher's Camp",
	[50] = "Crescent River Camp",
	[51] = "Broken Arch",
	[52] = "Greenspeaker's Grove",
	[53] = "Dawnmead Brigand Camp",
	[54] = "Little Ozur's Camp",
	[55] = "Fishing Dock",
	[56] = "Dawnmead Ruin Camp",
}
englishPOINames[5] = {		--Rivenspire
	[1] = "Hinault Farm",
	[2] = "Moira's Hope",
	[3] = "Silverhoof Vale",
	[4] = "Northpoint",
	[5] = "Crestshade",
	[6] = "Camp Tamrith",
	[7] = "Fell's Run",
	[8] = "Traitor's Tor",
	[9] = "Sanguine Barrows",
	[10] = "Shornhelm",
	[11] = "Edrald Estate",
	[12] = "Breagha-Fin",
	[13] = "Ravenwatch Castle",
	[14] = "The Doomcrag",
	[15] = "Lorkrata Hills",
	[16] = "Obsidian Scar",
	[17] = "Dungeon: Crypt of Hearts",
	[18] = "Oldgate Wayshrine",
	[19] = "Crestshade Wayshrine",
	[20] = "Camp Tamrith Wayshrine",
	[21] = "Hoarfrost Downs",
	[22] = "Boralis Wayshrine",
	[23] = "Staging Grounds Wayshrine",
	[24] = "Northpoint Wayshrine",
	[25] = "Fell's Run Wayshrine",
	[26] = "Hoarfrost Downs Wayshrine",
	[27] = "Shornhelm Wayshrine",
	[28] = "The Atronach",
	[29] = "The Shadow",
	[30] = "The Serpent",
	[31] = "Crestshade Mine",
	[32] = "Flyleaf Catacombs",
	[33] = "Tribulation Crypt",
	[34] = "Orc's Finger Ruins",
	[35] = "Erokii Ruins",
	[36] = "Hildune's Secret Refuge",
	[37] = "Sanguine Barrows Wayshrine",
	[38] = "Eyebright Feld Dolmen",
	[39] = "Westmark Moor Dolmen",
	[40] = "Boralis Dolmen",
	[41] = "Shrouded Pass Wayshrine",
	[42] = "Aesar's Web",
	[43] = "Valewatch Tower",
	[44] = "Old Kalgon's Keep",
	[45] = "Magdelena's Haunt",
	[46] = "East-Rock Landing",
	[47] = "Siren's Cove",
	[48] = "Shadowfate Cavern",
	[49] = "Old Fell's Fort",
	[50] = "Lagra's Pearl",
	[51] = "Northsalt Village",
	[52] = "Veawend Ede",
	[53] = "Westwind Lighthouse",
	[54] = "Dorell Farmhouse",
	[55] = "Southgard Tower",
	[56] = "Old Shornhelm Ruins",
	[57] = "Trader's Rest",
}
englishPOINames[20] = {		--Shadowfen
	[1] = "Alten Corimont",
	[2] = "Stormhold",
	[3] = "Stillrise Village",
	[4] = "Zuuk",
	[5] = "Hissmir",
	[6] = "Xal Ithix",
	[7] = "Deep Graves",
	[8] = "Ten-Maur-Wolk",
	[9] = "Murkwater",
	[11] = "Bogmother",
	[12] = "Forsaken Hamlet",
	[13] = "Hatching Pools",
	[14] = "Sunscale Strand",
	[15] = "Mud Tree Village",
	[16] = "Percolating Mire",
	[17] = "Atronach Stone",
	[18] = "The Shadow",
	[19] = "Serpent Stone",
	[20] = "Stillrise Wayshrine",
	[21] = "Stormhold Wayshrine",
	[22] = "Hatching Pools Wayshrine",
	[23] = "Bogmother Wayshrine",
	[24] = "Alten Corimont Wayshrine",
	[25] = "White Rose Prison",
	[26] = "Percolating Mire Wayshrine",
	[27] = "Hissmir Wayshrine",
	[28] = "Loriasel Wayshrine",
	[30] = "Venomous Fens Wayshrine",
	[31] = "Forsaken Hamlet Wayshrine",
	[32] = "Loriasel",
	[33] = "Shrine of the Black Maw",
	[34] = "Broken Tusk",
	[35] = "Atanaz Ruins",
	[36] = "Onkobra Kwama Mine",
	[37] = "Chid-Moska Ruins",
	[38] = "Gandranen Ruins",
	[39] = "Dungeon: Arx Corinium",
	[40] = "Sanguine's Demesne",
	[41] = "Reticulated Spine Dolmen",
	[42] = "Leafwater Dolmen",
	[43] = "Venomous Fens Dolmen",
	[44] = "Haynekhtnamet's Lair",
	[45] = "Captain Bones' Ship",
	[46] = "Bitterroot Cave",
	[47] = "Nen Ria",
	[48] = "Xal Thak",
	[49] = "Slaver Camp",
	[50] = "Xal Haj-Ei Shrine",
	[51] = "Camp Silken Snare",
	[52] = "The Vile Pavilion",
	[53] = "Camp Merciful Reduction",
	[54] = "Tsonashap Mine",
	[55] = "The Graceful Dominator",
	[56] = "Camp Crystal Abattoir",
	[57] = "Hatchling's Crown",
	[58] = "Telvanni Acquisition Camp",
	[59] = "Weeping Wamasu Falls",
	[60] = "Hei-Halai",
}
englishPOINames[9] = {		--Stonefalls
	[1] = "Fort Arand",
	[2] = "Vivec's Antlers",
	[3] = "Starved Plain",
	[4] = "Davon's Watch",
	[5] = "Hrogar's Hold",
	[6] = "Othrenis",
	[7] = "Sathram Plantation",
	[8] = "Brothers of Strife",
	[9] = "Heimlyn Keep",
	[10] = "Kragenmoor",
	[11] = "Lukiul Uxith",
	[12] = "Senie",
	[13] = "Sulfur Pools",
	[14] = "Iliath Temple",
	[15] = "Ebonheart",
	[16] = "Tormented Spire",
	[17] = "Ash Mountain",
	[18] = "Crow's Wood",
	[19] = "Fort Virak",
	[20] = "Davon's Watch Wayshrine",
	[21] = "Othrenis Wayshrine",
	[22] = "Fort Arand Wayshrine",
	[23] = "Ebonheart Wayshrine",
	[24] = "Vivec's Antlers Wayshrine",
	[25] = "Brothers of Strife Wayshrine",
	[26] = "Hrogar's Hold Wayshrine",
	[27] = "Fort Virak Wayshrine",
	[28] = "Iliath Temple Wayshrine",
	[29] = "Sathram Plantation Wayshrine",
	[30] = "Kragenmoor Wayshrine",
	[31] = "Ashen Road Wayshrine",
	[32] = "The Lady",
	[33] = "The Lover",
	[34] = "Dungeon: Fungal Grotto",
	[35] = "Inner Sea Armature",
	[36] = "Mephala's Nest",
	[37] = "Softloam Cavern",
	[38] = "Emberflint Mine",
	[39] = "Sulfur Pools Wayshrine",
	[40] = "Senie Wayshrine",
	[41] = "Hightide Hollow",
	[42] = "Sheogorath's Tongue",
	[43] = "Daen Seeth Dolmen",
	[44] = "Zabamat Dolmen",
	[45] = "Varanis Dolmen",
	[46] = "The Harborage",
	[47] = "Strifeswarm Hive",
	[48] = "The Matron's Clutch",
	[49] = "Shivering Shrine",
	[50] = "Cave of Memories",
	[51] = "Shipwreck Strand",
	[52] = "Still-Water's Camp",
	[53] = "Strifeswarm Kwama Mine",
	[54] = "Armature's Upheaval",
	[55] = "Stonefang Isle",
	[56] = "Steamfont Cavern",
	[57] = "Dagger's Point Invasion Camp",
	[58] = "Davenas Farm",
	[59] = "Magmaflow Overlook",
	[60] = "Greymist Falls",
	[61] = "Steamlake Encampment",
	[62] = "The Brahma's Grove",
	[64] = "Dockyards",
}
englishPOINames[111] = {	--Bal Foyen
	[1] = "Dhalmora",
	[2] = "Dhalmora Wayshrine",
	[3] = "Fort Zeren Wayshrine",
	[4] = "Foyen Docks Wayshrine",
	[5] = "Bal Foyen Dockyards",
	[6] = "Fort Zeren",
	[7] = "Hidden Dagger Landing Site",
	[8] = "Plantation Point Overlook",
}
englishPOINames[110] = {	--Bleakrock Isle
	[1] = "Orkey's Hollow",
	[2] = "Skyshroud Barrow",
	[3] = "Bleakrock Wayshrine",
	[4] = "Hozzin's Folly",
	[5] = "Bleakrock Village",
	[6] = "Frostedge Camp",
	[7] = "Hunter's Camp",
	[8] = "Halmaera's House",
	[9] = "Companions Point",
	[10] = "Paddlefloe Fishing Camp",
	[11] = "Deathclaw's Lair",
}
englishPOINames[4] = {		--Stormhaven
	[1] = "Aphren's Hold",
	[2] = "Shinji's Scarp",
	[3] = "Dro-Dara Plantation",
	[4] = "Soulshriven Tower",
	[5] = "Farangel's Landing",
	[6] = "Pariah Abbey",
	[7] = "Wind Keep",
	[8] = "Dreughside",
	[9] = "Cumberland's Watch",
	[10] = "At-Tura Estate",
	[11] = "Koeglin Lighthouse",
	[12] = "Steelheart Moorings",
	[13] = "Firebrand Keep",
	[14] = "Moonlit Maw",
	[15] = "Nurin Farm",
	[16] = "Vanne Farm",
	[17] = "Alcaire Castle",
	[18] = "Koeglin Village",
	[19] = "Windridge Cave",
	[20] = "Dungeon: Wayrest Sewers",
	[21] = "Bonesnap Ruins",
	[22] = "Koeglin Village Wayshrine",
	[23] = "Alcaire Castle Wayshrine",
	[24] = "Firebrand Keep Wayshrine",
	[25] = "Wind Keep Wayshrine",
	[26] = "Dro'dara Plantation Wayshrine",
	[27] = "Soulshriven Wayshrine",
	[28] = "Pariah Abbey Wayshrine",
	[29] = "Portdun Watch",
	[30] = "Koeglin Mine",
	[31] = "Pariah Catacombs",
	[32] = "Farangel's Delve",
	[33] = "Bearclaw Mine",
	[34] = "Norvulk Ruins",
	[35] = "Weeping Giant Wayshrine",
	[36] = "The Tower",
	[37] = "The Mage",
	[38] = "The Lord",
	[39] = "Gavaudon Dolmen",
	[40] = "Alcaire Dolmen",
	[41] = "Menevia Dolmen",
	[42] = "Wayrest Wayshrine",
	[43] = "Bonesnap Ruins Wayshrine",
	[44] = "Spider Nest",
	[45] = "Mudcrab Beach",
	[46] = "Dreugh Waters",
	[47] = "Abandoned Farm",
	[48] = "Scrag's Larder",
	[49] = "Ancient Altar",
	[50] = "Supernal Dreamers Camp",
	[51] = "Nightmare Crag",
	[52] = "Cave of Dreams",
	[53] = "Shrine to Azura",
	[54] = "Cumberland Falls",
	[55] = "Stonechewer Goblin Camp",
	[56] = "Hammerdeath Workshop",
	[57] = "Fisherman's Island",
	[58] = "Travelers' Rest",
	[59] = "Windridge Warehouse",
	[60] = "Weeping Giant",
}
englishPOINames[17] = {		--The Rift
	[1] = "Shor's Stone",
	[2] = "Vernim Woods",
	[3] = "Boulderfall Pass",
	[4] = "Pinepeak Cavern",
	[5] = "Nimalten",
	[6] = "Fallowstone Hall",
	[7] = "Northwind Mine",
	[8] = "Honrich Tower",
	[9] = "Taarengrav",
	[10] = "Skald's Retreat",
	[11] = "Treva's Farm",
	[12] = "Trolhetta",
	[13] = "Forelhost",
	[14] = "Riften Wayshrine",
	[15] = "Skald's Retreat Wayshrine",
	[16] = "Trolhetta Wayshrine",
	[17] = "Trolhetta Summit Wayshrine",
	[18] = "Lost Prospect",
	[19] = "Geirmund's Hall",
	[20] = "The Steed",
	[21] = "Riften",
	[22] = "Fullhelm Fort",
	[23] = "Honrich Tower Wayshrine",
	[24] = "Fallowstone Hall Wayshrine",
	[25] = "Northwind Mine Wayshrine",
	[26] = "Geirmund's Hall Wayshrine",
	[27] = "Taarengrav Wayshrine",
	[28] = "Nimalten Wayshrine",
	[29] = "Ragged Hills Wayshrine",
	[30] = "Fullhelm Fort Wayshrine",
	[31] = "Lion's Den",
	[32] = "Broken Helm Hollow",
	[33] = "Fort Greenwall",
	[34] = "Faldar's Tooth",
	[35] = "Avanchnzel",
	[36] = "Snapleg Cave",
	[37] = "Shroud Hearth Barrow",
	[38] = "Ivarstead",
	[39] = "Ragged Hills Dolmen",
	[40] = "Stony Basin Dolmen",
	[41] = "Smokefrost Peaks Dolmen",
	[42] = "Dungeon: Blessed Crucible",
	[43] = "The Apprentice",
	[44] = "Hunter Camp",
	[45] = "Troll Cave",
	[46] = "Frozen Ruins",
	[47] = "Abandoned Camp",
	[48] = "Giant Camp",
	[49] = "Wisplight Glen",
	[50] = "Linele Skullcarver's Camp",
	[51] = "Three Tribes Camp",
	[52] = "Autumnshade Clearing",
	[53] = "Smokefrost Vigil",
	[54] = "Mammoth Ridge",
	[55] = "Honeystrand Hill",
	[56] = "Grethel's Vigil",
	[57] = "Eldbjorg's Hideaway",
	[58] = "Jenedusil's Claw",
	[59] = "Trollslayer's Gully",
	[60] = "Frostmoon Farmstead",
}

local ZoneToAchievements = {}
ZoneToAchievements[872] = { -- M'aiq zone conversion
	[295] = 1,
	[179] = 2,
	[181] = 3,
	[19] = 4,
	[12] = 5,
	[180] = 6,
	[111] = 7,
	[9] = 8,
	[11] = 9,
	[20] = 10,
	[16] = 11,
	[17] = 12,
	[294] = 13,
	[2] = 14,
	[4] = 15,
	[5] = 16,
	[18] = 17,
	[15] = 18,
	[155] = 19,
}
ZoneToAchievements[767167] = { -- Crime Pays/Lightbringer/Give to the poor zone conversion
	[179] = 1,
	[181] = 2,
	[19] = 3,
	[12] = 4,
	[180] = 5,
	[9] = 6,
	[11] = 7,
	[20] = 8,
	[16] = 9,
	[17] = 10,
	[2] = 11,
	[4] = 12,
	[5] = 13,
	[18] = 14,
	[15] = 15,
}
ZoneToAchievements[704] = { -- This One's on Me zone conversion
	[2] = 1,
	[9] = 2,
	[179] = 3,
	[4] = 4,
	[11] = 5,
	[181] = 6,
	[5] = 7,
	[20] = 8,
	[19] = 9,
	[18] = 10,
	[16] = 11,
	[12] = 12,
	[15] = 13,
	[17] = 14,
	[180] = 15,
	[155] = 16,
}

local achTypes = {
	[1] = GetString(POITYPE_MAIQ),
	[2] = GetString(POITYPE_LB_GTTP_CP),
	[3] = GetString(POITYPE_PEACEMAKER),
	[4] = GetString(POITYPE_CRIME_PAYS),
	[5] = GetString(POITYPE_GIVE_TO_THE_POOR),
	[6] = GetString(POITYPE_LIGHTBRINGER),
	[7] = GetString(POITYPE_NOSEDIVER),
	[8] = GetString(POITYPE_EARTHLY_POS),
	[9] = GetString(POITYPE_ON_ME),
	[20] = GetString(POITYPE_AYLEID_WELL),
	[21] = GetString(POITYPE_WWVAMP),
	[22] = GetString(POITYPE_VAMPIRE_ALTAR),
	[23] = GetString(POITYPE_DWEMER_RUIN),
	[24] = GetString(POITYPE_WEREWOLF_SHRINE),
	[30] = GetString(POITYPE_TROPHY),
	[31] = GetString(POITYPE_FISH),
	[50] = GetString(POITYPE_UNDETERMINED),
	[55] = GetString(POITYPE_UNKNOWN),
}

local function GetAchTypeName(TYPE)
	return achTypes[TYPE] or achTypes[55]
end

----------------- GET MAP NAME -----------------
local function GetMapTextureName()
	local tileTexture = GetMapTileTexture()
	local stringEnd = string.sub(tileTexture,-6)
	local number = ""
	local nameNoNum = ""
	local path = ""
	local counter = 1
	for word in string.gmatch(tileTexture, "[%w_%-]+") do 
		if counter == 1 then path = "/" .. word end
		if counter == 2 then path = tostring(path .. "/" .. word) end
		if counter == 3 then path = tostring(path .. "/" .. word) end
		if counter == 4 then mapTextureName = word end 
		counter = counter + 1
	end
	if string.gmatch(stringEnd, "%d+") ~= nil then
		for mapNum in string.gmatch(stringEnd, "%d+") do
			number = mapNum
		end
	end
	if number == nil then
		number = ""
	else
		rNumber = tonumber(number)
	end
	if number == "" then
		nameNoNum = tostring(mapTextureName)
	elseif rNumber < 10 then
		local onedigit = string.sub(mapTextureName, 1,-2)
		nameNoNum = onedigit
	elseif rNumber > 9 then
		local twodigit = string.sub(mapTextureName, 1,-3)
		nameNoNum = twodigit
	end
	return mapTextureName
end
------------------- MAP PINS -------------------
------------------Achievements------------------
local function OtherpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_LB_GTTP_CP) or not DestinationsCSSV.filters[PINS_LB_GTTP_CP] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 2 then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[767167][zoneIndex]
			local desca, completedLB, requiredLB = GetAchievementCriterion(873, COMP)
			local descb, completedGTTP, requiredGTTP = GetAchievementCriterion(871, COMP)
			local descc, completedCP, requiredCP = GetAchievementCriterion(869, COMP)
			local completed = completedLB + completedGTTP + completedCP
			local required = requiredLB + requiredGTTP + requiredCP
			local tooltipText = {}
			if completed ~= required then
				local pinTextLine = 0
				if completedLB ~= requiredLB then
					pinTextLine = pinTextLine + 1
					table.insert(tooltipText, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOther.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[873])))
				elseif completedLB == requiredLB and DestinationsSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then
					pinTextLine = pinTextLine + 1
					table.insert(tooltipText, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOtherDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[873])))
				end
				if completedGTTP ~= requiredGTTP then
					pinTextLine = pinTextLine + 1
					table.insert(tooltipText, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOther.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[871])))
				elseif completedGTTP == requiredGTTP and DestinationsSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then
					pinTextLine = pinTextLine + 1
					table.insert(tooltipText, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOtherDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[871])))
				end
				if completedCP ~= requiredCP then
					pinTextLine = pinTextLine + 1
					table.insert(tooltipText, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOther.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[869])))
				elseif completedCP == requiredCP and DestinationsSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then
					pinTextLine = pinTextLine + 1
					table.insert(tooltipText, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOtherDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[869])))
				end
				LMP:CreatePin(PINS_LB_GTTP_CP, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
local function OtherpinTypeCallbackDone(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) or not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then return end
	if not LMP:IsEnabled(PINS_LB_GTTP_CP_DONE) or not DestinationsCSSV.filters[PINS_LB_GTTP_CP_DONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 2 then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[767167][zoneIndex]
			local desca, completedLB, requiredLB = GetAchievementCriterion(873, COMP)
			local descb, completedGTTP, requiredGTTP = GetAchievementCriterion(871, COMP)
			local descc, completedCP, requiredCP = GetAchievementCriterion(869, COMP)
			local completed = completedLB + completedGTTP + completedCP
			local required = requiredLB + requiredGTTP + requiredCP
			local tooltipText = {}
			if completed == required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOtherDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[873])))
				table.insert(tooltipText, 2, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOtherDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[871])))
				table.insert(tooltipText, 3, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOtherDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[869])))
				LMP:CreatePin(PINS_LB_GTTP_CP_DONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
------------------Achievements------------------
local function MaiqpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_MAIQ) or not DestinationsCSSV.filters[PINS_MAIQ] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 1 then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[872][zoneIndex]
			local desc, completed, required = GetAchievementCriterion(872, COMP)
			local tooltipText = {}
			if completed ~= required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureMaiq.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[872])))
				LMP:CreatePin(PINS_MAIQ, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
local function MaiqpinTypeCallbackDone(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) or not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then return end
	if not LMP:IsEnabled(PINS_MAIQ_DONE) or not DestinationsCSSV.filters[PINS_MAIQ_DONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 1 then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[872][zoneIndex]
			local desc, completed, required = GetAchievementCriterion(872, COMP)
			local tooltipText = {}
			if completed == required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureMaiqDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[872])))
				LMP:CreatePin(PINS_MAIQ_DONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
------------------Achievements------------------
local function PeacemakerpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_PEACEMAKER) or not DestinationsCSSV.filters[PINS_PEACEMAKER] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 3 then
			local desc, completed, required = GetAchievementCriterion(716)
			local tooltipText = {}
			if completed ~= required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTexturePeacemaker.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[716])))
				LMP:CreatePin(PINS_PEACEMAKER, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
local function PeacemakerpinTypeCallbackDone(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) or not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then return end
	if not LMP:IsEnabled(PINS_PEACEMAKER_DONE) or not DestinationsCSSV.filters[PINS_PEACEMAKER_DONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 3 then
			local desc, completed, required = GetAchievementCriterion(716)
			local tooltipText = {}
			if completed == required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTexturePeacemakerDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[716])))
				LMP:CreatePin(PINS_PEACEMAKER_DONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
------------------Achievements------------------
local function NosediverpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_NOSEDIVER) or not DestinationsCSSV.filters[PINS_NOSEDIVER] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 7 then
			local desc, completed, required = GetAchievementCriterion(406)
			local tooltipText = {}
			if completed ~= required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureNosediver.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[406])))
				LMP:CreatePin(PINS_NOSEDIVER, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
local function NosediverpinTypeCallbackDone(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) or not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then return end
	if not LMP:IsEnabled(PINS_NOSEDIVER_DONE) or not DestinationsCSSV.filters[PINS_NOSEDIVER_DONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 7 then
			local desc, completed, required = GetAchievementCriterion(406)
			local tooltipText = {}
			if completed == required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureNosediverDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[406])))
				LMP:CreatePin(PINS_NOSEDIVER_DONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
------------------Achievements------------------
local function EarthlyPospinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_EARTHLYPOS) or not DestinationsCSSV.filters[PINS_EARTHLYPOS] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 8 then
			local desc, completed, required = GetAchievementCriterion(1121)
			local tooltipText = {}
			if completed ~= required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureEarthlyPos.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[1121])))
				LMP:CreatePin(PINS_EARTHLYPOS, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
local function EarthlyPospinTypeCallbackDone(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) or not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then return end
	if not LMP:IsEnabled(PINS_EARTHLYPOS_DONE) or not DestinationsCSSV.filters[PINS_EARTHLYPOS_DONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 8 then
			local desc, completed, required = GetAchievementCriterion(1121)
			local tooltipText = {}
			if completed == required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureEarthlyPosDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[1121])))
				LMP:CreatePin(PINS_EARTHLYPOS_DONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
------------------Achievements------------------
local function OnMepinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_ON_ME) or not DestinationsCSSV.filters[PINS_ON_ME] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 9 then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[704][zoneIndex]
			local desc, completed, required = GetAchievementCriterion(704, COMP)
			local tooltipText = {}
			if completed ~= required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOnMe.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[704])))
				LMP:CreatePin(PINS_ON_ME, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
local function OnMepinTypeCallbackDone(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) or not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] then return end
	if not LMP:IsEnabled(PINS_ON_ME_DONE) or not DestinationsCSSV.filters[PINS_ON_ME_DONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 9 then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[704][zoneIndex]
			local desc, completed, required = GetAchievementCriterion(704, COMP)
			local tooltipText = {}
			if completed == required then
				table.insert(tooltipText, 1, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOnMeDone.textcolor)):Colorize(zo_strformat("<<1>>", ACHids[704])))
				LMP:CreatePin(PINS_ON_ME_DONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end

--------------------Misc POI--------------------
local function AyleidpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_AYLEID) or not DestinationsCSSV.filters[PINS_AYLEID] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		local OtherTypeName = GetAchTypeName(TYPE)
		if TYPE == 20 then
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureAyleid.textcolor)):Colorize(zo_strformat("<<1>>", OtherTypeName))}
			LMP:CreatePin(PINS_AYLEID, pinTag, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		end
	end
end
--------------------Misc POI--------------------
local function DwemerRuinpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_DWEMER) or not DestinationsCSSV.filters[PINS_DWEMER] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		local OtherTypeName = GetAchTypeName(TYPE)
		if TYPE == 23 then
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureDwemer.textcolor)):Colorize(zo_strformat("<<1>>", OtherTypeName))}
			LMP:CreatePin(PINS_DWEMER, pinTag, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		end
	end
end
--------------------Misc POI--------------------
local function ChampionpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_CHAMPION) or not DestinationsCSSV.filters[PINS_CHAMPION] then return end
	GetMapTextureName()
	local data = ChampionTableStore[mapTextureName]
	if not data then return end
	local CHAMPNAME = nil
	for _, pinData in ipairs(data) do
		if localLanguage == "de" then
			CHAMPNAME = pinData[ChampionTableIndex.CHAMPNAME_DE]
		elseif localLanguage == "fr" then
			CHAMPNAME = pinData[ChampionTableIndex.CHAMPNAME_FR]
		else
			CHAMPNAME = pinData[ChampionTableIndex.CHAMPNAME_EN]
		end
		pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureChampion.textcolor)):Colorize(zo_strformat("<<1>>", CHAMPNAME))}
		LMP:CreatePin(PINS_CHAMPION, pinTag, pinData[ChampionTableIndex.X], pinData[ChampionTableIndex.Y])
	end
end
--------------------Misc POI--------------------
local function WWVamppinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_WWVAMP) or not DestinationsCSSV.filters[PINS_WWVAMP] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		local OtherTypeName = GetAchTypeName(TYPE)
		if TYPE == 21 then
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureAyleid.textcolor)):Colorize(zo_strformat("<<1>>", OtherTypeName))}
			LMP:CreatePin(PINS_WWVAMP, pinTag, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		end
	end
end
--------------------Misc POI--------------------
local function VampireAltarpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_VAMPIRE_ALTAR) or not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		local OtherTypeName = GetAchTypeName(TYPE)
		if TYPE == 22 then
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureAyleid.textcolor)):Colorize(zo_strformat("<<1>>", OtherTypeName))}
			LMP:CreatePin(PINS_VAMPIRE_ALTAR, pinTag, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		end
	end
end
--------------------Misc POI--------------------
local function WerewolfShrinepinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_WEREWOLF_SHRINE) or not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		local OtherTypeName = GetAchTypeName(TYPE)
		if TYPE == 24 then
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureAyleid.textcolor)):Colorize(zo_strformat("<<1>>", OtherTypeName))}
			LMP:CreatePin(PINS_WEREWOLF_SHRINE, pinTag, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		end
	end
end
-----------------Craglorn Border----------------
local function BorderpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_BORDER) or not DestinationsCSSV.filters[PINS_BORDER] then return end
	GetMapTextureName()
	local data = BorderDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		LMP:CreatePin(PINS_BORDER, {""}, pinData[BorderDataIndex.X], pinData[BorderDataIndex.Y])
	end
end

--------------------Trophies--------------------
local function CollectiblepinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_COLLECTIBLES) or not DestinationsCSSV.filters[PINS_COLLECTIBLES] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 30 then
			local collectibleID = pinData[ACHDataIndex.ID]
			local collectibleCode = pinData[ACHDataIndex.KEYCODE]
			local completedTotal, requiredTotal = 0, GetAchievementNumCriteria(collectibleID)
			local desc, completed, required = nil, 0, 0
			for i = 1, requiredTotal, 1 do
				desc, completed, required = GetAchievementCriterion(collectibleID, i)
				if completed == 1 then
					completedTotal = completedTotal + 1
				end
			end
			local tooltipText = {}
			local textLine = 0
			local countCN, countCND = 0, 0
			if completedTotal ~= requiredTotal then
				textLine = textLine + 1
				table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectible.textcolortitle)):Colorize(zo_strformat("<<1>>", CollectibleIDs[collectibleID])))
				local collectibleName, collectibleNumber, collectibleItem = nil, nil, nil, nil
				local collectibledata = CollectibleDataStore[collectibleID]
				local ColName, ColNumber, ColKey = nil, nil, nil
				local collectibleMobNumber = nil
				for i = 1, requiredTotal, 1 do
					for _, pinData in ipairs(collectibledata) do
						collectibleNumber = pinData[CollectibleDataIndex.NUMBER]
						if i == 10 then
							collectibleMobNumber = "A"
						elseif i == 11 then
							collectibleMobNumber = "B"
						elseif i == 12 then
							collectibleMobNumber = "C"
						else
							collectibleMobNumber = tostring(i)
						end
						if collectibleNumber == i and string.find(collectibleCode, collectibleMobNumber) then
							_, completed, _ = GetAchievementCriterion(collectibleID, i)
							if completed == 0 then
								countCN = countCN + 1
							elseif LMP:IsEnabled(PINS_COLLECTIBLESDONE) then
								countCND = countCND + 1
							end
						end
					end
				end
				if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_MOBNAME] or DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_ITEM] then
					for i = 1, requiredTotal, 1 do
						for _, pinData in ipairs(collectibledata) do
							collectibleNumber = pinData[CollectibleDataIndex.NUMBER]
							if localLanguage == "de" then
								collectibleName = pinData[CollectibleDataIndex.NAME_de]
							else
								collectibleName = pinData[CollectibleDataIndex.NAME_en]
							end
							if i == 10 then
								collectibleMobNumber = "A"
							elseif i == 11 then
								collectibleMobNumber = "B"
							elseif i == 12 then
								collectibleMobNumber = "C"
							else
								collectibleMobNumber = tostring(i)
							end
							if collectibleNumber == i and string.find(collectibleCode, collectibleMobNumber) then
								collectibleItem, completed, _ = GetAchievementCriterion(collectibleID, i)
								if completed == 0 then
									if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_MOBNAME] then
										textLine = textLine + 1
										table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectible.textcolor)):Colorize(zo_strformat("<<1>>", "["..collectibleName.."]")))
									end
									if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_ITEM] then
										textLine = textLine + 1
										table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectible.textcolor)):Colorize(zo_strformat("<<1>>", "<"..collectibleItem..">")))
									end
								elseif LMP:IsEnabled(PINS_COLLECTIBLESDONE) then
									if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_MOBNAME] then
										textLine = textLine + 1
										table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectible.textcolor)):Colorize(zo_strformat("<<1>>", "["..collectibleName.."]")))
									end
									if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_ITEM] then
										textLine = textLine + 1
										table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectible.textcolor)):Colorize(zo_strformat("<<1>>", "<"..collectibleItem..">")))
									end
								end
							end
						end
					end
				end
				if countCN >= 1 and countCND == 0 then
					LMP:CreatePin(PINS_COLLECTIBLES, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
				end
			end
		end
	end
end
local function CollectibleDonepinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_COLLECTIBLESDONE) or not DestinationsCSSV.filters[PINS_COLLECTIBLESDONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 30 then
			local collectibleID = pinData[ACHDataIndex.ID]
			local collectibleCode = pinData[ACHDataIndex.KEYCODE]
			local completedTotal, requiredTotal = 0, GetAchievementNumCriteria(collectibleID)
			local desc, completed, required = nil, 0, 0
			for i = 1, requiredTotal, 1 do
				desc, completed, required = GetAchievementCriterion(collectibleID, i)
				if completed == 1 then
					completedTotal = completedTotal + 1
				end
			end
			local tooltipText = {}
			local textLine = 0
			local countCN = 0
			textLine = textLine + 1
			table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectible.textcolortitle)):Colorize(zo_strformat("<<1>>", CollectibleIDs[collectibleID])))
			local collectibleName, collectibleNumber, collectibleItem = nil, nil, nil
			local collectibledata = CollectibleDataStore[collectibleID]
			for i = 1, requiredTotal, 1 do
				for _, pinData in ipairs(collectibledata) do
					collectibleNumber = pinData[CollectibleDataIndex.NUMBER]
					if collectibleNumber == i and string.find(collectibleCode, i) then
						_, completed, _ = GetAchievementCriterion(collectibleID, i)
						if completed == 1 then
							countCN = countCN + 1
						end
					end
				end
			end
			if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_MOBNAME] or DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_ITEM] then
					for i = 1, requiredTotal, 1 do
						for _, pinData in ipairs(collectibledata) do
							collectibleNumber = pinData[CollectibleDataIndex.NUMBER]
							if localLanguage == "de" then
								collectibleName = pinData[CollectibleDataIndex.NAME_de]
							else
								collectibleName = pinData[CollectibleDataIndex.NAME_en]
							end
							if collectibleNumber == i and string.find(collectibleCode, i) then
								collectibleItem, completed, _ = GetAchievementCriterion(collectibleID, i)
								if completed == 1 then
									if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_MOBNAME] then
										textLine = textLine + 1
										table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectibleDone.textcolor)):Colorize(zo_strformat("<<1>>", "["..collectibleName.."]")))
									end
									if DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_ITEM] then
										textLine = textLine + 1
										table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectibleDone.textcolor)):Colorize(zo_strformat("<<1>>", "<"..collectibleItem..">")))
									end
								end
							end
						end
					end
				end
			if countCN >= 1 then
				LMP:CreatePin(PINS_COLLECTIBLESDONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end
--------------------Fishing---------------------
local function FishpinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_FISHING) or not DestinationsCSSV.filters[PINS_FISHING] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE >= 40 and TYPE <= 44 then
			local fishID = pinData[ACHDataIndex.ID]
			local completedTotal, requiredTotal = 0, GetAchievementNumCriteria(fishID)
			local desc, completed, required = nil, 0, 0
			for i = 1, requiredTotal, 1 do
				desc, completed, required = GetAchievementCriterion(fishID, i)
				if completed == 1 then
					completedTotal = completedTotal + 1
				end
			end
			if completedTotal == requiredTotal then return end
			local fishingBait, waterType = nil
			if TYPE == 40 then
				fishingBait = GetString(FISHING_FOUL_BAIT)
				waterType = GetString(FISHING_FOUL)
			elseif TYPE == 41 then
				fishingBait = GetString(FISHING_RIVER_BAIT)
				waterType = GetString(FISHING_RIVER)
			elseif TYPE == 42 then
				fishingBait = GetString(FISHING_OCEAN_BAIT)
				waterType = GetString(FISHING_OCEAN)
			elseif TYPE == 43 then
				fishingBait = GetString(FISHING_LAKE_BAIT)
				waterType = GetString(FISHING_LAKE)
			elseif TYPE == 44 then
				waterType = GetString(FISHING_UNKNOWN)
			end
			local tooltipText = {}
			local textLine = 0
			local countF, countL, countO, countR = 0, 0, 0, 0
			local countFN, countLN, countON, countRN = 0, 0, 0, 0
			local fishdata = FishLocationsStore[fishID]
			local FishName, FishNumber, FishLoc = nil, nil, nil
			for _, pinData in ipairs(fishdata) do
				FishLoc = pinData[FishLocationsIndex.LOCATION]
				if FishLoc == "F" then
					countF = countF + 1
				elseif FishLoc == "L" then
					countL = countL + 1
				elseif FishLoc == "O" then
					countO = countO + 1
				elseif FishLoc == "R" then
					countR = countR + 1
				end
			end
			for i = 1, requiredTotal, 1 do
				for _, pinData in ipairs(fishdata) do
					FishLoc = pinData[FishLocationsIndex.LOCATION]
					FishNumber = pinData[FishLocationsIndex.FISHNUMBER]
					if FishNumber == i then
						if TYPE == 40 and FishLoc == "F" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countFN = countFN + 1
							end
						elseif TYPE == 41 and FishLoc == "R" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countRN = countRN + 1
							end
						elseif TYPE == 42 and FishLoc == "O" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countON = countON + 1
							end
						elseif TYPE == 43 and FishLoc == "L" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countLN = countLN + 1
							end
						end
					end
				end
			end
			textLine = textLine + 1
			table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFish.textcolortitle)):Colorize(zo_strformat("<<1>>", FISHids[fishID])))
			if DestinationsSV.filters[PINS_FISHING_SHOW_FISHNAME] then
				for i = 1, requiredTotal, 1 do
					for _, pinData in ipairs(fishdata) do
						local fishFound = false
						local fishMiss = false
						FishLoc = pinData[FishLocationsIndex.LOCATION]
						FishNumber = pinData[FishLocationsIndex.FISHNUMBER]
						FishName, completed, _ = GetAchievementCriterion(fishID, i)
						if FishNumber == i then
							if TYPE == 40 and FishLoc == "F" then
								if completed == 0 then
									fishMiss = true
								elseif LMP:IsEnabled(PINS_FISHINGDONE) then
									fishFound = true
								end
							elseif TYPE == 41 and FishLoc == "R" then
								if completed == 0 then
									fishMiss = true
								elseif LMP:IsEnabled(PINS_FISHINGDONE) then
									fishFound = true
								end
							elseif TYPE == 42 and FishLoc == "O" then
								if completed == 0 then
									fishMiss = true
								elseif LMP:IsEnabled(PINS_FISHINGDONE) then
									fishFound = true
								end
							elseif TYPE == 43 and FishLoc == "L" then
								if completed == 0 then
									fishMiss = true
								elseif LMP:IsEnabled(PINS_FISHINGDONE) then
									fishFound = true
								end
							end
						end
						if fishMiss then
							textLine = textLine + 1
							table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFish.textcolor)):Colorize(zo_strformat("<<1>>", "["..FishName.."]")))
							fishMiss = false
						elseif fishFound then
							textLine = textLine + 1
							table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFishDone.textcolor)):Colorize(zo_strformat("<<1>>", "["..FishName.."]")))
							fishFound = false
						end
						if TYPE == 44 and FishNumber == i then
							if completed == 0 then
								textLine = textLine + 1
								table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFish.textcolor)):Colorize(zo_strformat("<<1>>", "["..FishName.."]")))
							else
								textLine = textLine + 1
								table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFishDone.textcolor)):Colorize(zo_strformat("<<1>>", "["..FishName.."]")))
							end
						end
					end
				end
			end
			if fishingBait and DestinationsSV.filters[PINS_FISHING_SHOW_BAIT] then
				textLine = textLine + 1
				table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFish.textcolorBait)):Colorize(zo_strformat("<<1>>", "<"..fishingBait..">")))
			end
			if waterType and DestinationsSV.filters[PINS_FISHING_SHOW_WATER] then
				textLine = textLine + 1
				table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFish.textcolorWater)):Colorize(zo_strformat("<<1>>", "("..waterType..")")))
			end
			if countFN >= 1 or countLN >= 1 or countON >= 1 or countRN >= 1 then
				if countF >= 1 or countL >= 1 or countO >= 1 or countR >= 1 then
					LMP:CreatePin(PINS_FISHING, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
				end
			end
		end
	end
end
local function FishDonepinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_FISHINGDONE) or not DestinationsCSSV.filters[PINS_FISHINGDONE] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE >= 40 and TYPE <= 44 then
			local fishID = pinData[ACHDataIndex.ID]
			local completedTotal, requiredTotal = 0, GetAchievementNumCriteria(fishID)
			local desc, completed, required = nil, 0, 0
			for i = 1, requiredTotal, 1 do
				desc, completed, required = GetAchievementCriterion(fishID, i)
				if completed == 1 then
					completedTotal = completedTotal + 1
				end
			end
			local fishingBait, waterType = nil
			if TYPE == 40 then
				fishingBait = GetString(FISHING_FOUL_BAIT)
				waterType = GetString(FISHING_FOUL)
			elseif TYPE == 41 then
				fishingBait = GetString(FISHING_RIVER_BAIT)
				waterType = GetString(FISHING_RIVER)
			elseif TYPE == 42 then
				fishingBait = GetString(FISHING_OCEAN_BAIT)
				waterType = GetString(FISHING_OCEAN)
			elseif TYPE == 43 then
				fishingBait = GetString(FISHING_LAKE_BAIT)
				waterType = GetString(FISHING_LAKE)
			elseif TYPE == 44 then
				waterType = GetString(FISHING_UNKNOWN)
			end
			local tooltipText = {}
			local textLine = 0
			local countF, countL, countO, countR = 0, 0, 0, 0
			local countFN, countLN, countON, countRN = 0, 0, 0, 0
			local fishdata = FishLocationsStore[fishID]
			for _, pinData in ipairs(fishdata) do
				FishLoc = pinData[FishLocationsIndex.LOCATION]
				if FishLoc == "F" then
					countF = countF + 1
				elseif FishLoc == "L" then
					countL = countL + 1
				elseif FishLoc == "O" then
					countO = countO + 1
				elseif FishLoc == "R" then
					countR = countR + 1
				end
			end
			if countF >= 1 or countL >= 1 or countO >= 1 or countR >= 1 then
				textLine = textLine + 1
				table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFish.textcolortitle)):Colorize(zo_strformat("<<1>>", FISHids[fishID])))
				local FishNumber, FishLoc = nil, nil
				for i = 1, requiredTotal, 1 do
					for _, pinData in ipairs(fishdata) do
						FishLoc = pinData[FishLocationsIndex.LOCATION]
						FishNumber = pinData[FishLocationsIndex.FISHNUMBER]
						if FishNumber == i then
							_, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 1 then
								if TYPE == 40 and FishLoc == "F" then
									countFN = countFN + 1
								elseif TYPE == 41 and FishLoc == "R" then
									countRN = countRN + 1
								elseif TYPE == 42 and FishLoc == "O" then
									countON = countON + 1
								elseif TYPE == 43 and FishLoc == "L" then
									countLN = countLN + 1
								end
							end
						end
					end
				end
				if DestinationsSV.filters[PINS_FISHING_SHOW_FISHNAME] then
					local FishName, FishNumber, FishLoc = nil, nil, nil
					for i = 1, requiredTotal, 1 do
						for _, pinData in ipairs(fishdata) do
							FishLoc = pinData[FishLocationsIndex.LOCATION]
							FishNumber = pinData[FishLocationsIndex.FISHNUMBER]
							if FishNumber == i then
								FishName, completed, _ = GetAchievementCriterion(fishID, i)
								if completed == 1 then
									local fishFound = false
									if TYPE == 40 and FishLoc == "F" then
										fishFound = true
									elseif TYPE == 41 and FishLoc == "R" then
										fishFound = true
									elseif TYPE == 42 and FishLoc == "O" then
										fishFound = true
									elseif TYPE == 43 and FishLoc == "L" then
										fishFound = true
									end
									if fishFound then
										textLine = textLine + 1
										table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFishDone.textcolor)):Colorize(zo_strformat("<<1>>", "["..FishName.."]")))
										fishFound = false
									end
								end
							end
						end
					end
				end
				if fishingBait and DestinationsSV.filters[PINS_FISHING_SHOW_BAIT] then
					textLine = textLine + 1
					table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFishDone.textcolorBait)):Colorize(zo_strformat("<<1>>", "<"..fishingBait..">")))
				end
				if waterType and DestinationsSV.filters[PINS_FISHING_SHOW_WATER] then
					textLine = textLine + 1
					table.insert(tooltipText, textLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFishDone.textcolorWater)):Colorize(zo_strformat("<<1>>", "("..waterType..")")))
				end
				if (countF >= 1 and countF == countFN) or (countL >= 1 and countL == countLN) or (countO >= 1 and countO == countON) or (countR >= 1 and countR == countRN) then
					LMP:CreatePin(PINS_FISHINGDONE, tooltipText, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
				end
			end
		end
	end
end

------------------Quest Givers------------------
local function Quests_Undone_pinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_QUESTS_UNDONE) or not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] then return end
	GetMapTextureName()
	local data = QuestDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local QuestID = pinData[QuestDataIndex.QUESTID]
		if not QuestID then return end
		local dataName = GetCompletedQuestInfo(QuestID)
		local Name = pinData[QuestDataIndex.NAME]
		if dataName ~= Name and DestinationsCSSV.QuestsDone[QuestID] ~= 2 and DestinationsCSSV.QuestsDone[QuestID] ~= 1 and DestinationsCSSV.QuestsDone[QuestID] ~= 5 then
			local NPC = pinData[QuestDataIndex.NPC]
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsUndone.textcolor)):Colorize(zo_strformat("<<1>>", Name))}
			table.insert(pinTag, 2, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsUndone.textcolor)):Colorize(zo_strformat("<<1>>", "["..NPC.."]")))
			local Rep = pinData[QuestDataIndex.REPEAT]
			local Type = pinData[QuestDataIndex.TYPE]
			if Type then
				local QType = nil
				local Repeatable = nil
				if Type == 2 then
					QType = GetString(QUESTTYPE_MAIN_STORY)
				elseif Type == 5 then
					QType = GetString(QUESTTYPE_DUNGEON)
				end
				if Rep then
					if Rep == 1 then
						Repeatable = GetString(QUESTREPEAT_REPEATABLE)
					elseif Rep == 2 then
						Repeatable = GetString(QUESTREPEAT_DAILY)
					end
				end
				if QType then
					table.insert(pinTag, 3, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsUndone.textcolor)):Colorize(zo_strformat("<<1>>", "{"..QType.."}")))
					if Repeatable then
						table.insert(pinTag, 4, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsUndone.textcolor)):Colorize(zo_strformat("<<1>>", "<"..Repeatable..">")))
					end
				else
					if Repeatable then
						table.insert(pinTag, 3, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsUndone.textcolor)):Colorize(zo_strformat("<<1>>", "<"..Repeatable..">")))
					end
				end
			end
			pinTag.IsAvailableQuest = true
			LMP:CreatePin(PINS_QUESTS_UNDONE, pinTag, pinData[QuestDataIndex.X], pinData[QuestDataIndex.Y])
		end
	end
end
local function Quests_In_Progress_pinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_QUESTS_IN_PROGRESS) or not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] then return end
	GetMapTextureName()
	local data = QuestDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local QuestID = pinData[QuestDataIndex.QUESTID]
		if not QuestID then return end
		if DestinationsCSSV.QuestsDone[QuestID] and DestinationsCSSV.QuestsDone[QuestID] == 2 then
			local Name = pinData[QuestDataIndex.NAME]
			local NPC = pinData[QuestDataIndex.NPC]
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.textcolor)):Colorize(zo_strformat("<<1>>", Name))}
			table.insert(pinTag, 2, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.textcolor)):Colorize(zo_strformat("<<1>>", "["..NPC.."]")))
			local Rep = pinData[QuestDataIndex.REPEAT]
			local Type = pinData[QuestDataIndex.TYPE]
			if Type then
				local QType = nil
				local Repeatable = nil
				if Type == 2 then
					QType = GetString(QUESTTYPE_MAIN_STORY)
				elseif Type == 5 then
					QType = GetString(QUESTTYPE_DUNGEON)
				end
				if Rep then
					if Rep == 1 then
						Repeatable = GetString(QUESTREPEAT_REPEATABLE)
					elseif Rep == 2 then
						Repeatable = GetString(QUESTREPEAT_DAILY)
					end
				end
				if QType then
					table.insert(pinTag, 3, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.textcolor)):Colorize(zo_strformat("<<1>>", "{"..QType.."}")))
					if Repeatable then
						table.insert(pinTag, 4, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.textcolor)):Colorize(zo_strformat("<<1>>", "<"..Repeatable..">")))
					end
				else
					if Repeatable then
						table.insert(pinTag, 3, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.textcolor)):Colorize(zo_strformat("<<1>>", "<"..Repeatable..">")))
					end
				end
			end
			pinTag.InProgressQuest = true
			LMP:CreatePin(PINS_QUESTS_IN_PROGRESS, pinTag, pinData[QuestDataIndex.X], pinData[QuestDataIndex.Y])
		end
	end
end
local function Quests_Done_pinTypeCallback(pinManager)
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not LMP:IsEnabled(PINS_QUESTS_DONE) or not DestinationsCSSV.filters[PINS_QUESTS_DONE] then return end
	GetMapTextureName()
	local data = QuestDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local QuestID = pinData[QuestDataIndex.QUESTID]
		if not QuestID then return end
		local dataName = GetCompletedQuestInfo(QuestID)
		local Name = pinData[QuestDataIndex.NAME]
		if (dataName == Name and DestinationsCSSV.QuestsDone[QuestID] ~= 5) or DestinationsCSSV.QuestsDone[QuestID] == 1 then
			local NPC = pinData[QuestDataIndex.NPC]
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsDone.textcolor)):Colorize(zo_strformat("<<1>>", Name))}
			table.insert(pinTag, 2, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsDone.textcolor)):Colorize(zo_strformat("<<1>>", "["..NPC.."]")))
			local Rep = pinData[QuestDataIndex.REPEAT]
			local Type = pinData[QuestDataIndex.TYPE]
			if Type then
				local QType = nil
				local Repeatable = nil
				if Type == 2 then
					QType = GetString(QUESTTYPE_MAIN_STORY)
				elseif Type == 5 then
					QType = GetString(QUESTTYPE_DUNGEON)
				end
				if Rep then
					if Rep == 1 then
						Repeatable = GetString(QUESTREPEAT_REPEATABLE)
					elseif Rep == 2 then
						Repeatable = GetString(QUESTREPEAT_DAILY)
					end
				end
				if QType then
					table.insert(pinTag, 3, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsDone.textcolor)):Colorize(zo_strformat("<<1>>", "{"..QType.."}")))
					if Repeatable then
						table.insert(pinTag, 4, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsDone.textcolor)):Colorize(zo_strformat("<<1>>", "<"..Repeatable..">")))
					end
				else
					if Repeatable then
						table.insert(pinTag, 3,ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsDone.textcolor)):Colorize(zo_strformat("<<1>>", "<"..Repeatable..">")))
					end
				end
			end
			LMP:CreatePin(PINS_QUESTS_DONE, pinTag, pinData[QuestDataIndex.X], pinData[QuestDataIndex.Y])
		end
	end
end

------------------- COMPASS PINS -------------------
local function AddAchievementCompassPins()
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not DestinationsCSSV.filters[PINS_ACHIEVEMENTS_COMPASS] then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 1 and LMP:IsEnabled(PINS_MAIQ) then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[872][zoneIndex]
			local desc, completed, required = GetAchievementCriterion(872, COMP)
			if completed ~= required then
				COMPASS_PINS.pinManager:CreatePin(PINS_MAIQ, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_MAIQ_DONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		elseif TYPE == 2 and LMP:IsEnabled(PINS_LB_GTTP_CP) then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[767167][zoneIndex]
			local desca, completedLB, requiredLB = GetAchievementCriterion(873, COMP)
			local descb, completedGTTP, requiredGTTP = GetAchievementCriterion(871, COMP)
			local descc, completedCP, requiredCP = GetAchievementCriterion(869, COMP)
			local completed = completedLB + completedGTTP + completedCP
			local required = requiredLB + requiredGTTP + requiredCP
			if completed ~= required then
				COMPASS_PINS.pinManager:CreatePin(PINS_LB_GTTP_CP, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_LB_GTTP_CP_DONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		elseif TYPE == 3 and LMP:IsEnabled(PINS_PEACEMAKER) then
			local desc, completed, required = GetAchievementCriterion(716, 1)
			if completed ~= required then
				COMPASS_PINS.pinManager:CreatePin(PINS_PEACEMAKER, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_PEACEMAKER_DONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		elseif TYPE == 7 and LMP:IsEnabled(PINS_NOSEDIVER) then
			local desc, completed, required = GetAchievementCriterion(406, 1)
			if completed ~= required then
				COMPASS_PINS.pinManager:CreatePin(PINS_NOSEDIVER, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_NOSEDIVER_DONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		elseif TYPE == 8 and LMP:IsEnabled(PINS_EARTHLYPOS) then
			local desc, completed, required = GetAchievementCriterion(1121, 1)
			if completed ~= required then
				COMPASS_PINS.pinManager:CreatePin(PINS_EARTHLYPOS, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_EARTHLYPOS_DONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		elseif TYPE == 9 and LMP:IsEnabled(PINS_ON_ME) then
			local zoneIndex = GetCurrentMapZoneIndex()
			local COMP = ZoneToAchievements[704][zoneIndex]
			local desc, completed, required = GetAchievementCriterion(704, COMP)
			if completed ~= required then
				COMPASS_PINS.pinManager:CreatePin(PINS_ON_ME, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_ON_ME_DONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end

local function AddMiscCompassPins() -- Ayleid, Werewolf+Shrine, Vampire+Altar, Dwemer, Champions
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then
		data = ChampionTableStore[mapTextureName]
	end
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE == 20 then
			if not LMP:IsEnabled(PINS_AYLEID) or not DestinationsCSSV.filters[PINS_MISC_COMPASS] then return end
			COMPASS_PINS.pinManager:CreatePin(PINS_AYLEID, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		elseif TYPE == 21 then
			if not LMP:IsEnabled(PINS_WWVAMP) or not DestinationsCSSV.filters[PINS_VWW_COMPASS] then return end
			COMPASS_PINS.pinManager:CreatePin(PINS_WWVAMP, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		elseif TYPE == 22 then
			if not LMP:IsEnabled(PINS_VAMPIRE_ALTAR) or not DestinationsCSSV.filters[PINS_VWW_COMPASS] then return end
			COMPASS_PINS.pinManager:CreatePin(PINS_VAMPIRE_ALTAR, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		elseif TYPE == 23 then
			if not LMP:IsEnabled(PINS_DWEMER) or not DestinationsCSSV.filters[PINS_MISC_COMPASS] then return end
			COMPASS_PINS.pinManager:CreatePin(PINS_DWEMER, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		elseif TYPE == 24 then
			if not LMP:IsEnabled(PINS_WEREWOLF_SHRINE) or not DestinationsCSSV.filters[PINS_VWW_COMPASS] then return end
			COMPASS_PINS.pinManager:CreatePin(PINS_WEREWOLF_SHRINE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
		end
	end
	if not LMP:IsEnabled(PINS_CHAMPION) or not DestinationsCSSV.filters[PINS_MISC_COMPASS] then return end
	data = nil
	data = ChampionTableStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		COMPASS_PINS.pinManager:CreatePin(PINS_CHAMPION, pinData, pinData[ChampionTableIndex.X], pinData[ChampionTableIndex.Y])
	end
end

local function Quests_CompassPins()
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	if not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] and not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] and not DestinationsCSSV.filters[PINS_QUESTS_DONE] then return end
	if not DestinationsSV.filters[PINS_QUESTS_COMPASS] then return end
	GetMapTextureName()
	local data = QuestDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local QuestID = pinData[QuestDataIndex.QUESTID]
		if not QuestID then return end
		local dataName = GetCompletedQuestInfo(QuestID)
		local Name = pinData[QuestDataIndex.NAME]
		if dataName ~= Name and DestinationsCSSV.QuestsDone[QuestID] ~= 2 and DestinationsCSSV.QuestsDone[QuestID] ~= 1 and DestinationsCSSV.QuestsDone[QuestID] ~= 5 and DestinationsCSSV.filters[PINS_QUESTS_UNDONE] then
			COMPASS_PINS.pinManager:CreatePin(PINS_QUESTS_UNDONE, pinData, pinData[QuestDataIndex.X], pinData[QuestDataIndex.Y])
		elseif DestinationsCSSV.QuestsDone[QuestID] and DestinationsCSSV.QuestsDone[QuestID] == 2 and DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] then
			COMPASS_PINS.pinManager:CreatePin(PINS_QUESTS_IN_PROGRESS, pinData, pinData[QuestDataIndex.X], pinData[QuestDataIndex.Y])
		elseif ((pinData[QuestDataIndex.NAME] == Name and DestinationsCSSV.QuestsDone[QuestID] ~= 5) or DestinationsCSSV.QuestsDone[QuestID] == 1) and DestinationsCSSV.filters[PINS_QUESTS_DONE] then
			COMPASS_PINS.pinManager:CreatePin(PINS_QUESTS_DONE, pinData, pinData[QuestDataIndex.X], pinData[QuestDataIndex.Y])
		end
	end
end

local function CollectibleFishCompassPins() -- Collectibles, Fishing
	if not DestinationsCSSV.filters[PINS_COLLECTIBLES] and not DestinationsCSSV.filters[PINS_FISHING] then return end
	if (GetMapType() >= MAPTYPE_ZONE + 1) then return end
	GetMapTextureName()
	local data = ACHDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		local TYPE = pinData[ACHDataIndex.TYPE]
		if TYPE >= 40 and TYPE <= 44 then
			if not DestinationsCSSV.filters[PINS_FISHING_COMPASS] or not DestinationsCSSV.filters[PINS_FISHING] then return end
			local fishID = pinData[ACHDataIndex.ID]
			local _, requiredTotal = 0, GetAchievementNumCriteria(fishID)
			local desc, completed = nil, 0, 0
			local countF, countL, countO, countR = 0, 0, 0, 0
			local countFN, countLN, countON, countRN = 0, 0, 0, 0
			local countFND, countLND, countOND, countRND = 0, 0, 0, 0
			local fishdata = FishLocationsStore[fishID]
			local FishName, FishNumber, FishLoc = nil, nil, nil
			for _, pinData in ipairs(fishdata) do
				FishLoc = pinData[FishLocationsIndex.LOCATION]
				if FishLoc == "F" then
					countF = countF + 1
				elseif FishLoc == "L" then
					countL = countL + 1
				elseif FishLoc == "O" then
					countO = countO + 1
				elseif FishLoc == "R" then
					countR = countR + 1
				end
			end
			for i = 1, requiredTotal, 1 do
				for _, pinData in ipairs(fishdata) do
					FishLoc = pinData[FishLocationsIndex.LOCATION]
					FishNumber = pinData[FishLocationsIndex.FISHNUMBER]
					if FishNumber == i then
						if TYPE == 40 and FishLoc == "F" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countFN = countFN + 1
							else
								countFND = countFND + 1
							end
						elseif TYPE == 41 and FishLoc == "R" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countRN = countRN + 1
							else
								countRND = countRND + 1
							end
						elseif TYPE == 42 and FishLoc == "O" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countON = countON + 1
							else
								countOND = countOND + 1
							end
						elseif TYPE == 43 and FishLoc == "L" then
							FishName, completed, _ = GetAchievementCriterion(fishID, i)
							if completed == 0 then
								countLN = countLN + 1
							else
								countLND = countLND + 1
							end
						end
					end
				end
			end
			if (countFN >= 1 and countF >= 1 and countF ~= countFND) or (countLN >= 1 and countL >= 1 and countL ~= countLND) or (countON >= 1 and countO >= 1 and countO ~= countOND) or (countRN >= 1 and countR >= 1 and countR ~= countRND) then
				COMPASS_PINS.pinManager:CreatePin(PINS_FISHING, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[PINS_FISHINGDONE] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_FISHINGDONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		elseif TYPE == 30 then
			if not DestinationsCSSV.filters[PINS_COLLECTIBLES_COMPASS] or not DestinationsCSSV.filters[PINS_COLLECTIBLES] then return end
			local collectibleID = pinData[ACHDataIndex.ID]
			local _, requiredTotal = 0, GetAchievementNumCriteria(collectibleID)
			local completed = 0
			local collectibleNumber = nil
			local collectibledata = CollectibleDataStore[collectibleID]
			local collectibleCode = pinData[ACHDataIndex.KEYCODE]
			local countCN = 0
			for i = 1, requiredTotal, 1 do
				for _, pinData in ipairs(collectibledata) do
					collectibleNumber = pinData[CollectibleDataIndex.NUMBER]
					if collectibleNumber == i and string.find(collectibleCode, i) then
						_, completed, _ = GetAchievementCriterion(collectibleID, i)
						if completed == 1 then
							countCN = countCN + 1
						end
					end
				end
			end
			if (countCN == 0) then
				COMPASS_PINS.pinManager:CreatePin(PINS_COLLECTIBLES, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			elseif DestinationsCSSV.filters[PINS_COLLECTIBLESDONE] == true then
				COMPASS_PINS.pinManager:CreatePin(PINS_COLLECTIBLESDONE, pinData, pinData[ACHDataIndex.X], pinData[ACHDataIndex.Y])
			end
		end
	end
end

local function BorderCompassPins()
	if (GetMapType() >= MAPTYPE_ZONE + 1) or not DestinationsCSSV.filters[PINS_BORDER] then return end
	GetMapTextureName()
	local data = BorderDataStore[mapTextureName]
	if not data then return end
	for _, pinData in ipairs(data) do
		COMPASS_PINS.pinManager:CreatePin(PINS_BORDER, pinData, pinData[BorderDataIndex.X], pinData[BorderDataIndex.Y])
	end
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

-- Toggle Semi-Real pins on or off depending on settings
local function ToggleRealPins()
	local index = DestinationsCSSV.pins.pinTextureUnknown.type
	if index ~= 3 or DestinationsCSSV.filters[PINS_UNKNOWN] == false then
		DestinationsCSSV.filters[PINS_REALUNKNOWNWAYSHRINE] = false
		LMP:SetEnabled(PINS_REALUNKNOWNWAYSHRINE, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNAOI] = false
		LMP:SetEnabled(PINS_REALUNKNOWNAOI, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNPUBLICDUNGEON] = false
		LMP:SetEnabled(PINS_REALUNKNOWNPUBLICDUNGEON, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNMUNDUS] = false
		LMP:SetEnabled(PINS_REALUNKNOWNMUNDUS, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNDOLMEN] = false
		LMP:SetEnabled(PINS_REALUNKNOWNDOLMEN, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPBOSS] = false
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPBOSS, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPDUNGEON] = false
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPDUNGEON, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNQUESTHUB] = false
		LMP:SetEnabled(PINS_REALUNKNOWNQUESTHUB, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNCRAFTING] = false
		LMP:SetEnabled(PINS_REALUNKNOWNCRAFTING, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNSOLODUNGEON] = false
		LMP:SetEnabled(PINS_REALUNKNOWNSOLODUNGEON, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPEVENT] = false
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPEVENT, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPDELVE] = false
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPDELVE, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNTRIAL] = false
		LMP:SetEnabled(PINS_REALUNKNOWNTRIAL, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNWAYSHRINETRADER] = false
		LMP:SetEnabled(PINS_REALUNKNOWNWAYSHRINETRADER, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPDUNGEON2] = false
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPDUNGEON2, false)
		DestinationsCSSV.filters[PINS_REALUNKNOWN] = false
		LMP:SetEnabled(PINS_REALUNKNOWN, false)
	else
		DestinationsCSSV.filters[PINS_REALUNKNOWNWAYSHRINE] = true
		LMP:SetEnabled(PINS_REALUNKNOWNWAYSHRINE, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNAOI] = true
		LMP:SetEnabled(PINS_REALUNKNOWNAOI, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNPUBLICDUNGEON] = true
		LMP:SetEnabled(PINS_REALUNKNOWNPUBLICDUNGEON, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNMUNDUS] = true
		LMP:SetEnabled(PINS_REALUNKNOWNMUNDUS, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNDOLMEN] = true
		LMP:SetEnabled(PINS_REALUNKNOWNDOLMEN, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPBOSS] = true
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPBOSS, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPDUNGEON] = true
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPDUNGEON, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNQUESTHUB] = true
		LMP:SetEnabled(PINS_REALUNKNOWNQUESTHUB, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNCRAFTING] = true
		LMP:SetEnabled(PINS_REALUNKNOWNCRAFTING, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNSOLODUNGEON] = true
		LMP:SetEnabled(PINS_REALUNKNOWNSOLODUNGEON, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPEVENT] = true
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPEVENT, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPDELVE] = true
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPDELVE, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNTRIAL] = true
		LMP:SetEnabled(PINS_REALUNKNOWNTRIAL, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNWAYSHRINETRADER] = true
		LMP:SetEnabled(PINS_REALUNKNOWNWAYSHRINETRADER, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWNGROUPDUNGEON2] = true
		LMP:SetEnabled(PINS_REALUNKNOWNGROUPDUNGEON2, true)
		DestinationsCSSV.filters[PINS_REALUNKNOWN] = true
		LMP:SetEnabled(PINS_REALUNKNOWN, true)
	end
end

-- Toggle filters depending on settings
local function TogglePins(pinType, value)
	DestinationsCSSV.filters[pinType] = value
	LMP:SetEnabled(pinType, value)
end

-- Refresh map and compass pins
local function RedrawAllPins(pinType)
	LMP:RefreshPins(pinType)
	COMPASS_PINS:RefreshPins(pinType)
end

-- Refresh map pins only
local function RedrawMapPinsOnly(pinType)
	LMP:RefreshPins(pinType)
end

-- Refresh compass pins only
local function RedrawCompassPinsOnly(pinType)
	COMPASS_PINS:RefreshPins(pinType)
end

-- Refresh all achievement map and compass pins
local function RedrawAllAchievementPins()
	LMP:RefreshPins(PINS_LB_GTTP_CP)
	LMP:RefreshPins(PINS_MAIQ)
	LMP:RefreshPins(PINS_PEACEMAKER)
	LMP:RefreshPins(PINS_NOSEDIVER)
	LMP:RefreshPins(PINS_EARTHLYPOS)
	LMP:RefreshPins(PINS_ON_ME)
	LMP:RefreshPins(PINS_LB_GTTP_CP_DONE)
	LMP:RefreshPins(PINS_MAIQ_DONE)
	LMP:RefreshPins(PINS_PEACEMAKER_DONE)
	LMP:RefreshPins(PINS_NOSEDIVER_DONE)
	LMP:RefreshPins(PINS_EARTHLYPOS_DONE)
	LMP:RefreshPins(PINS_ON_ME_DONE)
	COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP)
	COMPASS_PINS:RefreshPins(PINS_MAIQ)
	COMPASS_PINS:RefreshPins(PINS_PEACEMAKER)
	COMPASS_PINS:RefreshPins(PINS_NOSEDIVER)
	COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS)
	COMPASS_PINS:RefreshPins(PINS_ON_ME)
	COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP_DONE)
	COMPASS_PINS:RefreshPins(PINS_MAIQ_DONE)
	COMPASS_PINS:RefreshPins(PINS_PEACEMAKER_DONE)
	COMPASS_PINS:RefreshPins(PINS_NOSEDIVER_DONE)
	COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS_DONE)
	COMPASS_PINS:RefreshPins(PINS_ON_ME_DONE)
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

--Invoked on Map update to redraw Semi-Real Pins
local function MapCallback_unknownWayshrine(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 1 then
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName), zo_strformat("[<<t:1>>]", "["..poiTypeName.."]"))}
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					table.insert(pinTag, 2, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			pinType = PINS_REALUNKNOWNWAYSHRINE
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownWayshrineTrader(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 14 then
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName), zo_strformat("[<<t:1>>]", "["..poiTypeName.."]"))}
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			pinType = PINS_REALUNKNOWNWAYSHRINETRADER
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolorTrader)):Colorize(zo_strformat("<<1>>", "["..GetString(POITYPE_GUILDTRADERS).."]")))
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownAOI(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 2 then
			pinType = PINS_REALUNKNOWNAOI
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownPublicDungeon(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	local zoneIndex = GetCurrentMapZoneIndex()
	if index ~= 3 then return end
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 3 and zoneIndex ~= 353 then
			pinType = PINS_REALUNKNOWNPUBLICDUNGEON
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownMundus(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 4 then
			pinType = PINS_REALUNKNOWNMUNDUS
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownDolmen(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 5 then
			pinType = PINS_REALUNKNOWNDOLMEN
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownGroupBoss(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 6 then
			pinType = PINS_REALUNKNOWNGROUPBOSS
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownGroupDungeon(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	local zoneIndex = GetCurrentMapZoneIndex()
	if index ~= 3 or zoneIndex == 353 then return end
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 7 then
			pinType = PINS_REALUNKNOWNGROUPDUNGEON
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownGroupDungeon2(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	local zoneIndex = GetCurrentMapZoneIndex()
	if index ~= 3 or zoneIndex ~= 353 then return end
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 7 then
			pinType = PINS_REALUNKNOWNGROUPDUNGEON2
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownQuestHub(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 8 then
			pinType = PINS_REALUNKNOWNQUESTHUB
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownCrafting(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 9 then
			pinType = PINS_REALUNKNOWNCRAFTING
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownSoloDungeon(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 10 then
			pinType = PINS_REALUNKNOWNSOLODUNGEON
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownGroupEvent(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 11 then
			pinType = PINS_REALUNKNOWNGROUPEVENT
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownGroupDelve(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 12 then
			pinType = PINS_REALUNKNOWNGROUPDELVE
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_unknownTrial(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 13 then
			pinType = PINS_REALUNKNOWNTRIAL
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function MapCallback_RealUnknown(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index ~= 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown and poiTypeId == 22 then
			pinType = PINS_REALUNKNOWN
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName), zo_strformat("[<<t:1>>]", "["..poiTypeName.."]"))}
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					table.insert(pinTag, 2, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

local function RedrawAllRealPins()
		RedrawAllPins(PINS_REALUNKNOWNWAYSHRINE)
		RedrawAllPins(PINS_REALUNKNOWNAOI)
		RedrawAllPins(PINS_REALUNKNOWNPUBLICDUNGEON)
		RedrawAllPins(PINS_REALUNKNOWNMUNDUS)
		RedrawAllPins(PINS_REALUNKNOWNDOLMEN)
		RedrawAllPins(PINS_REALUNKNOWNGROUPBOSS)
		RedrawAllPins(PINS_REALUNKNOWNGROUPDUNGEON)
		RedrawAllPins(PINS_REALUNKNOWNQUESTHUB)
		RedrawAllPins(PINS_REALUNKNOWNCRAFTING)
		RedrawAllPins(PINS_REALUNKNOWNSOLODUNGEON)
		RedrawAllPins(PINS_REALUNKNOWNGROUPEVENT)
		RedrawAllPins(PINS_REALUNKNOWNGROUPDELVE)
		RedrawAllPins(PINS_REALUNKNOWNTRIAL)
		RedrawAllPins(PINS_REALUNKNOWNWAYSHRINETRADER)
		RedrawAllPins(PINS_REALUNKNOWNGROUPDUNGEON2)
		RedrawAllPins(PINS_REALUNKNOWN)
end
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

--Invoked on Map update to redraw Unknown Pins (not Semi-Real)
local function MapCallback_unknown(pinManager)
	if not LMP:IsEnabled(PINS_UNKNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_UNKNOWN] then return end
	local index = DestinationsSV.pins.pinTextureUnknown.type
	if index == 3 then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if unknown then
			pinType = PINS_UNKNOWN
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))) --insert english name as a second tooltip line
				end
			end
			pinTextLine = pinTextLine + 1
			table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			if poiTypeId == 14 then
				local poiTypeName2 = GetPoiTypeName(1)
				pinTextLine = pinTextLine + 1
				table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
				pinTextLine = pinTextLine + 1
				table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName2.."]")))
			end
			LMP:CreatePin(pinType, pinTag, normalizedX, normalizedY)
		end
	end
end

--Invoked on Map update to redraw known Pins
local function MapCallback_known(pinManager)
	if not LMP:IsEnabled(PINS_KNOWN) or (GetMapType() > MAPTYPE_ZONE) then return end
	if not DestinationsCSSV.filters[PINS_KNOWN] then return end
	local zoneIndex = GetCurrentMapZoneIndex()
	local data = MapDataStore[GetCurrentMapZoneIndex()]
	for i = 1, GetNumPOIs(zoneIndex) do
		local normalizedX, normalizedY, poiType, icon = GetPOIMapInfo(zoneIndex, i)
		local unknown = (poiType == MAP_PIN_TYPE_INVALID)
		local objectiveName = GetPOIInfo(zoneIndex, i)
		local poiTypeId = 22
		local poiTypeName
		local pinTag
		if data then
			for _, pinLookup in ipairs(data) do
				if pinLookup[1] == objectiveName then
					poiTypeId = pinLookup[2]
					break
				end
			end
		end
		poiTypeName = GetPoiTypeName(poiTypeId)
		if GetMapType() ~= 1 and not unknown then
			local pinTextLine = 1
			pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureKnown.textcolor)):Colorize(zo_strformat("<<1>>", objectiveName))}
			if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
				if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
					pinTextLine = pinTextLine + 1
					table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureKnown.textcolorEN)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i])))
				end
			end
			if poiTypeId ~= 1 and poiTypeId ~= 14 then
				pinTextLine = pinTextLine + 1
				table.insert(pinTag, pinTextLine, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureKnown.textcolor)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
			end
			if poiTypeId == 14 then
				if localLanguage ~= "en" and DestinationsSV.filters[PINS_ADD_ENGLISH] == true then
					if englishPOINames[zoneIndex] and englishPOINames[zoneIndex][i] then
						pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureKnown.textcolorEN)):Colorize(zo_strformat("<<1>>", englishPOINames[zoneIndex][i]))}
						table.insert(pinTag, 2, ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureKnown.textcolorTrader)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]")))
					end
				else
					pinTag = {ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureKnown.textcolorTrader)):Colorize(zo_strformat("<<1>>", "["..poiTypeName.."]"))}
				end
			end
			if poiTypeId ~= 1 then
				LMP:CreatePin(PINS_KNOWN, pinTag, normalizedX, normalizedY)
			end
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- Quest functions
function RegisterQuest(eventCode, journalIndex, questName, objectiveName)
	GetCoords(questName, journalIndex)
end
local MapCoords = ZO_Object:Subclass()
local function FormatCoords(number)
	return ("%05.04f"):format(zo_round(number * 10000)/10000)
end
function GetCoords(questName, journalIndex)
	if not npcName then return end
	local questType, isRepeat = nil, nil
	if journalIndex then
		questType = GetJournalQuestType(journalIndex)
		isRepeat = GetJournalQuestRepeatType(journalIndex)
	end
	if questType == 4 and isRepeat == 2 then return end -- crafting quests
	if questType == 5 and isRepeat == 2 then return end -- undaunted dailies
	if questType == 7 or questType == 10 or questType == 11 then return end -- AVA quests
	if string.find(questName, "*") then string.gsub(questName, "*", "") end
	local zoneName, mapName = nil, nil
	local data = nil
	if GetMapType() == 1 then
		GetMapTextureName()
		mapName = mapTextureName
		data = QuestDataStore[mapName]
	end
	if GetMapContentType() == MAP_CONTENT_DUNGEON or GetMapType() == MAPTYPE_SUBZONE then
		MapZoomOut()
		GetMapTextureName()
		zoneName = mapTextureName
		data = QuestDataStore[zoneName]
		SetMapToPlayerLocation()
	else
		GetMapTextureName()
		zoneName = mapTextureName
		data = QuestDataStore[zoneName]
	end
	local questFound, questID = false, nil
	for _, v in pairs(Destinations.QuestTableStore) do
		for _, x in pairs(v) do
			if x == questName then
				questID = v[4]
				questFound = true
				break
			end
			if questFound == true then break end
		end
		if questFound == true then break end
	end
	if questFound then
		if getQuestInfo then
			d("In progress: "..questID.."/"..questName)
		end
		DestinationsCSSV.QuestsDone[tonumber(questID)] = 2
		if questID == 5073 or questID == 5075 or questID == 5077 then -- fighters guild
			DestinationsCSSV.QuestsDone[5073] = 2
			DestinationsCSSV.QuestsDone[5075] = 2
			DestinationsCSSV.QuestsDone[5077] = 2
		end
		if questID == 5071 or questID == 5074 or questID == 5076 then -- mages guild
			DestinationsCSSV.QuestsDone[5071] = 2
			DestinationsCSSV.QuestsDone[5074] = 2
			DestinationsCSSV.QuestsDone[5076] = 2
		end
		if questID == 4767 or questID == 4967 or questID == 4997 then -- "One of the Undaunted"
			DestinationsCSSV.QuestsDone[4767] = 2
			DestinationsCSSV.QuestsDone[4967] = 2
			DestinationsCSSV.QuestsDone[4997] = 2
		end
	end
	RedrawAllPins(PINS_QUESTS_UNDONE)
	RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
	RedrawAllPins(PINS_QUESTS_DONE)
	SetMapToPlayerLocation()
	local mapX, mapY = GetMapPlayerPosition("player")
	local _, zoneX, zoneY = mapName, mapX, mapY
	if GetMapContentType() == MAP_CONTENT_DUNGEON or GetMapType() == MAPTYPE_SUBZONE then
		MapZoomOut()
		zoneX, zoneY = GetMapPlayerPosition("player")
	end
	local mapCheck = false
	local zoneCheck = false
	if data then
		local X, Y = 0, 0
		for _, pinData in ipairs(data) do
			if pinData[QuestDataIndex.NAME] == questName and pinData[QuestDataIndex.NPC] == npcName then
				if getQuestInfo then
					d("Checking local...")
				end
				X = FormatCoords(mapX)
				Y = FormatCoords(mapY)
				if getQuestInfo then
					d("Local Already registered!!!")
				end
				mapCheck = true
				X = FormatCoords(zoneX)
				Y = FormatCoords(zoneY)
				if getQuestInfo then
					d("Checking zone...")
				end
				if not (tonumber(X) <= pinData[QuestDataIndex.X] - 0.1) and not (tonumber(X) >= pinData[QuestDataIndex.X] + 0.1) then
					if getQuestInfo then
						d("Zone Already registered!!!")
					end
					zoneCheck = true
				end
				if mapCheck and zoneCheck then
					if getQuestInfo then
						d("Skipping...")
					end
					return
				elseif mapCheck then
					if getQuestInfo then
						d("Registering for zone...")
					end
				elseif zoneCheck then
					if getQuestInfo then
						d("Registering for map...")
					end
				else
					if getQuestInfo then
						d("Registering all...")
					end
				end
			end
		end
	end
	local questData = nil
	if DestinationsSV.filters[REGISTER_QUESTS] == false then return end
	local APIversion = GetAPIVersion()
	if not APIversion then
		APIversion = 100011
	end
	if getQuestInfo and not questID then
		d("Fixing empty QuestID...")
	end
	if not questID then questID = "" end
	if mapName then
		questData = mapName.."{"..FormatCoords(mapX)..", "..FormatCoords(mapY)..",\\t\\dq"..npcName.."\\dq,\\t\\dq"..questName.."\\dq,\\t"..questType..",\\t"..isRepeat..",\\t"..APIversion..",\\t"..questID.."},"
		if getQuestInfo then
			d("saving quest subzone data...")
		end
		DestinationsSV.Quests["DQD: "..mapName.."/"..questID] = questData
	end
	if zoneName and (mapName ~= zoneName) then
		questData = zoneName.."{"..FormatCoords(zoneX)..", "..FormatCoords(zoneY)..",\\t\\dq"..npcName.."\\dq,\\t\\dq"..questName.."\\dq,\\t"..questType..",\\t"..isRepeat..",\\t"..APIversion..",\\t"..questID.."},"
		if getQuestInfo then
			d("saving quest zone data...")
		end
		DestinationsSV.Quests["DQD: "..zoneName.."/"..questID] = questData
	end
end
local function RegisterNPC()
	npcName = GetUnitName("interact")
end
--------------------------------------------------------------------------------------------------------------------------------
function RegisterQuestDone(eventCode, questName, level, previousExperience, currentExperience, rank, previousPoints, currentPoints)
	local questFound, questID = false, 0
	for _, v in pairs(Destinations.QuestTableStore) do
		for _, x in pairs(v) do
			if x == questName then
				questID = tonumber(v[4])
				questFound = true
				break
			end
			if questFound == true then break end
		end
		if questFound == true then break end
	end
	if questFound then
		if getQuestInfo then
			d("Completed: "..tostring(questID).."/"..questName)
		end
		local questData = {}
		for k, v in pairs(DestinationsCSSV.QuestsDone) do
			if questID == k then
				if questID == 5073 or questID == 5075 or questID == 5077 then -- fighters guild
					questData[5073] = 1
					questData[5075] = 1
					questData[5077] = 1
				elseif questID == 5071 or questID == 5074 or questID == 5076 then -- mages guild
					questData[5071] = 1
					questData[5074] = 1
					questData[5076] = 1
				elseif questID == 4767 or questID == 4967 or questID == 4997 then -- "One of the Undaunted"
					questData[4767] = 1
					questData[4967] = 1
					questData[4997] = 1
				end
			else
				questData[k] = v
			end
		end
		DestinationsCSSV.QuestsDone = {}
		for k, v in pairs(questData) do
				DestinationsCSSV.QuestsDone[k] = v
		end
	end
	RedrawAllPins(PINS_QUESTS_UNDONE)
	RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
	RedrawAllPins(PINS_QUESTS_DONE)
end
function RegisterQuestCancelled(eventCode, isCompleted, journalIndex, questName, zoneIndex, poiIndex)
	local questFound, questID = false, 0
	for _, v in pairs(Destinations.QuestTableStore) do
		for _, x in pairs(v) do
			if x == questName then
				questID = tonumber(v[4])
				questFound = true
				break
			end
			if questFound == true then break end
		end
		if questFound == true then break end
	end
	if questFound then
		if getQuestInfo then
			d("Cancelled: "..tostring(questID).."/"..questName)
		end
		local questData = {}
		for k, v in pairs(DestinationsCSSV.QuestsDone) do
			if questID ~= k then
				if questID == 5073 or questID == 5075 or questID == 5077 then -- fighters guild
				elseif questID == 5071 or questID == 5074 or questID == 5076 then -- mages guild
				elseif questID == 4767 or questID == 4967 or questID == 4997 then -- "One of the Undaunted"
				else
					questData[k] = v
				end
			end
		end
		DestinationsCSSV.QuestsDone = {}
		for k, v in pairs(questData) do
				DestinationsCSSV.QuestsDone[k] = v
		end
	end
	RedrawAllPins(PINS_QUESTS_UNDONE)
	RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
	RedrawAllPins(PINS_QUESTS_DONE)
end
--------------------------------------------------------------------------------------------------------------------------------
function GetInProgressQuests()
	local questData = {}
	for k, v in pairs(DestinationsCSSV.QuestsDone) do
		if v == 5 then
			questData[k] = v
		end
	end
	DestinationsCSSV.QuestsDone = {}
	for k, v in pairs(questData) do
		DestinationsCSSV.QuestsDone[k] = v
	end
	local numQuests = GetNumJournalQuests()
	for i = 1, numQuests do
		local questName, _, _, _, _, _, _, _, _, _ = GetJournalQuestInfo(i)
		for _, v in pairs(Destinations.QuestDataStore) do
			for _, x in pairs(v) do
				if x[4] == questName then
					local questId = x[8]
					DestinationsCSSV.QuestsDone[questId] = 2
					if questId == 5073 or questId == 5075 or questId == 5077 then -- fighters guild
						DestinationsCSSV.QuestsDone[5073] = 2
						DestinationsCSSV.QuestsDone[5075] = 2
						DestinationsCSSV.QuestsDone[5077] = 2
					end
					if questId == 5071 or questId == 5074 or questId == 5076 then -- mages guild
						DestinationsCSSV.QuestsDone[5071] = 2
						DestinationsCSSV.QuestsDone[5074] = 2
						DestinationsCSSV.QuestsDone[5076] = 2
					end
				end
			end
		end
	end
end
function SetSpecialQuests()
	if not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] then return end
	for questID = 5071, 5077 do
		local questName = GetCompletedQuestInfo(questID)
		if questName then
			if questID == 5073 or questID == 5075 or questID == 5077 then -- fighters guild
				DestinationsCSSV.QuestsDone[5073] = 1
				DestinationsCSSV.QuestsDone[5075] = 1
				DestinationsCSSV.QuestsDone[5077] = 1
			end
			if questID == 5071 or questID == 5074 or questID == 5076 then -- mages guild
				DestinationsCSSV.QuestsDone[5071] = 1
				DestinationsCSSV.QuestsDone[5074] = 1
				DestinationsCSSV.QuestsDone[5076] = 1
			end
		end
	end
	for questID = 4766, 4998 do
		local questName = GetCompletedQuestInfo(questID)
		if questName then
			if questID == 4767 or questID == 4967 or questID == 4997 then -- "One of the Undaunted"
				DestinationsCSSV.QuestsDone[4767] = 1
				DestinationsCSSV.QuestsDone[4967] = 1
				DestinationsCSSV.QuestsDone[4997] = 1
			end
		end
	end
end
--------------------------------------------------------------------------------------------------------------------------------
function SetQuestHidden(pin, questID, questName)
	if getQuestInfo then
		d("Hiding questID: "..questID)
		d("Name: "..questName)
	end
	DestinationsCSSV.QuestsDone[questID] = 5
	RedrawAllPins(PINS_QUESTS_UNDONE)
	RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
	RedrawAllPins(PINS_QUESTS_DONE)
end
function SetQuestHiddenDummy()
end
function ResetHiddenQuests()
	local questData = {}
	for k, v in pairs(DestinationsCSSV.QuestsDone) do
		if v ~= 5 then
			questData[k] = v
		end
	end
	DestinationsCSSV.QuestsDone = {}
	for k, v in pairs(questData) do
		DestinationsCSSV.QuestsDone[k] = v
	end
	RedrawAllPins(PINS_QUESTS_UNDONE)
	RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
	RedrawAllPins(PINS_QUESTS_DONE)
end
--------------------------------------------------------------------------------------------------------------------------------
local function SetQuestEditing()
	if EditingQuests == false then
		EditingQuests = true
		LMP:SetClickHandlers(PINS_QUESTS_UNDONE, { [1] = { callback = function(pin) ShowQuestEditingMenu(pin) end }}, duplicates == false)
		d(GetString(QUEST_EDIT_ON))
	elseif EditingQuests == true then
		EditingQuests = false
		LMP:SetClickHandlers(PINS_QUESTS_UNDONE, nil)
		d(GetString(QUEST_EDIT_OFF))
	end
end
function ShowQuestEditingMenu(pin)
	if not EditingQuests then return end
	local _, pinTag = pin:GetPinTypeAndTag()
	local questName = pinTag[1]
	local qName = string.gsub(questName, "|c......", "")
	qName = string.gsub(qName, "|r", "")
	qName = string.gsub(qName, "%-", " ")
	if getQuestInfo then
		d("Quest found: "..qName)
	end
	local questTableName = nil
	for _, v in pairs(Destinations.QuestTableStore) do
		if localLanguage == "fr" then
			questTableName = v[3]
		elseif localLanguage == "de" then
			questTableName = v[2]
		else
			questTableName = v[1]
		end
		if questTableName then
			questTableName = string.gsub(questTableName, "%-", " ")
			if string.find(qName, questTableName) then
				questID = tonumber(v[4])
				break
			end
		end
	end
	ClearMenu()
	AddMenuItem(questName, function () SetQuestHiddenDummy() end)
	if not questID or questID == 0 then
		if getQuestInfo then
			d("The quest could not be identified as no ID was found. For that reason the quest can not be hidden.")
			d("Please report the name and location of the quest to SnowmanDK on ESOUI.com.")
		end
		AddMenuItem(defaults.miscColorCodes.settingsTextWarn:Colorize(GetString(QUEST_MENU_NOT_FOUND)), function () SetQuestHiddenDummy() end)
	else
		AddMenuItem(GetString(QUEST_MENU_HIDE_QUEST), function (pin) SetQuestHidden(pin, questID, questName) end)
	end
	AddMenuItem(GetString(QUEST_MENU_DISABLE_EDIT), function () SetQuestEditing() end)
	ShowMenu(pin)
end

SLASH_COMMANDS["/dqin"] = function()
	if getQuestInfo == false then
		getQuestInfo = true
		d("Quest debug Info ON")
		d("Repeat command to turn it off.")
	elseif getQuestInfo == true then
		getQuestInfo = false
		d("Quest debug Info OFF")
	end
end
SLASH_COMMANDS["/dzmi"] = function()
	local zoneName, subzone = nil, nil
	if GetMapContentType() == MAP_CONTENT_DUNGEON or GetMapType() == MAPTYPE_SUBZONE then
		GetMapTextureName()
		subzone = mapTextureName
		MapZoomOut()
		GetMapTextureName()
		zoneName = mapTextureName
	else
		GetMapTextureName()
		zoneName = mapTextureName
	end
	if zoneName and subzone then
		d(zoneName..", "..subzone)
	elseif zoneName then
		d("zone: "..zoneName)
	elseif subzone then
		d("subzone "..subzone)
	else
		d("no zonedata found!")
	end
end
SLASH_COMMANDS["/dhlp"] = function()
	d(GetString(DESTCOMMANDS))
	d(GetString(DESTCOMMANDdhlp))
	d(GetString(DESTCOMMANDdset))
end
SLASH_COMMANDS["/dlaq"] = function()
	GetInProgressQuests()
	SetSpecialQuests()
	ReloadUI()
end
SLASH_COMMANDS["/deaq"] = function()
	local questId = GetNextCompletedQuestId()
	local questName = ""
	local questType
	local APIversion = GetAPIVersion()
	for i = 1, 6000 do
		if questId ~= nil then
			questName, questType = GetCompletedQuestInfo(questId)
			for mapID, v in pairs(Destinations.QuestDataStore) do
				for k, x in pairs(v) do
					if x[4] == questName then
						local X = x[1]
						local Y = x[2]
						local NPC = x[3]
						local REPEAT = x[6]
						DestinationsSV.Quests[questId.."]-["..mapID] = "{"..X..", "..Y..",\t\v"..NPC.."\v,\t\t\t\v"..questName.."\v,\t"..questType..",\t"..REPEAT..",\t"..APIversion..",\t"..questId.."}"
					end
				end
			end
			questId = GetNextCompletedQuestId(questId)
		else
			return
		end
	end
end
SLASH_COMMANDS["/dqed"] = function()
	SetQuestEditing()
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

local function InitSettings()
	local LAM = LibStub("LibAddonMenu-2.0")
	local optionsTable = setmetatable({}, { __index = table })

	local panelData = {
		type = "panel",
		name = GetString(DEST_SETTINGS_TITLE),
		displayName = GetString(DEST_SETTINGS_TITLE),
		author = Addon.Author,
		version = Addon.Version,
		slashCommand = "/dset",
		registerForRefresh = true,
		registerForDefaults = true,
	}
	local settingsPanel = LAM:RegisterAddonPanel("Destinations_OptionsPanel", panelData)

	--Icon Preview
	CreateIcons = function(panel)
		if panel == settingsPanel then
			unknownPoiPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureUnknown, CT_TEXTURE)
			unknownPoiPreview:SetAnchor(RIGHT, previewpinTextureUnknown.dropdown:GetControl(), LEFT, -10, 0)
			unknownPoiPreview:SetTexture(pinTextures.Unknown[DestinationsSV.pins.pinTextureUnknown.type])
			unknownPoiPreview:SetDimensions(DestinationsSV.pins.pinTextureUnknown.size, DestinationsSV.pins.pinTextureUnknown.size)
			unknownPoiPreview:SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			
			knownPoiPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureKnown, CT_TEXTURE)
			knownPoiPreview:SetAnchor(RIGHT, previewpinTextureKnown.dropdown:GetControl(), LEFT, -10, 0)
			knownPoiPreview:SetTexture(pinTextures.Known[DestinationsSV.pins.pinTextureKnown.type])
			knownPoiPreview:SetDimensions(DestinationsSV.pins.pinTextureKnown.size, DestinationsSV.pins.pinTextureKnown.size)
			knownPoiPreview:SetColor(unpack(DestinationsSV.pins.pinTextureKnown.tint))
			
			otherPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureOther, CT_TEXTURE)
			otherPreview:SetAnchor(RIGHT, previewpinTextureOther.dropdown:GetControl(), LEFT, -40, 0)
			otherPreview:SetTexture(pinTextures.Other[DestinationsSV.pins.pinTextureOther.type])
			otherPreview:SetDimensions(DestinationsSV.pins.pinTextureOther.size, DestinationsSV.pins.pinTextureOther.size)
			otherPreview:SetColor(unpack(DestinationsSV.pins.pinTextureOther.tint))

			otherPreviewDone = WINDOW_MANAGER:CreateControl(nil, previewpinTextureOther, CT_TEXTURE)
			otherPreviewDone:SetAnchor(RIGHT, previewpinTextureOther.dropdown:GetControl(), LEFT, -5, 0)
			otherPreviewDone:SetTexture(pinTextures.OtherDone[DestinationsSV.pins.pinTextureOtherDone.type])
			otherPreviewDone:SetDimensions(DestinationsSV.pins.pinTextureOtherDone.size, DestinationsSV.pins.pinTextureOtherDone.size)
			otherPreviewDone:SetColor(unpack(DestinationsSV.pins.pinTextureOtherDone.tint))

			MaiqPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureMaiq, CT_TEXTURE)
			MaiqPreview:SetAnchor(RIGHT, previewpinTextureMaiq.dropdown:GetControl(), LEFT, -40, 0)
			MaiqPreview:SetTexture(pinTextures.Maiq[DestinationsSV.pins.pinTextureMaiq.type])
			MaiqPreview:SetDimensions(DestinationsSV.pins.pinTextureMaiq.size, DestinationsSV.pins.pinTextureMaiq.size)
			MaiqPreview:SetColor(unpack(DestinationsSV.pins.pinTextureMaiq.tint))

			MaiqPreviewDone = WINDOW_MANAGER:CreateControl(nil, previewpinTextureMaiq, CT_TEXTURE)
			MaiqPreviewDone:SetAnchor(RIGHT, previewpinTextureMaiq.dropdown:GetControl(), LEFT, -5, 0)
			MaiqPreviewDone:SetTexture(pinTextures.MaiqDone[DestinationsSV.pins.pinTextureMaiqDone.type])
			MaiqPreviewDone:SetDimensions(DestinationsSV.pins.pinTextureMaiqDone.size, DestinationsSV.pins.pinTextureMaiqDone.size)
			MaiqPreviewDone:SetColor(unpack(DestinationsSV.pins.pinTextureMaiqDone.tint))

			PeacemakerPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTexturePeacemaker, CT_TEXTURE)
			PeacemakerPreview:SetAnchor(RIGHT, previewpinTexturePeacemaker.dropdown:GetControl(), LEFT, -40, 0)
			PeacemakerPreview:SetTexture(pinTextures.Peacemaker[DestinationsSV.pins.pinTexturePeacemaker.type])
			PeacemakerPreview:SetDimensions(DestinationsSV.pins.pinTexturePeacemaker.size, DestinationsSV.pins.pinTexturePeacemaker.size)
			PeacemakerPreview:SetColor(unpack(DestinationsSV.pins.pinTexturePeacemaker.tint))

			PeacemakerPreviewDone = WINDOW_MANAGER:CreateControl(nil, previewpinTexturePeacemaker, CT_TEXTURE)
			PeacemakerPreviewDone:SetAnchor(RIGHT, previewpinTexturePeacemaker.dropdown:GetControl(), LEFT, -5, 0)
			PeacemakerPreviewDone:SetTexture(pinTextures.PeacemakerDone[DestinationsSV.pins.pinTexturePeacemakerDone.type])
			PeacemakerPreviewDone:SetDimensions(DestinationsSV.pins.pinTexturePeacemakerDone.size, DestinationsSV.pins.pinTexturePeacemakerDone.size)
			PeacemakerPreviewDone:SetColor(unpack(DestinationsSV.pins.pinTexturePeacemakerDone.tint))

			NosediverPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureNosediver, CT_TEXTURE)
			NosediverPreview:SetAnchor(RIGHT, previewpinTextureNosediver.dropdown:GetControl(), LEFT, -40, 0)
			NosediverPreview:SetTexture(pinTextures.Nosediver[DestinationsSV.pins.pinTextureNosediver.type])
			NosediverPreview:SetDimensions(DestinationsSV.pins.pinTextureNosediver.size, DestinationsSV.pins.pinTextureNosediver.size)
			NosediverPreview:SetColor(unpack(DestinationsSV.pins.pinTextureNosediver.tint))

			NosediverPreviewDone = WINDOW_MANAGER:CreateControl(nil, previewpinTextureNosediver, CT_TEXTURE)
			NosediverPreviewDone:SetAnchor(RIGHT, previewpinTextureNosediver.dropdown:GetControl(), LEFT, -5, 0)
			NosediverPreviewDone:SetTexture(pinTextures.NosediverDone[DestinationsSV.pins.pinTextureNosediverDone.type])
			NosediverPreviewDone:SetDimensions(DestinationsSV.pins.pinTextureNosediverDone.size, DestinationsSV.pins.pinTextureNosediverDone.size)
			NosediverPreviewDone:SetColor(unpack(DestinationsSV.pins.pinTextureNosediverDone.tint))

			EarthlyPosPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureEarthlyPos, CT_TEXTURE)
			EarthlyPosPreview:SetAnchor(RIGHT, previewpinTextureEarthlyPos.dropdown:GetControl(), LEFT, -40, 0)
			EarthlyPosPreview:SetTexture(pinTextures.Earthlypos[DestinationsSV.pins.pinTextureEarthlyPos.type])
			EarthlyPosPreview:SetDimensions(DestinationsSV.pins.pinTextureEarthlyPos.size, DestinationsSV.pins.pinTextureEarthlyPos.size)
			EarthlyPosPreview:SetColor(unpack(DestinationsSV.pins.pinTextureEarthlyPos.tint))

			EarthlyPosPreviewDone = WINDOW_MANAGER:CreateControl(nil, previewpinTextureEarthlyPos, CT_TEXTURE)
			EarthlyPosPreviewDone:SetAnchor(RIGHT, previewpinTextureEarthlyPos.dropdown:GetControl(), LEFT, -5, 0)
			EarthlyPosPreviewDone:SetTexture(pinTextures.EarthlyposDone[DestinationsSV.pins.pinTextureEarthlyPosDone.type])
			EarthlyPosPreviewDone:SetDimensions(DestinationsSV.pins.pinTextureEarthlyPosDone.size, DestinationsSV.pins.pinTextureEarthlyPosDone.size)
			EarthlyPosPreviewDone:SetColor(unpack(DestinationsSV.pins.pinTextureEarthlyPosDone.tint))

			OnMePreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureOnMe, CT_TEXTURE)
			OnMePreview:SetAnchor(RIGHT, previewpinTextureOnMe.dropdown:GetControl(), LEFT, -40, 0)
			OnMePreview:SetTexture(pinTextures.OnMe[DestinationsSV.pins.pinTextureOnMe.type])
			OnMePreview:SetDimensions(DestinationsSV.pins.pinTextureOnMe.size, DestinationsSV.pins.pinTextureOnMe.size)
			OnMePreview:SetColor(unpack(DestinationsSV.pins.pinTextureOnMe.tint))

			OnMePreviewDone = WINDOW_MANAGER:CreateControl(nil, previewpinTextureOnMe, CT_TEXTURE)
			OnMePreviewDone:SetAnchor(RIGHT, previewpinTextureOnMe.dropdown:GetControl(), LEFT, -5, 0)
			OnMePreviewDone:SetTexture(pinTextures.OnMeDone[DestinationsSV.pins.pinTextureOnMeDone.type])
			OnMePreviewDone:SetDimensions(DestinationsSV.pins.pinTextureOnMeDone.size, DestinationsSV.pins.pinTextureOnMeDone.size)
			OnMePreviewDone:SetColor(unpack(DestinationsSV.pins.pinTextureOnMeDone.tint))

			AyleidPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureAyleid, CT_TEXTURE)
			AyleidPreview:SetAnchor(RIGHT, previewpinTextureAyleid.dropdown:GetControl(), LEFT, -10, 0)
			AyleidPreview:SetTexture(pinTextures.ayleid[DestinationsSV.pins.pinTextureAyleid.type])
			AyleidPreview:SetDimensions(DestinationsSV.pins.pinTextureAyleid.size, DestinationsSV.pins.pinTextureAyleid.size)
			AyleidPreview:SetColor(unpack(DestinationsSV.pins.pinTextureAyleid.tint))

			DwemerPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureDwemer, CT_TEXTURE)
			DwemerPreview:SetAnchor(RIGHT, previewpinTextureDwemer.dropdown:GetControl(), LEFT, -10, 0)
			DwemerPreview:SetTexture(pinTextures.dwemer[DestinationsSV.pins.pinTextureDwemer.type])
			DwemerPreview:SetDimensions(DestinationsSV.pins.pinTextureDwemer.size, DestinationsSV.pins.pinTextureDwemer.size)
			DwemerPreview:SetColor(unpack(DestinationsSV.pins.pinTextureDwemer.tint))

			ChampionPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureChampion, CT_TEXTURE)
			ChampionPreview:SetAnchor(RIGHT, previewpinTextureChampion.dropdown:GetControl(), LEFT, -10, 0)
			ChampionPreview:SetTexture(pinTextures.champion[DestinationsSV.pins.pinTextureChampion.type])
			ChampionPreview:SetDimensions(DestinationsSV.pins.pinTextureChampion.size, DestinationsSV.pins.pinTextureChampion.size)
			ChampionPreview:SetColor(unpack(DestinationsSV.pins.pinTextureChampion.tint))

			CraglornBorderPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureBorder, CT_TEXTURE)
			CraglornBorderPreview:SetAnchor(RIGHT, previewpinTextureBorder.dropdown:GetControl(), LEFT, -10, 0)
			CraglornBorderPreview:SetTexture(pinTextures.border[DestinationsSV.pins.pinTextureBorder.type])
			CraglornBorderPreview:SetDimensions(DestinationsSV.pins.pinTextureBorder.size, DestinationsSV.pins.pinTextureBorder.size)
			CraglornBorderPreview:SetColor(unpack(DestinationsSV.pins.pinTextureBorder.tint))

			WWVampPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureWWVamp, CT_TEXTURE)
			WWVampPreview:SetAnchor(RIGHT, previewpinTextureWWVamp.dropdown:GetControl(), LEFT, -10, 0)
			WWVampPreview:SetTexture(pinTextures.wwvamp[DestinationsSV.pins.pinTextureWWVamp.type])
			WWVampPreview:SetDimensions(DestinationsSV.pins.pinTextureWWVamp.size, DestinationsSV.pins.pinTextureWWVamp.size)
			WWVampPreview:SetColor(unpack(DestinationsSV.pins.pinTextureWWVamp.tint))

			VampAltarPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureVampAltar, CT_TEXTURE)
			VampAltarPreview:SetAnchor(RIGHT, previewpinTextureVampAltar.dropdown:GetControl(), LEFT, -10, 0)
			VampAltarPreview:SetTexture(pinTextures.vampirealtar[DestinationsSV.pins.pinTextureVampAltar.type])
			VampAltarPreview:SetDimensions(DestinationsSV.pins.pinTextureVampAltar.size, DestinationsSV.pins.pinTextureVampAltar.size)
			VampAltarPreview:SetColor(unpack(DestinationsSV.pins.pinTextureVampAltar.tint))

			WWShrinePreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureWWShrine, CT_TEXTURE)
			WWShrinePreview:SetAnchor(RIGHT, previewpinTextureWWShrine.dropdown:GetControl(), LEFT, -10, 0)
			WWShrinePreview:SetTexture(pinTextures.werewolfshrine[DestinationsSV.pins.pinTextureWWShrine.type])
			WWShrinePreview:SetDimensions(DestinationsSV.pins.pinTextureWWShrine.size, DestinationsSV.pins.pinTextureWWShrine.size)
			WWShrinePreview:SetColor(unpack(DestinationsSV.pins.pinTextureWWShrine.tint))

			QuestsUndonePreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureQuestsUndone, CT_TEXTURE)
			QuestsUndonePreview:SetAnchor(RIGHT, previewpinTextureQuestsUndone.dropdown:GetControl(), LEFT, -10, 0)
			QuestsUndonePreview:SetTexture(pinTextures.Quests[DestinationsSV.pins.pinTextureQuestsUndone.type])
			QuestsUndonePreview:SetDimensions(DestinationsSV.pins.pinTextureQuestsUndone.size, DestinationsSV.pins.pinTextureQuestsUndone.size)
			QuestsUndonePreview:SetColor(unpack(DestinationsSV.pins.pinTextureQuestsUndone.tint))

			QuestsInProgressPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureQuestsInProgress, CT_TEXTURE)
			QuestsInProgressPreview:SetAnchor(RIGHT, previewpinTextureQuestsInProgress.dropdown:GetControl(), LEFT, -10, 0)
			QuestsInProgressPreview:SetTexture(pinTextures.Quests[DestinationsSV.pins.pinTextureQuestsInProgress.type])
			QuestsInProgressPreview:SetDimensions(DestinationsSV.pins.pinTextureQuestsInProgress.size, DestinationsSV.pins.pinTextureQuestsInProgress.size)
			QuestsInProgressPreview:SetColor(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.tint))

			QuestsDonePreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureQuestsDone, CT_TEXTURE)
			QuestsDonePreview:SetAnchor(RIGHT, previewpinTextureQuestsDone.dropdown:GetControl(), LEFT, -10, 0)
			QuestsDonePreview:SetTexture(pinTextures.Quests[DestinationsSV.pins.pinTextureQuestsDone.type])
			QuestsDonePreview:SetDimensions(DestinationsSV.pins.pinTextureQuestsDone.size, DestinationsSV.pins.pinTextureQuestsDone.size)
			QuestsDonePreview:SetColor(unpack(DestinationsSV.pins.pinTextureQuestsDone.tint))

			CollectiblePreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureCollectible, CT_TEXTURE)
			CollectiblePreview:SetAnchor(RIGHT, previewpinTextureCollectible.dropdown:GetControl(), LEFT, -40, 0)
			CollectiblePreview:SetTexture(pinTextures.collectible[DestinationsSV.pins.pinTextureCollectible.type])
			CollectiblePreview:SetDimensions(DestinationsSV.pins.pinTextureCollectible.size, DestinationsSV.pins.pinTextureCollectible.size)
			CollectiblePreview:SetColor(unpack(DestinationsSV.pins.pinTextureCollectible.tint))

			CollectibleDonePreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureCollectible, CT_TEXTURE)
			CollectibleDonePreview:SetAnchor(RIGHT, previewpinTextureCollectible.dropdown:GetControl(), LEFT, -5, 0)
			CollectibleDonePreview:SetTexture(pinTextures.collectibledone[DestinationsSV.pins.pinTextureCollectibleDone.type])
			CollectibleDonePreview:SetDimensions(DestinationsSV.pins.pinTextureCollectibleDone.size, DestinationsSV.pins.pinTextureCollectibleDone.size)
			CollectibleDonePreview:SetColor(unpack(DestinationsSV.pins.pinTextureCollectibleDone.tint))

			FishPreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureFish, CT_TEXTURE)
			FishPreview:SetAnchor(RIGHT, previewpinTextureFish.dropdown:GetControl(), LEFT, -40, 0)
			FishPreview:SetTexture(pinTextures.fish[DestinationsSV.pins.pinTextureFish.type])
			FishPreview:SetDimensions(DestinationsSV.pins.pinTextureFish.size, DestinationsSV.pins.pinTextureFish.size)
			FishPreview:SetColor(unpack(DestinationsSV.pins.pinTextureFish.tint))

			FishDonePreview = WINDOW_MANAGER:CreateControl(nil, previewpinTextureFish, CT_TEXTURE)
			FishDonePreview:SetAnchor(RIGHT, previewpinTextureFish.dropdown:GetControl(), LEFT, -5, 0)
			FishDonePreview:SetTexture(pinTextures.fishdone[DestinationsSV.pins.pinTextureFishDone.type])
			FishDonePreview:SetDimensions(DestinationsSV.pins.pinTextureFishDone.size, DestinationsSV.pins.pinTextureFishDone.size)
			FishDonePreview:SetColor(unpack(DestinationsSV.pins.pinTextureFishDone.tint))

			CALLBACK_MANAGER:UnregisterCallback("LAM-PanelControlsCreated", CreateIcons)
		end
	end
	CALLBACK_MANAGER:RegisterCallback("LAM-PanelControlsCreated", CreateIcons)

	optionsTable:insert({ -- Toggle using Account Wide settings
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_USE_ACCOUNTWIDE)),
		tooltip = GetString(DEST_SETTINGS_USE_ACCOUNTWIDE_TT),
		getFunc = function() return DestinationsAWSV.settings.useAccountWide end,
		setFunc = function(state)
			DestinationsAW.settings.useAccountWide = state
			ReloadUI()
		end,
		warning = defaults.miscColorCodes.settingsTextReloadWarning:Colorize(GetString(DEST_SETTINGS_RELOAD_WARNING)),
		default = defaults.settings.useAccountWide,
	})
	if DestinationsAW.settings.useAccountWide then
		optionsTable:insert({ -- Account wide tip
			type = "description",
			text = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_HEADER)),
		})
	end
------------------------------------------------------------------------
---------------------------Points of Interest---------------------------
------------------------------------------------------------------------
	optionsTable:insert({ -- Points of Interest submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextKnown:Colorize(GetString(DEST_SETTINGS_POI_HEADER)),
		tooltip = GetString(DEST_SETTINGS_POI_HEADER_TT),
		width = "full",	--or "half" (optional)
		controls = setmetatable({}, { __index = table })
	})
	local POIsubmenuControls = optionsTable[#optionsTable].controls
	POIsubmenuControls:insert({ -- Unknown pin toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_UNKNOWN_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_UNKNOWN) end,
		setFunc = function(state)
			TogglePins(PINS_UNKNOWN, state)
			ToggleRealPins()
		end,
		default = defaults.filters[PINS_UNKNOWN],
	})
	POIsubmenuControls:insert({ -- Unknown pin style
		type = "dropdown",
		name = defaults.miscColorCodes.settingsTextUnknown:Colorize(GetString(DEST_SETTINGS_UNKNOWN_PIN_STYLE)),
		reference = "previewpinTextureUnknown",
		choices = pinTexturesListUnknown,
		getFunc = function() return pinTexturesListUnknown[DestinationsSV.pins.pinTextureUnknown.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListUnknown) do
				if name == selected then
					DestinationsSV.pins.pinTextureUnknown.type = index
					LMP:SetLayoutKey(PINS_UNKNOWN, "texture", pinTextures.Unknown[index])
					unknownPoiPreview:SetTexture(pinTextures.Unknown[index])
					ToggleRealPins()
					LMP:RefreshPins(PINS_UNKNOWN)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_UNKNOWN] end,
		default = pinTexturesListUnknown[defaults.pins.pinTextureUnknown.type],
	})
	POIsubmenuControls:insert({ -- Unknown pin size
		type = "slider",
		name = defaults.miscColorCodes.settingsTextUnknown:Colorize(GetString(DEST_SETTINGS_UNKNOWN_PIN_SIZE)),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureUnknown.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureUnknown.size = size
			unknownPoiPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_UNKNOWN, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNWAYSHRINE, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNAOI, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNPUBLICDUNGEON, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNMUNDUS, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNDOLMEN, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPBOSS, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPDUNGEON, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNQUESTHUB, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNCRAFTING, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNSOLODUNGEON, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPEVENT, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPDELVE, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNTRIAL, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNWAYSHRINETRADER, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPDUNGEON2, "size", size)
			LMP:SetLayoutKey(PINS_REALUNKNOWN, "size", size)

			LMP:RefreshPins(PINS_UNKNOWN)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINE)
			LMP:RefreshPins(PINS_REALUNKNOWNAOI)
			LMP:RefreshPins(PINS_REALUNKNOWNPUBLICDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNMUNDUS)
			LMP:RefreshPins(PINS_REALUNKNOWNDOLMEN)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPBOSS)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNQUESTHUB)
			LMP:RefreshPins(PINS_REALUNKNOWNCRAFTING)
			LMP:RefreshPins(PINS_REALUNKNOWNSOLODUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPEVENT)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDELVE)
			LMP:RefreshPins(PINS_REALUNKNOWNTRIAL)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINETRADER)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON2)
			LMP:RefreshPins(PINS_REALUNKNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_UNKNOWN] end,
		default = defaults.pins.pinTextureUnknown.size
	})
	POIsubmenuControls:insert({ -- Unknown pin layer
		type = "slider",
		name = defaults.miscColorCodes.settingsTextUnknown:Colorize(GetString(DEST_SETTINGS_UNKNOWN_PIN_LAYER)),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureUnknown.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureUnknown.level = level
			LMP:SetLayoutKey(PINS_UNKNOWN, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNWAYSHRINE, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNAOI, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNPUBLICDUNGEON, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNMUNDUS, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNDOLMEN, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPBOSS, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPDUNGEON, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNQUESTHUB, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNCRAFTING, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNSOLODUNGEON, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPEVENT, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPDELVE, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNTRIAL, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNWAYSHRINETRADER, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWNGROUPDUNGEON2, "level", level)
			LMP:SetLayoutKey(PINS_REALUNKNOWN, "level", level)

			LMP:RefreshPins(PINS_UNKNOWN)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINE)
			LMP:RefreshPins(PINS_REALUNKNOWNAOI)
			LMP:RefreshPins(PINS_REALUNKNOWNPUBLICDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNMUNDUS)
			LMP:RefreshPins(PINS_REALUNKNOWNDOLMEN)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPBOSS)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNQUESTHUB)
			LMP:RefreshPins(PINS_REALUNKNOWNCRAFTING)
			LMP:RefreshPins(PINS_REALUNKNOWNSOLODUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPEVENT)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDELVE)
			LMP:RefreshPins(PINS_REALUNKNOWNTRIAL)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINETRADER)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON2)
			LMP:RefreshPins(PINS_REALUNKNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_UNKNOWN] end,
		default = defaults.pins.pinTextureUnknown.level
	})
	POIsubmenuControls:insert({ -- Unknown pin text color
		type = "colorpicker",
		name = defaults.miscColorCodes.settingsTextUnknown:Colorize(GetString(DEST_SETTINGS_UNKNOWN_COLOR)),
		tooltip = GetString(DEST_SETTINGS_UNKNOWN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureUnknown.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureUnknown.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_UNKNOWN)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINE)
			LMP:RefreshPins(PINS_REALUNKNOWNAOI)
			LMP:RefreshPins(PINS_REALUNKNOWNPUBLICDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNMUNDUS)
			LMP:RefreshPins(PINS_REALUNKNOWNDOLMEN)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPBOSS)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNQUESTHUB)
			LMP:RefreshPins(PINS_REALUNKNOWNCRAFTING)
			LMP:RefreshPins(PINS_REALUNKNOWNSOLODUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPEVENT)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDELVE)
			LMP:RefreshPins(PINS_REALUNKNOWNTRIAL)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINETRADER)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON2)
			LMP:RefreshPins(PINS_REALUNKNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_UNKNOWN] end,
		default = {r = defaults.pins.pinTextureUnknown.textcolor[1], g = defaults.pins.pinTextureUnknown.textcolor[2], b = defaults.pins.pinTextureUnknown.textcolor[3]}
	})
	POIsubmenuControls:insert({ -- Unknown English pin text color
		type = "colorpicker",
		name = defaults.miscColorCodes.settingsTextUnknown:Colorize(GetString(DEST_SETTINGS_UNKNOWN_COLOR_EN)),
		tooltip = GetString(DEST_SETTINGS_UNKNOWN_COLOR_EN_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureUnknown.textcolorEN) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureUnknown.textcolorEN = {r, g, b}
			LMP:RefreshPins(PINS_UNKNOWN)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINE)
			LMP:RefreshPins(PINS_REALUNKNOWNAOI)
			LMP:RefreshPins(PINS_REALUNKNOWNPUBLICDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNMUNDUS)
			LMP:RefreshPins(PINS_REALUNKNOWNDOLMEN)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPBOSS)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNQUESTHUB)
			LMP:RefreshPins(PINS_REALUNKNOWNCRAFTING)
			LMP:RefreshPins(PINS_REALUNKNOWNSOLODUNGEON)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPEVENT)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDELVE)
			LMP:RefreshPins(PINS_REALUNKNOWNTRIAL)
			LMP:RefreshPins(PINS_REALUNKNOWNWAYSHRINETRADER)
			LMP:RefreshPins(PINS_REALUNKNOWNGROUPDUNGEON2)
			LMP:RefreshPins(PINS_REALUNKNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_UNKNOWN] or localLanguage == "en" end,
		default = {r = defaults.pins.pinTextureUnknown.textcolorEN[1], g = defaults.pins.pinTextureUnknown.textcolorEN[2], b = defaults.pins.pinTextureUnknown.textcolorEN[3]}
	})
	POIsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	POIsubmenuControls:insert({ -- Known pin toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_KNOWN_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_KNOWN) end,
		setFunc = function(state)
			TogglePins(PINS_KNOWN, state)
		end,
		default = defaults.filters[PINS_KNOWN],
	})
	POIsubmenuControls:insert({ -- Known pin style
		type = "dropdown",
		name = defaults.miscColorCodes.settingsTextKnown:Colorize(GetString(DEST_SETTINGS_KNOWN_PIN_STYLE)),
		reference = "previewpinTextureKnown",
		choices = pinTexturesListKnown,
		getFunc = function() return pinTexturesListKnown[DestinationsSV.pins.pinTextureKnown.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListKnown) do
				if name == selected then
					DestinationsSV.pins.pinTextureKnown.type = index
					LMP:SetLayoutKey(PINS_KNOWN, "texture", pinTextures.Known[index])
					knownPoiPreview:SetTexture(pinTextures.Known[index])
					LMP:RefreshPins(PINS_KNOWN)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_KNOWN] end,
		default = pinTexturesListKnown[defaults.pins.pinTextureKnown.type],
	})
	POIsubmenuControls:insert({ -- Known pin size
		type = "slider",
		name = defaults.miscColorCodes.settingsTextKnown:Colorize(GetString(DEST_SETTINGS_KNOWN_PIN_SIZE)),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureKnown.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureKnown.size = size
			knownPoiPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_KNOWN, "size", size)
			LMP:RefreshPins(PINS_KNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_KNOWN] end,
		default = defaults.pins.pinTextureKnown.size
	})
	POIsubmenuControls:insert({ -- Known pin layer
		type = "slider",
		name = defaults.miscColorCodes.settingsTextKnown:Colorize(GetString(DEST_SETTINGS_KNOWN_PIN_LAYER)),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureKnown.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureKnown.level = level
			LMP:SetLayoutKey(PINS_KNOWN, "level", level)
			LMP:RefreshPins(PINS_KNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_KNOWN] end,
		default = defaults.pins.pinTextureKnown.level
	})
	POIsubmenuControls:insert({ -- Known pin text color
		type = "colorpicker",
		name = defaults.miscColorCodes.settingsTextKnown:Colorize(GetString(DEST_SETTINGS_KNOWN_COLOR)),
		tooltip = GetString(DEST_SETTINGS_KNOWN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureKnown.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureKnown.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_KNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_KNOWN] or not DestinationsSV.filters[PINS_ADD_ENGLISH] end,
		default = {r = defaults.pins.pinTextureKnown.textcolor[1], g = defaults.pins.pinTextureKnown.textcolor[2], b = defaults.pins.pinTextureKnown.textcolor[3]}
	})
	POIsubmenuControls:insert({ -- Known English pin text color
		type = "colorpicker",
		name = defaults.miscColorCodes.settingsTextKnown:Colorize(GetString(DEST_SETTINGS_KNOWN_COLOR_EN)),
		tooltip = GetString(DEST_SETTINGS_KNOWN_COLOR_EN_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureKnown.textcolorEN) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureKnown.textcolorEN = {r, g, b}
			LMP:RefreshPins(PINS_KNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_KNOWN] or localLanguage == "en" end,
		default = {r = defaults.pins.pinTextureKnown.textcolorEN[1], g = defaults.pins.pinTextureKnown.textcolorEN[2], b = defaults.pins.pinTextureKnown.textcolorEN[3]}
	})
	POIsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	POIsubmenuControls:insert({ -- Guild Trader pin text color
		type = "colorpicker",
		name = defaults.miscColorCodes.settingsTextEnglish:Colorize(GetString(DEST_SETTINGS_GTRADER_COLOR)),
		tooltip = GetString(DEST_SETTINGS_GTRADER_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureKnown.textcolorTrader) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureUnknown.textcolorTrader = {r, g, b}
			DestinationsSV.pins.pinTextureKnown.textcolorTrader = {r, g, b}
			LMP:RefreshPins(PINS_UNKNOWN)
			LMP:RefreshPins(PINS_KNOWN)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_KNOWN] and not DestinationsCSSV.filters[PINS_UNKNOWN] end,
		default = {r = defaults.pins.pinTextureKnown.textcolorTrader[1], g = defaults.pins.pinTextureKnown.textcolorTrader[2], b = defaults.pins.pinTextureKnown.textcolorTrader[3]}
	})
	POIsubmenuControls:insert({ -- English pin name toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextEnglish:Colorize(GetString(DEST_SETTINGS_ALL_SHOW_ENGLISH)),
		getFunc = function() return DestinationsSV.filters[PINS_ADD_ENGLISH] end,
		setFunc = function(state)
			TogglePins(PINS_ADD_ENGLISH, state)
		end,
		default = defaults.filters[PINS_ADD_ENGLISH],
		disabled = function() return (not DestinationsCSSV.filters[PINS_KNOWN] and not DestinationsCSSV.filters[PINS_UNKNOWN]) or (localLanguage == "en") end,
	})
------------------------------------------------------------------------
------------------------------ACHIEVEMENTS------------------------------
------------------------------------------------------------------------
	optionsTable:insert({ -- Achievements submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextAchievements:Colorize(GetString(DEST_SETTINGS_ACH_HEADER)),
		tooltip = GetString(DEST_SETTINGS_ACH_HEADER_TT),
		width = "full",
		controls = setmetatable({}, { __index = table })
	})
	local ACHsubmenuControls = optionsTable[#optionsTable].controls
	ACHsubmenuControls:insert({ -- Achievement Other Toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_OTHER_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_ACH_OTHER_PIN_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_LB_GTTP_CP) end,
		setFunc = function(state)
			TogglePins(PINS_LB_GTTP_CP, state)
			TogglePins(PINS_LB_GTTP_CP_DONE, state)
			RedrawAllPins(PINS_LB_GTTP_CP)
			RedrawAllPins(PINS_LB_GTTP_CP_DONE)
		end,
		default = defaults.filters[PINS_LB_GTTP_CP],
	})
	ACHsubmenuControls:insert({ -- Achievement Other Style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureOther",
		choices = pinTexturesListOther,
		getFunc = function() return pinTexturesListOther[DestinationsSV.pins.pinTextureOther.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListOther) do
				if name == selected then
					DestinationsSV.pins.pinTextureOther.type = index
					DestinationsSV.pins.pinTextureOtherDone.type = index
					LMP:SetLayoutKey(PINS_LB_GTTP_CP, "texture", pinTextures.Other[index])
					LMP:SetLayoutKey(PINS_LB_GTTP_CP_DONE, "texture", pinTextures.OtherDone[index])
					otherPreview:SetTexture(pinTextures.Other[index])
					otherPreviewDone:SetTexture(pinTextures.OtherDone[index])
					RedrawAllPins(PINS_LB_GTTP_CP)
					RedrawAllPins(PINS_LB_GTTP_CP_DONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_LB_GTTP_CP] end,
		default = pinTexturesListOther[defaults.pins.pinTextureOther.type],
	})
	ACHsubmenuControls:insert({ -- Achievement Other size
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_OTHER_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureOther.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureOther.size = size
			LMP:SetLayoutKey(PINS_LB_GTTP_CP, "size", size)
			otherPreview:SetDimensions(size, size)
			DestinationsSV.pins.pinTextureOtherDone.size = size
			LMP:SetLayoutKey(PINS_LB_GTTP_CP_DONE, "size", size)
			otherPreviewDone:SetDimensions(size, size)
			RedrawAllPins(PINS_LB_GTTP_CP)
			RedrawAllPins(PINS_LB_GTTP_CP_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_LB_GTTP_CP] end,
		default = defaults.pins.pinTextureOther.size
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement M'aiq Toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_MAIQ_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_ACH_MAIQ_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_MAIQ) end,
		setFunc = function(state)
			TogglePins(PINS_MAIQ, state)
			TogglePins(PINS_MAIQ_DONE, state)
			RedrawAllPins(PINS_MAIQ)
			RedrawAllPins(PINS_MAIQ_DONE)
		end,
		default = defaults.filters[PINS_MAIQ],
	})
	ACHsubmenuControls:insert({ -- Achievement M'aiq Style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureMaiq",
		choices = pinTexturesListMaiq,
		getFunc = function() return pinTexturesListMaiq[DestinationsSV.pins.pinTextureMaiq.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListMaiq) do
				if name == selected then
					DestinationsSV.pins.pinTextureMaiq.type = index
					DestinationsSV.pins.pinTextureMaiqDone.type = index
					LMP:SetLayoutKey(PINS_MAIQ, "texture", pinTextures.Maiq[index])
					LMP:SetLayoutKey(PINS_MAIQ_DONE, "texture", pinTextures.MaiqDone[index])
					MaiqPreview:SetTexture(pinTextures.Maiq[index])
					MaiqPreviewDone:SetTexture(pinTextures.MaiqDone[index])
					RedrawAllPins(PINS_MAIQ)
					RedrawAllPins(PINS_MAIQ_DONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_MAIQ] end,
		default = pinTexturesListMaiq[defaults.pins.pinTextureMaiq.type],
	})
	ACHsubmenuControls:insert({ -- Achievement M'aiq Size
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_MAIQ_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureMaiq.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureMaiq.size = size
			LMP:SetLayoutKey(PINS_MAIQ, "size", size)
			MaiqPreview:SetDimensions(size, size)
			DestinationsSV.pins.pinTextureMaiqDone.size = size
			LMP:SetLayoutKey(PINS_MAIQ_DONE, "size", size)
			MaiqPreviewDone:SetDimensions(size, size)
			RedrawAllPins(PINS_MAIQ)
			RedrawAllPins(PINS_MAIQ_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_MAIQ] end,
		default = defaults.pins.pinTextureMaiq.size
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement Peacemaker Toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_PEACEMAKER_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_ACH_PEACEMAKER_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_PEACEMAKER) end,
		setFunc = function(state)
			TogglePins(PINS_PEACEMAKER, state)
			TogglePins(PINS_PEACEMAKER_DONE, state)
			RedrawAllPins(PINS_PEACEMAKER)
			RedrawAllPins(PINS_PEACEMAKER_DONE)
		end,
		default = defaults.filters[PINS_PEACEMAKER],
	})
	ACHsubmenuControls:insert({ -- Achievement Peacemaker Style
		type = "dropdown",
		width = "half",
		reference = "previewpinTexturePeacemaker",
		choices = pinTexturesListPeacemaker,
		getFunc = function() return pinTexturesListPeacemaker[DestinationsSV.pins.pinTexturePeacemaker.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListPeacemaker) do
				if name == selected then
					DestinationsSV.pins.pinTexturePeacemaker.type = index
					DestinationsSV.pins.pinTexturePeacemakerDone.type = index
					LMP:SetLayoutKey(PINS_PEACEMAKER, "texture", pinTextures.Peacemaker[index])
					LMP:SetLayoutKey(PINS_PEACEMAKER_DONE, "texture", pinTextures.PeacemakerDone[index])
					PeacemakerPreview:SetTexture(pinTextures.Peacemaker[index])
					PeacemakerPreviewDone:SetTexture(pinTextures.PeacemakerDone[index])
					RedrawAllPins(PINS_PEACEMAKER)
					RedrawAllPins(PINS_PEACEMAKER_DONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_PEACEMAKER] end,
		default = pinTexturesListPeacemaker[defaults.pins.pinTexturePeacemaker.type],
	})
	ACHsubmenuControls:insert({ -- Achievement Peacemaker Size
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_PEACEMAKER_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTexturePeacemaker.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTexturePeacemaker.size = size
			LMP:SetLayoutKey(PINS_PEACEMAKER, "size", size)
			PeacemakerPreview:SetDimensions(size, size)
			DestinationsSV.pins.pinTexturePeacemakerDone.size = size
			LMP:SetLayoutKey(PINS_PEACEMAKER_DONE, "size", size)
			PeacemakerPreviewDone:SetDimensions(size, size)
			RedrawAllPins(PINS_PEACEMAKER)
			RedrawAllPins(PINS_PEACEMAKER_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_PEACEMAKER] end,
		default = defaults.pins.pinTexturePeacemaker.size
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement Nosediver Toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_NOSEDIVER_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_ACH_NOSEDIVER_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_NOSEDIVER) end,
		setFunc = function(state)
			TogglePins(PINS_NOSEDIVER, state)
			TogglePins(PINS_NOSEDIVER_DONE, state)
			RedrawAllPins(PINS_NOSEDIVER)
			RedrawAllPins(PINS_NOSEDIVER_DONE)
		end,
		default = defaults.filters[PINS_NOSEDIVER],
	})
	ACHsubmenuControls:insert({ -- Achievement Nosediver Style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureNosediver",
		choices = pinTexturesListNosediver,
		getFunc = function() return pinTexturesListNosediver[DestinationsSV.pins.pinTextureNosediver.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListNosediver) do
				if name == selected then
					DestinationsSV.pins.pinTextureNosediver.type = index
					DestinationsSV.pins.pinTextureNosediverDone.type = index
					LMP:SetLayoutKey(PINS_NOSEDIVER, "texture", pinTextures.Nosediver[index])
					LMP:SetLayoutKey(PINS_NOSEDIVER_DONE, "texture", pinTextures.NosediverDone[index])
					NosediverPreview:SetTexture(pinTextures.Nosediver[index])
					NosediverPreviewDone:SetTexture(pinTextures.NosediverDone[index])
					RedrawAllPins(PINS_NOSEDIVER)
					RedrawAllPins(PINS_NOSEDIVER_DONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_NOSEDIVER] end,
		default = pinTexturesListNosediver[defaults.pins.pinTextureNosediver.type],
	})
	ACHsubmenuControls:insert({ -- Achievement Nosediver Size
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_NOSEDIVER_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureNosediver.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureNosediver.size = size
			LMP:SetLayoutKey(PINS_NOSEDIVER, "size", size)
			NosediverPreview:SetDimensions(size, size)
			DestinationsSV.pins.pinTextureNosediverDone.size = size
			LMP:SetLayoutKey(PINS_NOSEDIVER_DONE, "size", size)
			NosediverPreviewDone:SetDimensions(size, size)
			RedrawAllPins(PINS_NOSEDIVER)
			RedrawAllPins(PINS_NOSEDIVER_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_NOSEDIVER] end,
		default = defaults.pins.pinTextureNosediver.size
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement Earthly Possesion Toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_EARTHLYPOS_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_ACH_EARTHLYPOS_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_EARTHLYPOS) end,
		setFunc = function(state)
			TogglePins(PINS_EARTHLYPOS, state)
			TogglePins(PINS_EARTHLYPOS_DONE, state)
			RedrawAllPins(PINS_EARTHLYPOS)
			RedrawAllPins(PINS_EARTHLYPOS_DONE)
		end,
		default = defaults.filters[PINS_EARTHLYPOS],
	})
	ACHsubmenuControls:insert({ -- Achievement Earthly Possesion Style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureEarthlyPos",
		choices = pinTexturesListEarthlyPos,
		getFunc = function() return pinTexturesListEarthlyPos[DestinationsSV.pins.pinTextureEarthlyPos.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListEarthlyPos) do
				if name == selected then
					DestinationsSV.pins.pinTextureEarthlyPos.type = index
					DestinationsSV.pins.pinTextureEarthlyPosDone.type = index
					LMP:SetLayoutKey(PINS_EARTHLYPOS, "texture", pinTextures.Earthlypos[index])
					LMP:SetLayoutKey(PINS_EARTHLYPOS_DONE, "texture", pinTextures.EarthlyposDone[index])
					EarthlyPosPreview:SetTexture(pinTextures.Earthlypos[index])
					EarthlyPosPreviewDone:SetTexture(pinTextures.EarthlyposDone[index])
					RedrawAllPins(PINS_EARTHLYPOS)
					RedrawAllPins(PINS_EARTHLYPOS_DONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_EARTHLYPOS] end,
		default = pinTexturesListNosediver[defaults.pins.pinTextureNosediver.type],
	})
	ACHsubmenuControls:insert({ -- Achievement Earthly Possesion Size
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_EARTHLYPOS_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureEarthlyPos.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureEarthlyPos.size = size
			LMP:SetLayoutKey(PINS_EARTHLYPOS, "size", size)
			EarthlyPosPreview:SetDimensions(size, size)
			DestinationsSV.pins.pinTextureEarthlyPosDone.size = size
			LMP:SetLayoutKey(PINS_EARTHLYPOS_DONE, "size", size)
			EarthlyPosPreviewDone:SetDimensions(size, size)
			RedrawAllPins(PINS_EARTHLYPOS)
			RedrawAllPins(PINS_EARTHLYPOS_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_EARTHLYPOS] end,
		default = defaults.pins.pinTextureEarthlyPos.size
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement This One's on Me Toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_ON_ME_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_ACH_ON_ME_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_ON_ME) end,
		setFunc = function(state)
			TogglePins(PINS_ON_ME, state)
			TogglePins(PINS_ON_ME_DONE, state)
			RedrawAllPins(PINS_ON_ME)
			RedrawAllPins(PINS_ON_ME_DONE)
		end,
		default = defaults.filters[PINS_ON_ME],
	})
	ACHsubmenuControls:insert({ -- Achievement This One's on Me Style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureOnMe",
		choices = pinTexturesListOnMe,
		getFunc = function() return pinTexturesListOnMe[DestinationsSV.pins.pinTextureOnMe.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListOnMe) do
				if name == selected then
					DestinationsSV.pins.pinTextureOnMe.type = index
					DestinationsSV.pins.pinTextureOnMeDone.type = index
					LMP:SetLayoutKey(PINS_ON_ME, "texture", pinTextures.OnMe[index])
					LMP:SetLayoutKey(PINS_ON_ME_DONE, "texture", pinTextures.OnMeDone[index])
					OnMePreview:SetTexture(pinTextures.OnMe[index])
					OnMePreviewDone:SetTexture(pinTextures.OnMeDone[index])
					RedrawAllPins(PINS_ON_ME)
					RedrawAllPins(PINS_ON_ME_DONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_ON_ME] end,
		default = pinTexturesListOnMe[defaults.pins.pinTextureOnMe.type],
	})
	ACHsubmenuControls:insert({ -- Achievement This One's on Me Size
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_ON_ME_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureOnMe.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureOnMe.size = size
			LMP:SetLayoutKey(PINS_ON_ME, "size", size)
			OnMePreview:SetDimensions(size, size)
			DestinationsSV.pins.pinTextureOnMeDone.size = size
			LMP:SetLayoutKey(PINS_ON_ME_DONE, "size", size)
			OnMePreviewDone:SetDimensions(size, size)
			RedrawAllPins(PINS_ON_ME)
			RedrawAllPins(PINS_ON_ME_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_ON_ME] end,
		default = defaults.pins.pinTextureOnMe.size
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement All Undone pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_ACH_PIN_COLOR_MISS),
		tooltip = GetString(DEST_SETTINGS_ACH_PIN_COLOR_MISS_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureOther.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureOther.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureMaiq.tint = {r, g, b, a}
			DestinationsSV.pins.pinTexturePeacemaker.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureNosediver.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureEarthlyPos.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureOnMe.tint = {r, g, b, a}
			LMP:SetLayoutKey(PINS_LB_GTTP_CP, "tint", ZO_ColorDef:New(r, g, b, a))
			otherPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_MAIQ, "tint", ZO_ColorDef:New(r, g, b, a))
			MaiqPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_PEACEMAKER, "tint", ZO_ColorDef:New(r, g, b, a))
			PeacemakerPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_NOSEDIVER, "tint", ZO_ColorDef:New(r, g, b, a))
			NosediverPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_EARTHLYPOS, "tint", ZO_ColorDef:New(r, g, b, a))
			EarthlyPosPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_ON_ME, "tint", ZO_ColorDef:New(r, g, b, a))
			OnMePreview:SetColor(r, g, b, a)
			RedrawAllPins(PINS_LB_GTTP_CP)
			RedrawAllPins(PINS_MAIQ)
			RedrawAllPins(PINS_PEACEMAKER)
			RedrawAllPins(PINS_NOSEDIVER)
			RedrawAllPins(PINS_EARTHLYPOS)
			RedrawAllPins(PINS_ON_ME)
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_LB_GTTP_CP] and
			not DestinationsCSSV.filters[PINS_MAIQ] and
			not DestinationsCSSV.filters[PINS_PEACEMAKER] and
			not DestinationsCSSV.filters[PINS_NOSEDIVER] and
			not DestinationsCSSV.filters[PINS_EARTHLYPOS] and
			not DestinationsCSSV.filters[PINS_ON_ME]
		end,
		default = {r = defaults.pins.pinTextureOther.tint[1], g = defaults.pins.pinTextureOther.tint[2], b = defaults.pins.pinTextureOther.tint[3], a = defaults.pins.pinTextureOther.tint[4]}
	})
	ACHsubmenuControls:insert({ -- Achievement All Undone pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_ACH_TXT_COLOR_MISS),
		tooltip = GetString(DEST_SETTINGS_ACH_TXT_COLOR_MISS_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureOther.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureOther.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureMaiq.textcolor = {r, g, b}
			DestinationsSV.pins.pinTexturePeacemaker.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureNosediver.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureEarthlyPos.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureOnMe.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_LB_GTTP_CP)
			LMP:RefreshPins(PINS_MAIQ)
			LMP:RefreshPins(PINS_PEACEMAKER)
			LMP:RefreshPins(PINS_NOSEDIVER)
			LMP:RefreshPins(PINS_EARTHLYPOS)
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_LB_GTTP_CP] and
			not DestinationsCSSV.filters[PINS_MAIQ] and
			not DestinationsCSSV.filters[PINS_PEACEMAKER] and
			not DestinationsCSSV.filters[PINS_NOSEDIVER] and
			not DestinationsCSSV.filters[PINS_EARTHLYPOS] and
			not DestinationsCSSV.filters[PINS_ON_ME]
		end,
		default = {r = defaults.pins.pinTextureOther.textcolor[1], g = defaults.pins.pinTextureOther.textcolor[2], b = defaults.pins.pinTextureOther.textcolor[3]}
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement All Done pin toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_ALL_SHOW_COMPLETE_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(SHOW_COMPLETED_ACHIEVEMENTS) end,
		setFunc = function(state)
			TogglePins(SHOW_COMPLETED_ACHIEVEMENTS, state)
			RedrawAllAchievementPins()
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_LB_GTTP_CP] and
			not DestinationsCSSV.filters[PINS_MAIQ] and
			not DestinationsCSSV.filters[PINS_PEACEMAKER] and
			not DestinationsCSSV.filters[PINS_NOSEDIVER] and
			not DestinationsCSSV.filters[PINS_EARTHLYPOS] and
			not DestinationsCSSV.filters[PINS_ON_ME]
		end,
		default = defaults.filters[SHOW_COMPLETED_ACHIEVEMENTS],
	})
	ACHsubmenuControls:insert({ -- Achievement All Done pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_ACH_PIN_COLOR_DONE),
		tooltip = GetString(DEST_SETTINGS_ACH_PIN_COLOR_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureOtherDone.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureOtherDone.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureMaiqDone.tint = {r, g, b, a}
			DestinationsSV.pins.pinTexturePeacemakerDone.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureNosediverDone.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureEarthlyPosDone.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureOnMeDone.tint = {r, g, b, a}
			LMP:SetLayoutKey(PINS_LB_GTTP_CP_DONE, "tint", ZO_ColorDef:New(r, g, b, a))
			otherPreviewDone:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_MAIQ_DONE, "tint", ZO_ColorDef:New(r, g, b, a))
			MaiqPreviewDone:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_PEACEMAKER_DONE, "tint", ZO_ColorDef:New(r, g, b, a))
			PeacemakerPreviewDone:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_NOSEDIVER_DONE, "tint", ZO_ColorDef:New(r, g, b, a))
			NosediverPreviewDone:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_EARTHLYPOS_DONE, "tint", ZO_ColorDef:New(r, g, b, a))
			EarthlyPosPreviewDone:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_ON_ME_DONE, "tint", ZO_ColorDef:New(r, g, b, a))
			OnMePreviewDone:SetColor(r, g, b, a)
			RedrawAllPins(PINS_LB_GTTP_CP_DONE)
			RedrawAllPins(PINS_MAIQ_DONE)
			RedrawAllPins(PINS_PEACEMAKER_DONE)
			RedrawAllPins(PINS_NOSEDIVER_DONE)
			RedrawAllPins(PINS_EARTHLYPOS_DONE)
			RedrawAllPins(PINS_ON_ME_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] end,
		default = {r = defaults.pins.pinTextureOtherDone.tint[1], g = defaults.pins.pinTextureOtherDone.tint[2], b = defaults.pins.pinTextureOtherDone.tint[3], a = defaults.pins.pinTextureOtherDone.tint[4]}
	})
	ACHsubmenuControls:insert({ -- Achievement All Done pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_ACH_TXT_COLOR_DONE),
		tooltip = GetString(DEST_SETTINGS_ACH_TXT_COLOR_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureOtherDone.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureOtherDone.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureMaiqDone.textcolor = {r, g, b}
			DestinationsSV.pins.pinTexturePeacemakerDone.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureNosediverDone.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureEarthlyPosDone.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureOnMeDone.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_LB_GTTP_CP_DONE)
			LMP:RefreshPins(PINS_MAIQ_DONE)
			LMP:RefreshPins(PINS_PEACEMAKER_DONE)
			LMP:RefreshPins(PINS_NOSEDIVER_DONE)
			LMP:RefreshPins(PINS_EARTHLYPOS_DONE)
			LMP:RefreshPins(PINS_ON_ME_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[SHOW_COMPLETED_ACHIEVEMENTS] end,
		default = {r = defaults.pins.pinTextureOtherDone.textcolor[1], g = defaults.pins.pinTextureOtherDone.textcolor[2], b = defaults.pins.pinTextureOtherDone.textcolor[3]}
	})
	ACHsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	ACHsubmenuControls:insert({ -- Achievement All compass toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_ACH_ALL_COMPASS_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return DestinationsCSSV.filters[PINS_ACHIEVEMENTS_COMPASS] end,
		setFunc = function(state)
			TogglePins(PINS_ACHIEVEMENTS_COMPASS, state)
			RedrawCompassPinsOnly(PINS_LB_GTTP_CP)
			RedrawCompassPinsOnly(PINS_LB_GTTP_CP_DONE)
			RedrawCompassPinsOnly(PINS_MAIQ)
			RedrawCompassPinsOnly(PINS_MAIQ_DONE)
			RedrawCompassPinsOnly(PINS_PEACEMAKER)
			RedrawCompassPinsOnly(PINS_PEACEMAKER_DONE)
			RedrawCompassPinsOnly(PINS_NOSEDIVER)
			RedrawCompassPinsOnly(PINS_NOSEDIVER_DONE)
			RedrawCompassPinsOnly(PINS_EARTHLYPOS)
			RedrawCompassPinsOnly(PINS_EARTHLYPOS_DONE)
			RedrawCompassPinsOnly(PINS_ON_ME)
			RedrawCompassPinsOnly(PINS_ON_ME_DONE)
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_LB_GTTP_CP] and
			not DestinationsCSSV.filters[PINS_MAIQ] and
			not DestinationsCSSV.filters[PINS_PEACEMAKER] and
			not DestinationsCSSV.filters[PINS_NOSEDIVER] and
			not DestinationsCSSV.filters[PINS_EARTHLYPOS] and
			not DestinationsCSSV.filters[PINS_ON_ME]
		end,
		default = defaults.filters[PINS_ACHIEVEMENTS_COMPASS],
	})
	ACHsubmenuControls:insert({ -- Achievement All compass distance
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_ALL_COMPASS_DIST),
		min = 1,
		max = 100,
		getFunc = function() return DestinationsSV.pins.pinTextureOther.maxDistance * 1000 end,
		setFunc = function(maxDistance)
			DestinationsSV.pins.pinTextureOther.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureOtherDone.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureMaiq.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureMaiqDone.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTexturePeacemaker.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTexturePeacemakerDone.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureNosediver.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureNosediverDone.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureEarthlyPos.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureEarthlyPosDone.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureOnMe.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureOnMeDone.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureOther.maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_LB_GTTP_CP].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_LB_GTTP_CP_DONE].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_MAIQ].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_MAIQ_DONE].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_PEACEMAKER].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_PEACEMAKER_DONE].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_NOSEDIVER].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_NOSEDIVER_DONE].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_EARTHLYPOS].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_EARTHLYPOS_DONE].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_ON_ME].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_ON_ME_DONE].maxDistance = maxDistance / 1000
			RedrawCompassPinsOnly(PINS_LB_GTTP_CP)
			RedrawCompassPinsOnly(PINS_LB_GTTP_CP_DONE)
			RedrawCompassPinsOnly(PINS_MAIQ)
			RedrawCompassPinsOnly(PINS_MAIQ_DONE)
			RedrawCompassPinsOnly(PINS_PEACEMAKER)
			RedrawCompassPinsOnly(PINS_PEACEMAKER_DONE)
			RedrawCompassPinsOnly(PINS_NOSEDIVER)
			RedrawCompassPinsOnly(PINS_NOSEDIVER_DONE)
			RedrawCompassPinsOnly(PINS_EARTHLYPOS)
			RedrawCompassPinsOnly(PINS_EARTHLYPOS_DONE)
			RedrawCompassPinsOnly(PINS_ON_ME)
			RedrawCompassPinsOnly(PINS_ON_ME_DONE)
		end,
		width = "full",
		disabled = function() return 
			(not DestinationsCSSV.filters[PINS_LB_GTTP_CP] and
			not DestinationsCSSV.filters[PINS_MAIQ] and
			not DestinationsCSSV.filters[PINS_PEACEMAKER] and
			not DestinationsCSSV.filters[PINS_NOSEDIVER] and
			not DestinationsCSSV.filters[PINS_EARTHLYPOS] and
			not DestinationsCSSV.filters[PINS_ON_ME]) or
			not DestinationsCSSV.filters[PINS_ACHIEVEMENTS_COMPASS]
		end,
		default = defaults.pins.pinTextureOther.maxDistance * 1000,
	})
	ACHsubmenuControls:insert({ -- Achievement All Pin Layer
		type = "slider",
		name = GetString(DEST_SETTINGS_ACH_ALL_PIN_LAYER),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureOther.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureOther.level = level
			DestinationsSV.pins.pinTextureOtherDone.level = level
			DestinationsSV.pins.pinTextureMaiq.level = level
			DestinationsSV.pins.pinTextureMaiqDone.level = level
			DestinationsSV.pins.pinTexturePeacemaker.level = level
			DestinationsSV.pins.pinTexturePeacemakerDone.level = level
			DestinationsSV.pins.pinTextureNosediver.level = level
			DestinationsSV.pins.pinTextureNosediverDone.level = level
			DestinationsSV.pins.pinTextureEarthlyPos.level = level
			DestinationsSV.pins.pinTextureEarthlyPosDone.level = level
			DestinationsSV.pins.pinTextureOnMe.level = level
			DestinationsSV.pins.pinTextureOnMeDone.level = level
			LMP:SetLayoutKey(PINS_LB_GTTP_CP, "level", level)
			LMP:SetLayoutKey(PINS_LB_GTTP_CP_DONE, "level", level)
			LMP:SetLayoutKey(PINS_MAIQ, "level", level)
			LMP:SetLayoutKey(PINS_MAIQ_DONE, "level", level)
			LMP:SetLayoutKey(PINS_PEACEMAKER, "level", level)
			LMP:SetLayoutKey(PINS_PEACEMAKER_DONE, "level", level)
			LMP:SetLayoutKey(PINS_NOSEDIVER, "level", level)
			LMP:SetLayoutKey(PINS_NOSEDIVER_DONE, "level", level)
			LMP:SetLayoutKey(PINS_EARTHLYPOS, "level", level)
			LMP:SetLayoutKey(PINS_EARTHLYPOS_DONE, "level", level)
			LMP:SetLayoutKey(PINS_ON_ME, "level", level)
			LMP:SetLayoutKey(PINS_ON_ME_DONE, "level", level)
			RedrawAllAchievementPins()
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_LB_GTTP_CP] and
			not DestinationsCSSV.filters[PINS_MAIQ] and
			not DestinationsCSSV.filters[PINS_PEACEMAKER] and
			not DestinationsCSSV.filters[PINS_NOSEDIVER] and
			not DestinationsCSSV.filters[PINS_EARTHLYPOS] and
			not DestinationsCSSV.filters[PINS_ON_ME]
		end,
		default = defaults.pins.pinTextureOther.level
	})
------------------------------------------------------------------------
--------------------------------MISC POIs-------------------------------
------------------------------------------------------------------------
	optionsTable:insert({ -- Misc POIs submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextMiscellaneous:Colorize(GetString(DEST_SETTINGS_MISC_HEADER)),
		tooltip = GetString(DEST_SETTINGS_MISC_HEADER_TT),
		width = "full",
		controls = setmetatable({}, { __index = table })
	})
	local MiscPOIsubmenuControls = optionsTable[#optionsTable].controls
	MiscPOIsubmenuControls:insert({ -- Ayleid Well pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_MISC_PIN_AYLEID_WELL_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_MISC_PIN_AYLEID_WELL_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_AYLEID) end,
		setFunc = function(state)
			TogglePins(PINS_AYLEID, state)
			RedrawAllPins(PINS_AYLEID)
		end,
		default = defaults.filters[PINS_AYLEID],
	})
	MiscPOIsubmenuControls:insert({ -- Ayleid Well pintype
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureAyleid",
		choices = pinTexturesListAyleid,
		getFunc = function() return pinTexturesListAyleid[DestinationsSV.pins.pinTextureAyleid.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListAyleid) do
				if name == selected then
					DestinationsSV.pins.pinTextureAyleid.type = index
					LMP:SetLayoutKey(PINS_AYLEID, "texture", pinTextures.ayleid[index])
					AyleidPreview:SetTexture(pinTextures.ayleid[index])
					RedrawAllPins(PINS_AYLEID)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_AYLEID] end,
		default = pinTexturesListAyleid[defaults.pins.pinTextureAyleid.type],
	})
	MiscPOIsubmenuControls:insert({ -- Ayleid Well pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_MISC_PIN_AYLEID_WELL_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureAyleid.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureAyleid.size = size
			AyleidPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_AYLEID, "size", size)
			RedrawAllPins(PINS_AYLEID)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_AYLEID] end,
		default = defaults.pins.pinTextureAyleid.size
	})
	MiscPOIsubmenuControls:insert({ -- Ayleid pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_MISC_PIN_AYLEID_WELL_COLOR),
		tooltip = GetString(DEST_SETTINGS_MISC_PIN_AYLEID_WELL_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureAyleid.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureAyleid.tint = {r, g, b, a}
			LMP:SetLayoutKey(PINS_AYLEID, "tint", ZO_ColorDef:New(r, g, b, a))
			AyleidPreview:SetColor(r, g, b, a)
			RedrawAllPins(PINS_AYLEID)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_AYLEID] end,
		default = {r = defaults.pins.pinTextureAyleid.tint[1], g = defaults.pins.pinTextureAyleid.tint[2], b = defaults.pins.pinTextureAyleid.tint[3], a = defaults.pins.pinTextureAyleid.tint[4]}
	})
	MiscPOIsubmenuControls:insert({ -- Ayleid pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_MISC_PINTEXT_AYLEID_WELL_COLOR),
		tooltip = GetString(DEST_SETTINGS_MISC_PINTEXT_AYLEID_WELL_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureAyleid.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureAyleid.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_AYLEID)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_AYLEID] end,
		default = {r = defaults.pins.pinTextureAyleid.textcolor[1], g = defaults.pins.pinTextureAyleid.textcolor[2], b = defaults.pins.pinTextureAyleid.textcolor[3]}
	})
	MiscPOIsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	MiscPOIsubmenuControls:insert({ -- Dwemer pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_MISC_DWEMER_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_MISC_DWEMER_PIN_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_DWEMER) end,
		setFunc = function(state)
			TogglePins(PINS_DWEMER, state)
			RedrawAllPins(PINS_DWEMER)
		end,
		default = defaults.filters[PINS_DWEMER],
	})
	MiscPOIsubmenuControls:insert({ -- Dwemer pin style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureDwemer",
		choices = pinTexturesListDwemer,
		getFunc = function() return pinTexturesListDwemer[DestinationsSV.pins.pinTextureDwemer.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListDwemer) do
				if name == selected then
					DestinationsSV.pins.pinTextureDwemer.type = index
					LMP:SetLayoutKey(PINS_DWEMER, "texture", pinTextures.dwemer[index])
					DwemerPreview:SetTexture(pinTextures.dwemer[index])
					RedrawAllPins(PINS_DWEMER)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_DWEMER] end,
		default = pinTexturesListDwemer[defaults.pins.pinTextureDwemer.type],
	})
	MiscPOIsubmenuControls:insert({ -- Dwemer pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_MISC_DWEMER_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureDwemer.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureDwemer.size = size
			DwemerPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_DWEMER, "size", size)
			RedrawAllPins(PINS_DWEMER)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_DWEMER] end,
		default = defaults.pins.pinTextureDwemer.size
	})
	MiscPOIsubmenuControls:insert({ -- Dwemer pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_MISC_DWEMER_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_MISC_DWEMER_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureDwemer.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureDwemer.tint = {r, g, b, a}
			LMP:SetLayoutKey(PINS_DWEMER, "tint", ZO_ColorDef:New(r, g, b, a))
			DwemerPreview:SetColor(r, g, b, a)
			RedrawAllPins(PINS_DWEMER)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_DWEMER] end,
		default = {r = defaults.pins.pinTextureDwemer.tint[1], g = defaults.pins.pinTextureDwemer.tint[2], b = defaults.pins.pinTextureDwemer.tint[3], a = defaults.pins.pinTextureDwemer.tint[4]}
	})
	MiscPOIsubmenuControls:insert({ -- Dwemer pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_MISC_DWEMER_PINTEXT_COLOR),
		tooltip = GetString(DEST_SETTINGS_MISC_DWEMER_PINTEXT_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureDwemer.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureDwemer.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_DWEMER)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_DWEMER] end,
		default = {r = defaults.pins.pinTextureDwemer.textcolor[1], g = defaults.pins.pinTextureDwemer.textcolor[2], b = defaults.pins.pinTextureDwemer.textcolor[3]}
	})
	MiscPOIsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	MiscPOIsubmenuControls:insert({ -- Champion pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_MISC_CHAMPION_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_MISC_CHAMPION_PIN_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_CHAMPION) end,
		setFunc = function(state)
			TogglePins(PINS_CHAMPION, state)
			RedrawAllPins(PINS_CHAMPION)
		end,
		default = defaults.filters[PINS_CHAMPION],
	})
	MiscPOIsubmenuControls:insert({ -- Champion pin style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureChampion",
		choices = pinTexturesListChampion,
		getFunc = function() return pinTexturesListChampion[DestinationsSV.pins.pinTextureChampion.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListChampion) do
				if name == selected then
					DestinationsSV.pins.pinTextureChampion.type = index
					LMP:SetLayoutKey(PINS_CHAMPION, "texture", pinTextures.champion[index])
					ChampionPreview:SetTexture(pinTextures.champion[index])
					RedrawAllPins(PINS_CHAMPION)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_CHAMPION] end,
		default = pinTexturesListChampion[defaults.pins.pinTextureChampion.type],
	})
	MiscPOIsubmenuControls:insert({ -- Champion pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_MISC_CHAMPION_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureChampion.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureChampion.size = size
			ChampionPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_CHAMPION, "size", size)
			RedrawAllPins(PINS_CHAMPION)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_CHAMPION] end,
		default = defaults.pins.pinTextureChampion.size
	})
	MiscPOIsubmenuControls:insert({ -- Champion pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_MISC_CHAMPION_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_MISC_CHAMPION_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureChampion.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureChampion.tint = {r, g, b, a}
			LMP:SetLayoutKey(PINS_CHAMPION, "tint", ZO_ColorDef:New(r, g, b, a))
			ChampionPreview:SetColor(r, g, b, a)
			RedrawAllPins(PINS_CHAMPION)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_CHAMPION] end,
		default = {r = defaults.pins.pinTextureChampion.tint[1], g = defaults.pins.pinTextureChampion.tint[2], b = defaults.pins.pinTextureChampion.tint[3], a = defaults.pins.pinTextureChampion.tint[4]}
	})
	MiscPOIsubmenuControls:insert({ -- Champion pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_MISC_CHAMPION_PINTEXT_COLOR),
		tooltip = GetString(DEST_SETTINGS_MISC_CHAMPION_PINTEXT_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureChampion.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureChampion.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_CHAMPION)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_CHAMPION] end,
		default = {r = defaults.pins.pinTextureChampion.textcolor[1], g = defaults.pins.pinTextureChampion.textcolor[2], b = defaults.pins.pinTextureChampion.textcolor[3]}
	})
	MiscPOIsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	MiscPOIsubmenuControls:insert({ -- Ayleid Well/Dwemer/Champion toggle compass
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_MISC_COMPASS_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return DestinationsCSSV.filters[PINS_MISC_COMPASS] end,
		setFunc = function(state)
			TogglePins(PINS_MISC_COMPASS, state)
			RedrawCompassPinsOnly(PINS_AYLEID)
			RedrawCompassPinsOnly(PINS_DWEMER)
			RedrawCompassPinsOnly(PINS_CHAMPION)
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_AYLEID] and
			not DestinationsCSSV.filters[PINS_DWEMER] and
			not DestinationsCSSV.filters[PINS_CHAMPION]
		end,
		default = defaults.filters[PINS_MISC_COMPASS],
	})
	MiscPOIsubmenuControls:insert({ -- Ayleid Well/Dwemer compass pin distance
		type = "slider",
		name = GetString(DEST_SETTINGS_MISC_COMPASS_DIST),
		min = 1,
		max = 100,
		getFunc = function() return DestinationsSV.pins.pinTextureAyleid.maxDistance * 1000 end,
		setFunc = function(maxDistance)
			DestinationsSV.pins.pinTextureAyleid.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureDwemer.maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_AYLEID].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_DWEMER].maxDistance = maxDistance / 1000
			RedrawCompassPinsOnly(PINS_AYLEID)
			RedrawCompassPinsOnly(PINS_DWEMER)
		end,
		disabled = function() return 
			(not DestinationsCSSV.filters[PINS_AYLEID] and
			not DestinationsCSSV.filters[PINS_DWEMER]) or
			not DestinationsCSSV.filters[PINS_MISC_COMPASS]
		end,
		default = defaults.pins.pinTextureAyleid.maxDistance * 1000,
	})
	MiscPOIsubmenuControls:insert({ -- Ayleid Well/Dwemer/Champion pin layer
		type = "slider",
		name = GetString(DEST_SETTINGS_MISC_PIN_LAYER),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureAyleid.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureAyleid.level = level
			DestinationsSV.pins.pinTextureDwemer.level = level
			DestinationsSV.pins.pinTextureChampion.level = level
			LMP:SetLayoutKey(PINS_AYLEID, "level", level)
			LMP:SetLayoutKey(PINS_DWEMER, "level", level)
			LMP:SetLayoutKey(PINS_CHAMPION, "level", level)
			RedrawAllPins(PINS_AYLEID)
			RedrawAllPins(PINS_DWEMER)
			RedrawAllPins(PINS_CHAMPION)
		end,
		disabled = function() return
			not DestinationsCSSV.filters[PINS_AYLEID] and
			not DestinationsCSSV.filters[PINS_DWEMER] and
			not DestinationsCSSV.filters[PINS_CHAMPION]
		end,
		default = defaults.pins.pinTextureAyleid.level
	})
	MiscPOIsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	MiscPOIsubmenuControls:insert({ -- Craglorn Border pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_MISC_BORDER_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_MISC_BORDER_PIN_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_BORDER) end,
		setFunc = function(state)
			TogglePins(PINS_BORDER, state)
			RedrawAllPins(PINS_BORDER)
		end,
		default = defaults.filters[PINS_BORDER],
	})
	MiscPOIsubmenuControls:insert({ -- Craglorn Border pintype
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureBorder",
		choices = pinTexturesListBorder,
		getFunc = function() return pinTexturesListBorder[DestinationsSV.pins.pinTextureBorder.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListBorder) do
				if name == selected then
					DestinationsSV.pins.pinTextureBorder.type = index
					LMP:SetLayoutKey(PINS_BORDER, "texture", pinTextures.border[index])
					CraglornBorderPreview:SetTexture(pinTextures.border[index])
					RedrawAllPins(PINS_BORDER)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_BORDER] end,
		default = pinTexturesListWWVamp[defaults.pins.pinTextureBorder.type],
	})
	MiscPOIsubmenuControls:insert({ -- Craglorn Border pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_MISC_BORDER_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureBorder.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureBorder.size = size
			CraglornBorderPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_BORDER, "size", size)
			RedrawAllPins(PINS_BORDER)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_BORDER] end,
		default = defaults.pins.pinTextureBorder.size
	})
	MiscPOIsubmenuControls:insert({ -- Craglorn Border pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_MISC_BORDER_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_MISC_BORDER_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureBorder.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureBorder.tint = {r, g, b, a}
			LMP:SetLayoutKey(PINS_BORDER, "tint", ZO_ColorDef:New(r, g, b, a))
			CraglornBorderPreview:SetColor(r, g, b, a)
			RedrawAllPins(PINS_BORDER)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_BORDER] end,
		default = {r = defaults.pins.pinTextureBorder.tint[1], g = defaults.pins.pinTextureBorder.tint[2], b = defaults.pins.pinTextureBorder.tint[3], a = defaults.pins.pinTextureBorder.tint[4]}
	})
--PINS_BORDER_COMPASS
------------------------------------------------------------------------
---------------------------VAMPIRE & WEREWOLF --------------------------
------------------------------------------------------------------------
	optionsTable:insert({ -- VWW submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextVWW:Colorize(GetString(DEST_SETTINGS_VWW_HEADER)),
		tooltip = GetString(DEST_SETTINGS_VWW_HEADER_TT),
		width = "full",
		controls = setmetatable({}, { __index = table })
	})
	local VWWsubmenuControls = optionsTable[#optionsTable].controls
	VWWsubmenuControls:insert({ -- Werewolf/Vampire pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_VWW_PIN_WWVAMP_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_VWW_PIN_WWVAMP_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_WWVAMP) end,
		setFunc = function(state)
			TogglePins(PINS_WWVAMP, state)
			RedrawAllPins(PINS_WWVAMP)
		end,
		default = defaults.filters[PINS_WWVAMP],
	})
	VWWsubmenuControls:insert({ -- Werewolf/Vampire pintype
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureWWVamp",
		choices = pinTexturesListWWVamp,
		getFunc = function() return pinTexturesListWWVamp[DestinationsSV.pins.pinTextureWWVamp.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListWWVamp) do
				if name == selected then
					DestinationsSV.pins.pinTextureWWVamp.type = index
					LMP:SetLayoutKey(PINS_WWVAMP, "texture", pinTextures.wwvamp[index])
					WWVampPreview:SetTexture(pinTextures.wwvamp[index])
					RedrawAllPins(PINS_WWVAMP)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_WWVAMP] end,
		default = pinTexturesListWWVamp[defaults.pins.pinTextureWWVamp.type],
	})
	VWWsubmenuControls:insert({ -- Werewolf/Vampire pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_VWW_PIN_WWVAMP_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureWWVamp.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureWWVamp.size = size
			WWVampPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_WWVAMP, "size", size)
			RedrawAllPins(PINS_WWVAMP)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_WWVAMP] end,
		default = defaults.pins.pinTextureWWVamp.size
	})
	VWWsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	VWWsubmenuControls:insert({ -- Vampire Alter pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_VWW_PIN_VAMP_ALTAR_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_VWW_PIN_VAMP_ALTAR_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_VAMPIRE_ALTAR) end,
		setFunc = function(state)
			TogglePins(PINS_VAMPIRE_ALTAR, state)
			RedrawAllPins(PINS_VAMPIRE_ALTAR)
		end,
		default = defaults.filters[PINS_VAMPIRE_ALTAR],
	})
	VWWsubmenuControls:insert({ -- Vampire Alter pintype
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureVampAltar",
		choices = pinTexturesListVampAltar,
		getFunc = function() return pinTexturesListVampAltar[DestinationsSV.pins.pinTextureVampAltar.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListVampAltar) do
				if name == selected then
					DestinationsSV.pins.pinTextureVampAltar.type = index
					LMP:SetLayoutKey(PINS_VAMPIRE_ALTAR, "texture", pinTextures.vampirealtar[index])
					VampAltarPreview:SetTexture(pinTextures.vampirealtar[index])
					RedrawAllPins(PINS_VAMPIRE_ALTAR)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] end,
		default = pinTexturesListVampAltar[defaults.pins.pinTextureVampAltar.type],
	})
	VWWsubmenuControls:insert({ -- Vampire Alter pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_VWW_PIN_VAMP_ALTAR_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureVampAltar.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureVampAltar.size = size
			VampAltarPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_VAMPIRE_ALTAR, "size", size)
			RedrawAllPins(PINS_VAMPIRE_ALTAR)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] end,
		default = defaults.pins.pinTextureVampAltar.size
	})
	VWWsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	VWWsubmenuControls:insert({ -- Werewolf Shrine pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_VWW_PIN_WW_SHRINE_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_VWW_PIN_WW_SHRINE_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_WEREWOLF_SHRINE) end,
		setFunc = function(state)
			TogglePins(PINS_WEREWOLF_SHRINE, state)
			RedrawAllPins(PINS_WEREWOLF_SHRINE)
		end,
		default = defaults.filters[PINS_WEREWOLF_SHRINE],
	})
	VWWsubmenuControls:insert({ -- Werewolf Shrine pintype
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureWWShrine",
		choices = pinTexturesListWWShrine,
		getFunc = function() return pinTexturesListWWShrine[DestinationsSV.pins.pinTextureWWShrine.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListWWShrine) do
				if name == selected then
					DestinationsSV.pins.pinTextureWWShrine.type = index
					LMP:SetLayoutKey(PINS_WEREWOLF_SHRINE, "texture", pinTextures.werewolfshrine[index])
					WWShrinePreview:SetTexture(pinTextures.werewolfshrine[index])
					RedrawAllPins(PINS_WEREWOLF_SHRINE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE] end,
		default = pinTexturesListWWShrine[defaults.pins.pinTextureWWShrine.type],
	})
	VWWsubmenuControls:insert({ -- Werewolf Shrine pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_VWW_PIN_WW_SHRINE_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureWWShrine.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureWWShrine.size = size
			WWShrinePreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_WEREWOLF_SHRINE, "size", size)
			RedrawAllPins(PINS_WEREWOLF_SHRINE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE] end,
		default = defaults.pins.pinTextureWWShrine.size
	})
	VWWsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	VWWsubmenuControls:insert({ -- Werewolf/Vampire toggle compass
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_VWW_COMPASS_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return DestinationsCSSV.filters[PINS_VWW_COMPASS] end,
		setFunc = function(state)
			TogglePins(PINS_VWW_COMPASS, state)
			RedrawCompassPinsOnly(PINS_WWVAMP)
			RedrawCompassPinsOnly(PINS_VAMPIRE_ALTAR)
			RedrawCompassPinsOnly(PINS_WEREWOLF_SHRINE)
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_WWVAMP] and
			not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] and
			not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE]
		end,
		default = defaults.filters[PINS_VWW_COMPASS],
	})
	VWWsubmenuControls:insert({ -- Werewolf/Vampire compass pin distance
		type = "slider",
		name = GetString(DEST_SETTINGS_VWW_COMPASS_DIST),
		min = 1,
		max = 100,
		getFunc = function() return DestinationsSV.pins.pinTextureWWShrine.maxDistance * 1000 end,
		setFunc = function(maxDistance)
			DestinationsSV.pins.pinTextureWWVamp.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureWWShrine.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureVampAltar.maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_WWVAMP].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_VAMPIRE_ALTAR].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_WEREWOLF_SHRINE].maxDistance = maxDistance / 1000
			RedrawCompassPinsOnly(PINS_WWVAMP)
			RedrawCompassPinsOnly(PINS_VAMPIRE_ALTAR)
			RedrawCompassPinsOnly(PINS_WEREWOLF_SHRINE)
		end,
		disabled = function() return 
			(not DestinationsCSSV.filters[PINS_WWVAMP] and
			not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] and
			not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE]) or
			not DestinationsCSSV.filters[PINS_VWW_COMPASS]
		end,
		default = defaults.pins.pinTextureWWShrine.maxDistance * 1000,
	})
	VWWsubmenuControls:insert({ -- Werewolf/Vampire pin layer
		type = "slider",
		name = GetString(DEST_SETTINGS_VWW_PIN_LAYER),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureWWShrine.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureWWVamp.level = level
			DestinationsSV.pins.pinTextureWWShrine.level = level
			DestinationsSV.pins.pinTextureVampAltar.level = level
			LMP:SetLayoutKey(PINS_WWVAMP, "level", level)
			LMP:SetLayoutKey(PINS_VAMPIRE_ALTAR, "level", level)
			LMP:SetLayoutKey(PINS_WEREWOLF_SHRINE, "level", level)
			RedrawAllPins(PINS_WWVAMP)
			RedrawAllPins(PINS_VAMPIRE_ALTAR)
			RedrawAllPins(PINS_WEREWOLF_SHRINE)
		end,
		disabled = function() return
			not DestinationsCSSV.filters[PINS_WWVAMP] and
			not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] and
			not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE]
		end,
		default = defaults.pins.pinTextureWWShrine.level
	})
	VWWsubmenuControls:insert({ -- Werewolf/Vampire pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_VWW_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_VWW_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureWWVamp.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureWWVamp.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureVampAltar.tint = {r, g, b, a}
			DestinationsSV.pins.pinTextureWWShrine.tint = {r, g, b, a}
			LMP:SetLayoutKey(PINS_WWVAMP, "tint", ZO_ColorDef:New(r, g, b, a))
			WWVampPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_VAMPIRE_ALTAR, "tint", ZO_ColorDef:New(r, g, b, a))
			VampAltarPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_WEREWOLF_SHRINE, "tint", ZO_ColorDef:New(r, g, b, a))
			WWShrinePreview:SetColor(r, g, b, a)
			RedrawAllPins(PINS_WWVAMP)
			RedrawAllPins(PINS_VAMPIRE_ALTAR)
			RedrawAllPins(PINS_WEREWOLF_SHRINE)
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_WWVAMP] and
			not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] and
			not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE]
		end,
		default = {r = defaults.pins.pinTextureWWVamp.tint[1], g = defaults.pins.pinTextureWWVamp.tint[2], b = defaults.pins.pinTextureWWVamp.tint[3], a = defaults.pins.pinTextureWWVamp.tint[4]}
	})
	VWWsubmenuControls:insert({ -- Werewolf/Vampire pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_VWW_PINTEXT_COLOR),
		tooltip = GetString(DEST_SETTINGS_VWW_PINTEXT_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureWWVamp.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureWWVamp.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureVampAltar.textcolor = {r, g, b}
			DestinationsSV.pins.pinTextureWWShrine.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_WWVAMP)
			LMP:RefreshPins(PINS_VAMPIRE_ALTAR)
			LMP:RefreshPins(PINS_WEREWOLF_SHRINE)
		end,
		disabled = function() return 
			not DestinationsCSSV.filters[PINS_WWVAMP] and
			not DestinationsCSSV.filters[PINS_VAMPIRE_ALTAR] and
			not DestinationsCSSV.filters[PINS_WEREWOLF_SHRINE]
		end,
		default = {r = defaults.pins.pinTextureWWVamp.textcolor[1], g = defaults.pins.pinTextureWWVamp.textcolor[2], b = defaults.pins.pinTextureWWVamp.textcolor[3]}
	})
------------------------------------------------------------------------
---------------------------------QUESTS---------------------------------
------------------------------------------------------------------------
	optionsTable:insert({ -- Quests submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextQuests:Colorize(GetString(DEST_SETTINGS_QUEST_HEADER)),
		tooltip = GetString(DEST_SETTINGS_QUEST_HEADER_TT),
		width = "full",	--or "half" (optional)
		controls = setmetatable({}, { __index = table })
	})
	local QuestssubmenuControls = optionsTable[#optionsTable].controls
	QuestssubmenuControls:insert({ -- Undone Quest pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_QUEST_UNDONE_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_QUESTS_UNDONE) end,
		setFunc = function(state)
			TogglePins(PINS_QUESTS_UNDONE, state)
			RedrawAllPins(PINS_QUESTS_UNDONE)
		end,
		default = defaults.filters[PINS_QUESTS_UNDONE],
	})
	QuestssubmenuControls:insert({ -- Undone Quest pin style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureQuestsUndone",
		choices = pinTexturesListQuests,
		getFunc = function() return pinTexturesListQuests[DestinationsSV.pins.pinTextureQuestsUndone.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListQuests) do
				if name == selected then
					DestinationsSV.pins.pinTextureQuestsUndone.type = index
					LMP:SetLayoutKey(PINS_QUESTS_UNDONE, "texture", pinTextures.Quests[index])
					QuestsUndonePreview:SetTexture(pinTextures.Quests[index])
					RedrawAllPins(PINS_QUESTS_UNDONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] end,
		default = pinTexturesListQuests[defaults.pins.pinTextureQuestsUndone.type],
	})
	QuestssubmenuControls:insert({ -- Undone Quest pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_QUEST_UNDONE_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureQuestsUndone.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureQuestsUndone.size = size
			QuestsUndonePreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_QUESTS_UNDONE, "size", size)
			RedrawAllPins(PINS_QUESTS_UNDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] end,
		default = defaults.pins.pinTextureQuestsUndone.size
	})
	QuestssubmenuControls:insert({ -- Undone Quest pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_QUEST_UNDONE_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_QUEST_UNDONE_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureQuestsUndone.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureQuestsUndone.tint = {r, g, b, a}
			QuestsUndonePreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_QUESTS_UNDONE, "tint", ZO_ColorDef:New(r, g, b, a))
			LMP:RefreshPins(PINS_QUESTS_UNDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] end,
		default = {r = defaults.pins.pinTextureQuestsUndone.tint[1], g = defaults.pins.pinTextureQuestsUndone.tint[2], b = defaults.pins.pinTextureQuestsUndone.tint[3], a = defaults.pins.pinTextureQuestsUndone.tint[4]}
	})
	QuestssubmenuControls:insert({ -- Undone Quest pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_QUEST_UNDONE_PINTEXT_COLOR),
		tooltip = GetString(DEST_SETTINGS_QUEST_UNDONE_PINTEXT_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureQuestsUndone.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureQuestsUndone.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_QUESTS_UNDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] end,
		default = {r = defaults.pins.pinTextureQuestsUndone.textcolor[1], g = defaults.pins.pinTextureQuestsUndone.textcolor[2], b = defaults.pins.pinTextureQuestsUndone.textcolor[3]}
	})
	QuestssubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	QuestssubmenuControls:insert({ -- In Progress Quest pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_QUEST_INPROGRESS_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_QUESTS_IN_PROGRESS) end,
		setFunc = function(state)
			TogglePins(PINS_QUESTS_IN_PROGRESS, state)
			RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
		end,
		default = defaults.filters[PINS_QUESTS_IN_PROGRESS],
	})
	QuestssubmenuControls:insert({ -- In Progress Quest pin style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureQuestsInProgress",
		choices = pinTexturesListQuests,
		getFunc = function() return pinTexturesListQuests[DestinationsSV.pins.pinTextureQuestsInProgress.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListQuests) do
				if name == selected then
					DestinationsSV.pins.pinTextureQuestsInProgress.type = index
					LMP:SetLayoutKey(PINS_QUESTS_IN_PROGRESS, "texture", pinTextures.Quests[index])
					QuestsInProgressPreview:SetTexture(pinTextures.Quests[index])
					RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] end,
		default = pinTexturesListQuests[defaults.pins.pinTextureQuestsInProgress.type],
	})
	QuestssubmenuControls:insert({ -- In Progress Quest pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_QUEST_INPROGRESS_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureQuestsInProgress.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureQuestsInProgress.size = size
			QuestsInProgressPreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_QUESTS_IN_PROGRESS, "size", size)
			RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] end,
		default = defaults.pins.pinTextureQuestsInProgress.size
	})
	QuestssubmenuControls:insert({ -- In Progress Quest pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_QUEST_INPROGRESS_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_QUEST_INPROGRESS_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureQuestsInProgress.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureQuestsInProgress.tint = {r, g, b, a}
			QuestsInProgressPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_QUESTS_IN_PROGRESS, "tint", ZO_ColorDef:New(r, g, b, a))
			LMP:RefreshPins(PINS_QUESTS_IN_PROGRESS)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] end,
		default = {r = defaults.pins.pinTextureQuestsInProgress.tint[1], g = defaults.pins.pinTextureQuestsInProgress.tint[2], b = defaults.pins.pinTextureQuestsInProgress.tint[3], a = defaults.pins.pinTextureQuestsInProgress.tint[4]}
	})
	QuestssubmenuControls:insert({ -- In Progress Quest pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_QUEST_INPROGRESS_PINTEXT_COLOR),
		tooltip = GetString(DEST_SETTINGS_QUEST_INPROGRESS_PINTEXT_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureQuestsInProgress.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureQuestsInProgress.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_QUESTS_IN_PROGRESS)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] end,
		default = {r = defaults.pins.pinTextureQuestsInProgress.textcolor[1], g = defaults.pins.pinTextureQuestsInProgress.textcolor[2], b = defaults.pins.pinTextureQuestsInProgress.textcolor[3]}
	})
	QuestssubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	QuestssubmenuControls:insert({ -- Done Quest pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_QUEST_DONE_PIN_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_QUESTS_DONE) end,
		setFunc = function(state)
			TogglePins(PINS_QUESTS_DONE, state)
			RedrawAllPins(PINS_QUESTS_DONE)
		end,
		default = defaults.filters[PINS_QUESTS_DONE],
	})
	QuestssubmenuControls:insert({ -- Done Quest pin style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureQuestsDone",
		choices = pinTexturesListQuests,
		getFunc = function() return pinTexturesListQuests[DestinationsSV.pins.pinTextureQuestsDone.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListQuests) do
				if name == selected then
					DestinationsSV.pins.pinTextureQuestsDone.type = index
					LMP:SetLayoutKey(PINS_QUESTS_DONE, "texture", pinTextures.Quests[index])
					QuestsDonePreview:SetTexture(pinTextures.Quests[index])
					RedrawAllPins(PINS_QUESTS_DONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_DONE] end,
		default = pinTexturesListQuests[defaults.pins.pinTextureQuestsDone.type],
	})
	QuestssubmenuControls:insert({ -- Done Quest pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_QUEST_DONE_PIN_SIZE),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureQuestsDone.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureQuestsDone.size = size
			QuestsDonePreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_QUESTS_DONE, "size", size)
			RedrawAllPins(PINS_QUESTS_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_DONE] end,
		default = defaults.pins.pinTextureQuestsDone.size
	})
	QuestssubmenuControls:insert({ -- Done Quest pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_QUEST_DONE_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_QUEST_DONE_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureQuestsDone.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureQuestsDone.tint = {r, g, b, a}
			QuestsDonePreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_QUESTS_DONE, "tint", ZO_ColorDef:New(r, g, b, a))
			LMP:RefreshPins(PINS_QUESTS_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_DONE] end,
		default = {r = defaults.pins.pinTextureQuestsDone.tint[1], g = defaults.pins.pinTextureQuestsDone.tint[2], b = defaults.pins.pinTextureQuestsDone.tint[3], a = defaults.pins.pinTextureQuestsDone.tint[4]}
	})
	QuestssubmenuControls:insert({ -- Done Quest pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_QUEST_DONE_PINTEXT_COLOR),
		tooltip = GetString(DEST_SETTINGS_QUEST_DONE_PINTEXT_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureQuestsDone.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureQuestsDone.textcolor = {r, g, b}
			LMP:RefreshPins(PINS_QUESTS_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_DONE] end,
		default = {r = defaults.pins.pinTextureQuestsDone.textcolor[1], g = defaults.pins.pinTextureQuestsDone.textcolor[2], b = defaults.pins.pinTextureQuestsDone.textcolor[3]}
	})
	QuestssubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	QuestssubmenuControls:insert({ -- Global Quest on compass toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_QUEST_COMPASS_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return DestinationsCSSV.filters[PINS_QUESTS_COMPASS] end,
		setFunc = function(state)
			TogglePins(PINS_QUESTS_COMPASS, state)
			RedrawCompassPinsOnly(PINS_QUESTS_UNDONE)
			RedrawCompassPinsOnly(PINS_QUESTS_IN_PROGRESS)
			RedrawCompassPinsOnly(PINS_QUESTS_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] and not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] and not DestinationsCSSV.filters[PINS_QUESTS_DONE] end,
		default = defaults.filters[PINS_QUESTS_COMPASS],
	})
	QuestssubmenuControls:insert({ -- Global Quest compass distance
		type = "slider",
		name = GetString(DEST_SETTINGS_QUEST_COMPASS_DIST),
		min = 1,
		max = 100,
		getFunc = function() return DestinationsSV.pins.pinTextureQuestsUndone.maxDistance * 1000 end,
		setFunc = function(maxDistance)
			DestinationsSV.pins.pinTextureQuestsUndone.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureQuestsInProgress.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureQuestsDone.maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_QUESTS_UNDONE].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_QUESTS_IN_PROGRESS].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_QUESTS_DONE].maxDistance = maxDistance / 1000
			RedrawCompassPinsOnly(PINS_QUESTS_UNDONE)
			RedrawCompassPinsOnly(PINS_QUESTS_IN_PROGRESS)
			RedrawCompassPinsOnly(PINS_QUESTS_DONE)
		end,
		width = "full",
		disabled = function() return (not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] and not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] and not DestinationsCSSV.filters[PINS_QUESTS_DONE]) or not DestinationsCSSV.filters[PINS_QUESTS_COMPASS] end,
		default = defaults.pins.pinTextureQuestsUndone.maxDistance * 1000,
	})
	QuestssubmenuControls:insert({ -- Global Quest pin layer
		type = "slider",
		name = GetString(DEST_SETTINGS_QUEST_ALL_PIN_LAYER),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureQuestsUndone.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureQuestsUndone.level = level + 1
			DestinationsSV.pins.pinTextureQuestsInProgress.level = level + 2
			DestinationsSV.pins.pinTextureQuestsDone.level = level
			LMP:SetLayoutKey(PINS_QUESTS_UNDONE, "level", level + 1)
			LMP:SetLayoutKey(PINS_QUESTS_IN_PROGRESS, "level", level + 2)
			LMP:SetLayoutKey(PINS_QUESTS_DONE, "level", level)
			RedrawAllPins(PINS_QUESTS_UNDONE)
			RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
			RedrawAllPins(PINS_QUESTS_DONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] and not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] and not DestinationsCSSV.filters[PINS_QUESTS_DONE] end,
		default = defaults.pins.pinTextureQuestsUndone.level
	})
	QuestssubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	QuestssubmenuControls:insert({ -- Register Quests toggle
		type = "checkbox",
		width = "full",
		name = GetString(DEST_SETTINGS_REGISTER_QUESTS_TOGGLE),
		tooltip = GetString(DEST_SETTINGS_REGISTER_QUESTS_TOGGLE_TT),
		getFunc = function() return DestinationsSV.filters[REGISTER_QUESTS] end,
		setFunc = function(state) DestinationsSV.filters[REGISTER_QUESTS] = state end,
		disabled = function() return not DestinationsCSSV.filters[PINS_QUESTS_UNDONE] and not DestinationsCSSV.filters[PINS_QUESTS_IN_PROGRESS] and not DestinationsCSSV.filters[PINS_QUESTS_DONE] end,
		default = defaults.filters[REGISTER_QUESTS],
	})
	QuestssubmenuControls:insert({ -- Reset Hidden Quests Button
		type = "button",
		name = defaults.miscColorCodes.settingsTextWarn:Colorize(GetString(DEST_SETTINGS_QUEST_RESET_HIDDEN)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_QUEST_RESET_HIDDEN_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_BUTTON_TT)),
		width = "full",
		func = function()
			ResetHiddenQuests()
			RedrawAllPins(PINS_QUESTS_UNDONE)
			RedrawAllPins(PINS_QUESTS_IN_PROGRESS)
			RedrawAllPins(PINS_QUESTS_DONE)
		end,
	})
------------------------------------------------------------------------
------------------------------COLLECTIBLES------------------------------
------------------------------------------------------------------------
	optionsTable:insert({ -- Collectible submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextCollectibles:Colorize(GetString(DEST_SETTINGS_COLLECTIBLES_HEADER)),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_HEADER_TT),
		width = "full",
		controls = setmetatable({}, { __index = table })
	})
	local CollectiblesubmenuControls = optionsTable[#optionsTable].controls
	CollectiblesubmenuControls:insert({ -- Collectible pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_COLLECTIBLES_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_COLLECTIBLES) end,
		setFunc = function(state)
			TogglePins(PINS_COLLECTIBLES, state)
			RedrawAllPins(PINS_COLLECTIBLES)
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		default = defaults.filters[PINS_COLLECTIBLES],
	})
	CollectiblesubmenuControls:insert({ -- Collectible pin style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureCollectible",
		choices = pinTexturesListCollectible,
		getFunc = function() return pinTexturesListCollectible[DestinationsSV.pins.pinTextureCollectible.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListCollectible) do
				if name == selected then
					DestinationsSV.pins.pinTextureCollectible.type = index
					DestinationsSV.pins.pinTextureCollectibleDone.type = index
					LMP:SetLayoutKey(PINS_COLLECTIBLES, "texture", pinTextures.collectible[index])
					LMP:SetLayoutKey(PINS_COLLECTIBLESDONE, "texture", pinTextures.collectibledone[index])
					CollectiblePreview:SetTexture(pinTextures.collectible[index])
					CollectibleDonePreview:SetTexture(pinTextures.collectible[index])
					RedrawAllPins(PINS_COLLECTIBLES)
					RedrawAllPins(PINS_COLLECTIBLESDONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = pinTexturesListCollectible[defaults.pins.pinTextureCollectible.type],
	})
	CollectiblesubmenuControls:insert({ -- Collectible Name on pin toggle
		type = "checkbox",
		width = "full",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_SHOW_MOBNAME),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_SHOW_MOBNAME_TT),
		getFunc = function() return DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_MOBNAME] end,
		setFunc = function(state)
			DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_MOBNAME] = state
			RedrawAllPins(PINS_COLLECTIBLES)
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		default = defaults.filters[PINS_COLLECTIBLES_SHOW_MOBNAME],
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
	})
	CollectiblesubmenuControls:insert({ -- Collectible Item on pin toggle
		type = "checkbox",
		width = "full",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_SHOW_ITEM),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_SHOW_ITEM_TT),
		getFunc = function() return DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_ITEM] end,
		setFunc = function(state)
			DestinationsSV.filters[PINS_COLLECTIBLES_SHOW_ITEM] = state
			RedrawAllPins(PINS_COLLECTIBLES)
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		default = defaults.filters[PINS_COLLECTIBLES_SHOW_ITEM],
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
	})
	CollectiblesubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	CollectiblesubmenuControls:insert({ -- Collectible title pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_COLOR_TITLE),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_COLOR_TITLE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureCollectible.textcolortitle) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureCollectible.textcolortitle = {r, g, b}
			RedrawAllPins(PINS_COLLECTIBLES)
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = {r = defaults.pins.pinTextureCollectible.textcolortitle[1], g = defaults.pins.pinTextureCollectible.textcolortitle[2], b = defaults.pins.pinTextureCollectible.textcolortitle[3]}
	})
	CollectiblesubmenuControls:insert({ -- Collectible Missing pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureCollectible.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureCollectible.tint = {r, g, b, a}
			CollectiblePreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_COLLECTIBLES, "tint", ZO_ColorDef:New(r, g, b, a))
			LMP:RefreshPins(PINS_COLLECTIBLES)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = {r = defaults.pins.pinTextureCollectible.tint[1], g = defaults.pins.pinTextureCollectible.tint[2], b = defaults.pins.pinTextureCollectible.tint[3], a = defaults.pins.pinTextureCollectible.tint[4]}
	})
	CollectiblesubmenuControls:insert({ -- Collectible Missing pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_COLOR_UNDONE),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_COLOR_UNDONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureCollectible.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureCollectible.textcolor = {r, g, b}
			RedrawAllPins(PINS_COLLECTIBLES)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = {r = defaults.pins.pinTextureCollectible.textcolor[1], g = defaults.pins.pinTextureCollectible.textcolor[2], b = defaults.pins.pinTextureCollectible.textcolor[3]}
	})
	CollectiblesubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	CollectiblesubmenuControls:insert({ -- Collectible Completed pin toggle
		type = "checkbox",
		width = "full",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_COLLECTIBLES_DONE_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_DONE_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_COLLECTIBLESDONE) end,
		setFunc = function(state)
			TogglePins(PINS_COLLECTIBLESDONE, state)
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = defaults.filters[PINS_COLLECTIBLESDONE],
	})
	CollectiblesubmenuControls:insert({ -- Collectible Completed pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_COLOR_DONE),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_COLOR_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureCollectibleDone.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureCollectibleDone.tint = {r, g, b, a}
			CollectibleDonePreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_COLLECTIBLESDONE, "tint", ZO_ColorDef:New(r, g, b, a))
			LMP:RefreshPins(PINS_COLLECTIBLESDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLESDONE] end,
		default = {r = defaults.pins.pinTextureCollectibleDone.tint[1], g = defaults.pins.pinTextureCollectibleDone.tint[2], b = defaults.pins.pinTextureCollectibleDone.tint[3], a = defaults.pins.pinTextureCollectibleDone.tint[4]}
	})
	CollectiblesubmenuControls:insert({ -- Collectible Completed pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_COLOR_DONE),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_COLOR_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureCollectibleDone.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureCollectibleDone.textcolor = {r, g, b}
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLESDONE] end,
		default = {r = defaults.pins.pinTextureCollectibleDone.textcolor[1], g = defaults.pins.pinTextureCollectibleDone.textcolor[2], b = defaults.pins.pinTextureCollectibleDone.textcolor[3]}
	})
	CollectiblesubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	CollectiblesubmenuControls:insert({ -- Collectible on compass toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_COLLECTIBLES_COMPASS_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_COMPASS_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return DestinationsCSSV.filters[PINS_COLLECTIBLES_COMPASS] end,
		setFunc = function(state)
			TogglePins(PINS_COLLECTIBLES_COMPASS, state)
			RedrawCompassPinsOnly(PINS_COLLECTIBLES)
			RedrawCompassPinsOnly(PINS_COLLECTIBLESDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = defaults.filters[PINS_COLLECTIBLES_COMPASS],
	})
	CollectiblesubmenuControls:insert({ -- Collectible compass distance
		type = "slider",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_COMPASS_DIST),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_COMPASS_DIST_TT),
		min = 1,
		max = 100,
		getFunc = function() return DestinationsSV.pins.pinTextureCollectible.maxDistance * 1000 end,
		setFunc = function(maxDistance)
			DestinationsSV.pins.pinTextureCollectible.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureCollectibleDone.maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_COLLECTIBLES].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_COLLECTIBLESDONE].maxDistance = maxDistance / 1000
			RedrawCompassPinsOnly(PINS_COLLECTIBLES)
			RedrawCompassPinsOnly(PINS_COLLECTIBLESDONE)
		end,
		width = "full",
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] or not DestinationsCSSV.filters[PINS_COLLECTIBLES_COMPASS] end,
		default = defaults.pins.pinTextureCollectible.maxDistance * 1000,
	})
	CollectiblesubmenuControls:insert({ -- Collectible pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_SIZE),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_SIZE_TT),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureCollectible.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureCollectible.size = size
			DestinationsSV.pins.pinTextureCollectibleDone.size = size
			CollectiblePreview:SetDimensions(size, size)
			CollectibleDonePreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_COLLECTIBLES, "size", size)
			LMP:SetLayoutKey(PINS_COLLECTIBLESDONE, "size", size)
			RedrawAllPins(PINS_COLLECTIBLES)
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = defaults.pins.pinTextureCollectible.size
	})
	CollectiblesubmenuControls:insert({ -- Collectible pin layer
		type = "slider",
		name = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_LAYER),
		tooltip = GetString(DEST_SETTINGS_COLLECTIBLES_PIN_LAYER_TT),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureCollectible.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureCollectible.level = level
			DestinationsSV.pins.pinTextureCollectibleDone.level = level - 1
			LMP:SetLayoutKey(PINS_COLLECTIBLES, "level", level)
			LMP:SetLayoutKey(PINS_COLLECTIBLESDONE, "level", level - 1)
			RedrawAllPins(PINS_COLLECTIBLES)
			RedrawAllPins(PINS_COLLECTIBLESDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_COLLECTIBLES] end,
		default = defaults.pins.pinTextureCollectible.level
	})
------------------------------------------------------------------------
--------------------------------FISHING---------------------------------
------------------------------------------------------------------------
	optionsTable:insert({ -- Fish submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextFish:Colorize(GetString(DEST_SETTINGS_FISHING_HEADER)),
		tooltip = GetString(DEST_SETTINGS_FISHING_HEADER_TT),
		width = "full",
		controls = setmetatable({}, { __index = table })
	})
	local FishsubmenuControls = optionsTable[#optionsTable].controls
	FishsubmenuControls:insert({ -- Fish pin toggle
		type = "checkbox",
		width = "half",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_FISHING_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_FISHING_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_FISHING) end,
		setFunc = function(state)
			TogglePins(PINS_FISHING, state)
			RedrawAllPins(PINS_FISHING)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		default = defaults.filters[PINS_FISHING],
	})
	FishsubmenuControls:insert({ -- Fish pin style
		type = "dropdown",
		width = "half",
		reference = "previewpinTextureFish",
		choices = pinTexturesListFish,
		getFunc = function() return pinTexturesListFish[DestinationsSV.pins.pinTextureFish.type] end,
		setFunc = function(selected)
			for index, name in ipairs(pinTexturesListFish) do
				if name == selected then
					DestinationsSV.pins.pinTextureFish.type = index
					DestinationsSV.pins.pinTextureFishDone.type = index
					LMP:SetLayoutKey(PINS_FISHING, "texture", pinTextures.fish[index])
					LMP:SetLayoutKey(PINS_FISHINGDONE, "texture", pinTextures.fishdone[index])
					FishPreview:SetTexture(pinTextures.fish[index])
					FishDonePreview:SetTexture(pinTextures.fishdone[index])
					RedrawAllPins(PINS_FISHING)
					RedrawAllPins(PINS_FISHINGDONE)
					break
				end
			end
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = pinTexturesListFish[defaults.pins.pinTextureFish.type],
	})
	FishsubmenuControls:insert({ -- Fish Name on pin toggle
		type = "checkbox",
		width = "full",
		name = GetString(DEST_SETTINGS_FISHING_SHOW_FISHNAME),
		tooltip = GetString(DEST_SETTINGS_FISHING_SHOW_FISHNAME_TT),
		getFunc = function() return DestinationsSV.filters[PINS_FISHING_SHOW_FISHNAME] end,
		setFunc = function(state)
			DestinationsSV.filters[PINS_FISHING_SHOW_FISHNAME] = state
			RedrawAllPins(PINS_FISHING)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		default = defaults.filters[PINS_FISHING_SHOW_FISHNAME],
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
	})
	FishsubmenuControls:insert({ -- Fish Bait on pin toggle
		type = "checkbox",
		width = "full",
		name = GetString(DEST_SETTINGS_FISHING_SHOW_BAIT),
		tooltip = GetString(DEST_SETTINGS_FISHING_SHOW_BAIT_TT),
		getFunc = function() return DestinationsSV.filters[PINS_FISHING_SHOW_BAIT] end,
		setFunc = function(state)
			DestinationsSV.filters[PINS_FISHING_SHOW_BAIT] = state
			RedrawAllPins(PINS_FISHING)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		default = defaults.filters[PINS_FISHING_SHOW_BAIT],
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
	})
	FishsubmenuControls:insert({ -- Fish Water on pin toggle
		type = "checkbox",
		width = "full",
		name = GetString(DEST_SETTINGS_FISHING_SHOW_WATER),
		tooltip = GetString(DEST_SETTINGS_FISHING_SHOW_WATER_TT),
		getFunc = function() return DestinationsSV.filters[PINS_FISHING_SHOW_WATER] end,
		setFunc = function(state)
			DestinationsSV.filters[PINS_FISHING_SHOW_WATER] = state
			RedrawAllPins(PINS_FISHING)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		default = defaults.filters[PINS_FISHING_SHOW_WATER],
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
	})
	FishsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	FishsubmenuControls:insert({ -- Fish pin title pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_COLOR_TITLE),
		tooltip = GetString(DEST_SETTINGS_FISHING_COLOR_TITLE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFish.textcolortitle) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureFish.textcolortitle = {r, g, b}
			RedrawAllPins(PINS_FISHING)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = {r = defaults.pins.pinTextureFish.textcolortitle[1], g = defaults.pins.pinTextureFish.textcolortitle[2], b = defaults.pins.pinTextureFish.textcolortitle[3]}
	})
	FishsubmenuControls:insert({ -- Fish Missing pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_PIN_COLOR),
		tooltip = GetString(DEST_SETTINGS_FISHING_PIN_COLOR_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFish.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureFish.tint = {r, g, b, a}
			FishPreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_FISHING, "tint", ZO_ColorDef:New(r, g, b, a))
			LMP:RefreshPins(PINS_FISHING)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = {r = defaults.pins.pinTextureFish.tint[1], g = defaults.pins.pinTextureFish.tint[2], b = defaults.pins.pinTextureFish.tint[3], a = defaults.pins.pinTextureFish.tint[4]}
	})
	FishsubmenuControls:insert({ -- Fish Missing pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_COLOR_UNDONE),
		tooltip = GetString(DEST_SETTINGS_FISHING_COLOR_UNDONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFish.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureFish.textcolor = {r, g, b}
			RedrawAllPins(PINS_FISHING)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = {r = defaults.pins.pinTextureFish.textcolor[1], g = defaults.pins.pinTextureFish.textcolor[2], b = defaults.pins.pinTextureFish.textcolor[3]}
	})
	FishsubmenuControls:insert({ -- Fish Missing pin bait text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_COLOR_BAIT_UNDONE),
		tooltip = GetString(DEST_SETTINGS_FISHING_COLOR_BAIT_UNDONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFish.textcolorBait) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureFish.textcolorBait = {r, g, b}
			RedrawAllPins(PINS_FISHING)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = {r = defaults.pins.pinTextureFish.textcolorBait[1], g = defaults.pins.pinTextureFish.textcolorBait[2], b = defaults.pins.pinTextureFish.textcolorBait[3]}
	})
	FishsubmenuControls:insert({ -- Fish Missing pin water text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_COLOR_WATER_UNDONE),
		tooltip = GetString(DEST_SETTINGS_FISHING_COLOR_WATER_UNDONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFish.textcolorWater) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureFish.textcolorWater = {r, g, b}
			RedrawAllPins(PINS_FISHING)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = {r = defaults.pins.pinTextureFish.textcolorWater[1], g = defaults.pins.pinTextureFish.textcolorWater[2], b = defaults.pins.pinTextureFish.textcolorWater[3]}
	})
	FishsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	FishsubmenuControls:insert({ -- Fish Completed pin toggle
		type = "checkbox",
		width = "full",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_FISHING_DONE_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_FISHING_DONE_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return LMP:IsEnabled(PINS_FISHINGDONE) end,
		setFunc = function(state)
			TogglePins(PINS_FISHINGDONE, state)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = defaults.filters[PINS_FISHINGDONE],
	})
	FishsubmenuControls:insert({ -- Fish Completed pin color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_PIN_COLOR_DONE),
		tooltip = GetString(DEST_SETTINGS_FISHING_PIN_COLOR_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFishDone.tint) end,
		setFunc = function(r, g, b, a)
			DestinationsSV.pins.pinTextureFishDone.tint = {r, g, b, a}
			FishDonePreview:SetColor(r, g, b, a)
			LMP:SetLayoutKey(PINS_FISHINGDONE, "tint", ZO_ColorDef:New(r, g, b, a))
			LMP:RefreshPins(PINS_FISHINGDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHINGDONE] end,
		default = {r = defaults.pins.pinTextureFishDone.tint[1], g = defaults.pins.pinTextureFishDone.tint[2], b = defaults.pins.pinTextureFishDone.tint[3], a = defaults.pins.pinTextureFishDone.tint[4]}
	})
	FishsubmenuControls:insert({ -- Fish Completed pin text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_COLOR_DONE),
		tooltip = GetString(DEST_SETTINGS_FISHING_COLOR_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFishDone.textcolor) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureFishDone.textcolor = {r, g, b}
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHINGDONE] end,
		default = {r = defaults.pins.pinTextureFishDone.textcolor[1], g = defaults.pins.pinTextureFishDone.textcolor[2], b = defaults.pins.pinTextureFishDone.textcolor[3]}
	})
	FishsubmenuControls:insert({ -- Fish Completed pin bait text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_COLOR_BAIT_DONE),
		tooltip = GetString(DEST_SETTINGS_FISHING_COLOR_BAIT_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFishDone.textcolorBait) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureFishDone.textcolorBait = {r, g, b}
			RedrawAllPins(PINS_FISHING)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = {r = defaults.pins.pinTextureFishDone.textcolorBait[1], g = defaults.pins.pinTextureFishDone.textcolorBait[2], b = defaults.pins.pinTextureFishDone.textcolorBait[3]}
	})
	FishsubmenuControls:insert({ -- Fish Completed pin water text color
		type = "colorpicker",
		name = GetString(DEST_SETTINGS_FISHING_COLOR_WATER_DONE),
		tooltip = GetString(DEST_SETTINGS_FISHING_COLOR_WATER_DONE_TT),
		getFunc = function() return unpack(DestinationsSV.pins.pinTextureFishDone.textcolorWater) end,
		setFunc = function(r, g, b)
			DestinationsSV.pins.pinTextureFishDone.textcolorWater = {r, g, b}
			RedrawAllPins(PINS_FISHING)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = {r = defaults.pins.pinTextureFishDone.textcolorWater[1], g = defaults.pins.pinTextureFishDone.textcolorWater[2], b = defaults.pins.pinTextureFishDone.textcolorWater[3]}
	})
	FishsubmenuControls:insert({ -- divider
		type = "texture",
		width = "full",
		image = "Destinations/misc/divider.dds",
		imageWidth = 510,
		imageHeight = 9,
		tooltip = "test",
	})
	FishsubmenuControls:insert({ -- Fish on compass toggle
		type = "checkbox",
		name = defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_FISHING_COMPASS_TOGGLE)).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR)),
		tooltip = GetString(DEST_SETTINGS_FISHING_COMPASS_TOGGLE_TT).." "..defaults.miscColorCodes.settingsTextAccountWide:Colorize(GetString(DEST_SETTINGS_PER_CHAR_TOGGLE_TT)),
		getFunc = function() return DestinationsCSSV.filters[PINS_FISHING_COMPASS] end,
		setFunc = function(state)
			TogglePins(PINS_FISHING_COMPASS, state)
			RedrawCompassPinsOnly(PINS_FISHING)
			RedrawCompassPinsOnly(PINS_FISHINGDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = defaults.filters[PINS_FISHING_COMPASS],
	})
	FishsubmenuControls:insert({ -- Fish compass distance
		type = "slider",
		name = GetString(DEST_SETTINGS_FISHING_COMPASS_DIST),
		tooltip = GetString(DEST_SETTINGS_FISHING_COMPASS_DIST_TT),
		min = 1,
		max = 100,
		getFunc = function() return DestinationsSV.pins.pinTextureFish.maxDistance * 1000 end,
		setFunc = function(maxDistance)
			DestinationsSV.pins.pinTextureFish.maxDistance = maxDistance / 1000
			DestinationsSV.pins.pinTextureFishDone.maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_FISHING].maxDistance = maxDistance / 1000
			COMPASS_PINS.pinLayouts[PINS_FISHINGDONE].maxDistance = maxDistance / 1000
			RedrawCompassPinsOnly(PINS_FISHING)
			RedrawCompassPinsOnly(PINS_FISHINGDONE)
		end,
		width = "full",
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] or not DestinationsCSSV.filters[PINS_FISHING_COMPASS] end,
		default = defaults.pins.pinTextureFish.maxDistance * 1000,
	})
	FishsubmenuControls:insert({ -- Fish pin size
		type = "slider",
		name = GetString(DEST_SETTINGS_FISHING_PIN_SIZE),
		tooltip = GetString(DEST_SETTINGS_FISHING_PIN_SIZE_TT),
		min = 20,
		max = 70,
		getFunc = function() return DestinationsSV.pins.pinTextureFish.size end,
		setFunc = function(size)
			DestinationsSV.pins.pinTextureFish.size = size
			DestinationsSV.pins.pinTextureFishDone.size = size
			FishPreview:SetDimensions(size, size)
			FishDonePreview:SetDimensions(size, size)
			LMP:SetLayoutKey(PINS_FISHING, "size", size)
			LMP:SetLayoutKey(PINS_FISHINGDONE, "size", size)
			RedrawAllPins(PINS_FISHING)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = defaults.pins.pinTextureFish.size
	})
	FishsubmenuControls:insert({ -- Fish pin layer
		type = "slider",
		name = GetString(DEST_SETTINGS_FISHING_PIN_LAYER),
		tooltip = GetString(DEST_SETTINGS_FISHING_PIN_LAYER_TT),
		min = 10,
		max = 200,
		step = 5,
		getFunc = function() return DestinationsSV.pins.pinTextureFish.level end,
		setFunc = function(level)
			DestinationsSV.pins.pinTextureFish.level = level
			DestinationsSV.pins.pinTextureFishDone.level = level - 1
			LMP:SetLayoutKey(PINS_FISHING, "level", level)
			LMP:SetLayoutKey(PINS_FISHINGDONE, "level", level - 1)
			RedrawAllPins(PINS_FISHING)
			RedrawAllPins(PINS_FISHINGDONE)
		end,
		disabled = function() return not DestinationsCSSV.filters[PINS_FISHING] end,
		default = defaults.pins.pinTextureFish.level
	})

	optionsTable:insert({ -- Instructions submenu
		type = "submenu",
		name = defaults.miscColorCodes.settingsTextInstructions:Colorize(GetString(INSTRUCTIONS_TEXT_HEADER)),
		width = "full",	--or "half" (optional)
		controls = setmetatable({}, { __index = table })
	})
	local InstructionssubmenuControls = optionsTable[#optionsTable].controls
	InstructionssubmenuControls:insert({ -- Instructions intro
		type = "description",
		text = "|c55FF55"..GetString(INSTRUCTIONS_PART_1).."|r ",
	})
	InstructionssubmenuControls:insert({ -- Instructions /dset
		type = "description",
		text = "|cFFFF55/dset|r "..GetString(INSTRUCTIONS_PART_2),
	})
	InstructionssubmenuControls:insert({ -- Instructions /dqed
		type = "description",
		text = "|cFFFF55/dqed|r "..GetString(INSTRUCTIONS_PART_3),
	})
	LAM:RegisterOptionControls("Destinations_OptionsPanel", optionsTable)
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
function InitVariables()
	if not DestinationsAWSV.settings.useAccountWide then DestinationsAWSV.settings.useAccountWide = defaults.settings.useAccountWide end

	if not DestinationsSV.pins.pinTextureUnknown.maxDistance then DestinationsSV.pins.pinTextureUnknown.maxDistance = defaults.pins.pinTextureUnknown.maxDistance end
	if not DestinationsSV.pins.pinTextureUnknown.type then DestinationsSV.pins.pinTextureUnknown.type = defaults.pins.pinTextureUnknown.type end
	if not DestinationsSV.pins.pinTextureUnknown.level then DestinationsSV.pins.pinTextureUnknown.level = defaults.pins.pinTextureUnknown.level end
	if not DestinationsSV.pins.pinTextureUnknown.size then DestinationsSV.pins.pinTextureUnknown.size = defaults.pins.pinTextureUnknown.size end
	if not DestinationsSV.pins.pinTextureUnknown.tint then DestinationsSV.pins.pinTextureUnknown.tint = defaults.pins.pinTextureUnknown.tint end
	if not DestinationsSV.pins.pinTextureUnknown.textcolor then DestinationsSV.pins.pinTextureUnknown.textcolor = defaults.pins.pinTextureUnknown.textcolor end
	if not DestinationsSV.pins.pinTextureUnknown.textcolorEN then DestinationsSV.pins.pinTextureUnknown.textcolorEN = defaults.pins.pinTextureUnknown.textcolorEN end
	if not DestinationsSV.pins.pinTextureUnknown.textcolorTrader then DestinationsSV.pins.pinTextureUnknown.textcolorTrader = defaults.pins.pinTextureUnknown.textcolorTrader end

	if not DestinationsSV.pins.pinTextureKnown.maxDistance then DestinationsSV.pins.pinTextureKnown.maxDistance = defaults.pins.pinTextureKnown.maxDistance end
	if not DestinationsSV.pins.pinTextureKnown.type then DestinationsSV.pins.pinTextureKnown.type = defaults.pins.pinTextureKnown.type end
	if not DestinationsSV.pins.pinTextureKnown.level then DestinationsSV.pins.pinTextureKnown.level = defaults.pins.pinTextureKnown.level end
	if not DestinationsSV.pins.pinTextureKnown.level then DestinationsSV.pins.pinTextureKnown.size = defaults.pins.pinTextureKnown.size end
	if not DestinationsSV.pins.pinTextureKnown.tint then DestinationsSV.pins.pinTextureKnown.tint = defaults.pins.pinTextureKnown.tint end
	if not DestinationsSV.pins.pinTextureKnown.textcolor then DestinationsSV.pins.pinTextureKnown.textcolor = defaults.pins.pinTextureKnown.textcolor end
	if not DestinationsSV.pins.pinTextureKnown.textcolorEN then DestinationsSV.pins.pinTextureKnown.textcolorEN = defaults.pins.pinTextureKnown.textcolorEN end
	if not DestinationsSV.pins.pinTextureKnown.textcolorTrader then DestinationsSV.pins.pinTextureKnown.textcolorTrader = defaults.pins.pinTextureKnown.textcolorTrader end

	if not DestinationsSV.pins.pinTextureOther.maxDistance then DestinationsSV.pins.pinTextureOther.maxDistance = defaults.pins.pinTextureOther.maxDistance end
	if not DestinationsSV.pins.pinTextureOther.type then DestinationsSV.pins.pinTextureOther.type = defaults.pins.pinTextureOther.type end
	if not DestinationsSV.pins.pinTextureOther.level then DestinationsSV.pins.pinTextureOther.level = defaults.pins.pinTextureOther.level end
	if not DestinationsSV.pins.pinTextureOther.size then DestinationsSV.pins.pinTextureOther.size = defaults.pins.pinTextureOther.size end
	if not DestinationsSV.pins.pinTextureOther.tint then DestinationsSV.pins.pinTextureOther.tint = defaults.pins.pinTextureOther.tint end
	if not DestinationsSV.pins.pinTextureOther.textcolor then DestinationsSV.pins.pinTextureOther.textcolor = defaults.pins.pinTextureOther.textcolor end

	if not DestinationsSV.pins.pinTextureOtherDone.maxDistance then DestinationsSV.pins.pinTextureOtherDone.maxDistance = defaults.pins.pinTextureOtherDone.maxDistance end
	if not DestinationsSV.pins.pinTextureOtherDone.type then DestinationsSV.pins.pinTextureOtherDone.type = defaults.pins.pinTextureOtherDone.type end
	if not DestinationsSV.pins.pinTextureOtherDone.level then DestinationsSV.pins.pinTextureOtherDone.level = defaults.pins.pinTextureOtherDone.level end
	if not DestinationsSV.pins.pinTextureOtherDone.size then DestinationsSV.pins.pinTextureOtherDone.size = defaults.pins.pinTextureOtherDone.size end
	if not DestinationsSV.pins.pinTextureOtherDone.tint then DestinationsSV.pins.pinTextureOtherDone.tint = defaults.pins.pinTextureOtherDone.tint end
	if not DestinationsSV.pins.pinTextureOtherDone.textcolor then DestinationsSV.pins.pinTextureOtherDone.textcolor = defaults.pins.pinTextureOtherDone.textcolor end

	if not DestinationsSV.pins.pinTextureMaiq.maxDistance then DestinationsSV.pins.pinTextureMaiq.maxDistance = defaults.pins.pinTextureMaiq.maxDistance end
	if not DestinationsSV.pins.pinTextureMaiq.type then DestinationsSV.pins.pinTextureMaiq.type = defaults.pins.pinTextureMaiq.type end
	if not DestinationsSV.pins.pinTextureMaiq.level then DestinationsSV.pins.pinTextureMaiq.level = defaults.pins.pinTextureMaiq.level end
	if not DestinationsSV.pins.pinTextureMaiq.size then DestinationsSV.pins.pinTextureMaiq.size = defaults.pins.pinTextureMaiq.size end
	if not DestinationsSV.pins.pinTextureMaiq.tint then DestinationsSV.pins.pinTextureMaiq.tint = defaults.pins.pinTextureMaiq.tint end
	if not DestinationsSV.pins.pinTextureMaiq.textcolor then DestinationsSV.pins.pinTextureMaiq.textcolor = defaults.pins.pinTextureMaiq.textcolor end

	if not DestinationsSV.pins.pinTextureMaiqDone.maxDistance then DestinationsSV.pins.pinTextureMaiqDone.maxDistance = defaults.pins.pinTextureMaiqDone.maxDistance end
	if not DestinationsSV.pins.pinTextureMaiqDone.type then DestinationsSV.pins.pinTextureMaiqDone.type = defaults.pins.pinTextureMaiqDone.type end
	if not DestinationsSV.pins.pinTextureMaiqDone.level then DestinationsSV.pins.pinTextureMaiqDone.level = defaults.pins.pinTextureMaiqDone.level end
	if not DestinationsSV.pins.pinTextureMaiqDone.size then DestinationsSV.pins.pinTextureMaiqDone.size = defaults.pins.pinTextureMaiqDone.size end
	if not DestinationsSV.pins.pinTextureMaiqDone.tint then DestinationsSV.pins.pinTextureMaiqDone.tint = defaults.pins.pinTextureMaiqDone.tint end
	if not DestinationsSV.pins.pinTextureMaiqDone.textcolor then DestinationsSV.pins.pinTextureMaiqDone.textcolor = defaults.pins.pinTextureMaiqDone.textcolor end

	if not DestinationsSV.pins.pinTexturePeacemaker.maxDistance then DestinationsSV.pins.pinTexturePeacemaker.maxDistance = defaults.pins.pinTexturePeacemaker.maxDistance end
	if not DestinationsSV.pins.pinTexturePeacemaker.type then DestinationsSV.pins.pinTexturePeacemaker.type = defaults.pins.pinTexturePeacemaker.type end
	if not DestinationsSV.pins.pinTexturePeacemaker.level then DestinationsSV.pins.pinTexturePeacemaker.level = defaults.pins.pinTexturePeacemaker.level end
	if not DestinationsSV.pins.pinTexturePeacemaker.size then DestinationsSV.pins.pinTexturePeacemaker.size = defaults.pins.pinTexturePeacemaker.size end
	if not DestinationsSV.pins.pinTexturePeacemaker.tint then DestinationsSV.pins.pinTexturePeacemaker.tint = defaults.pins.pinTexturePeacemaker.tint end
	if not DestinationsSV.pins.pinTexturePeacemaker.textcolor then DestinationsSV.pins.pinTexturePeacemaker.textcolor = defaults.pins.pinTexturePeacemaker.textcolor end

	if not DestinationsSV.pins.pinTexturePeacemakerDone.maxDistance then DestinationsSV.pins.pinTexturePeacemakerDone.maxDistance = defaults.pins.pinTexturePeacemakerDone.maxDistance end
	if not DestinationsSV.pins.pinTexturePeacemakerDone.type then DestinationsSV.pins.pinTexturePeacemakerDone.type = defaults.pins.pinTexturePeacemakerDone.type end
	if not DestinationsSV.pins.pinTexturePeacemakerDone.level then DestinationsSV.pins.pinTexturePeacemakerDone.level = defaults.pins.pinTexturePeacemakerDone.level end
	if not DestinationsSV.pins.pinTexturePeacemakerDone.size then DestinationsSV.pins.pinTexturePeacemakerDone.size = defaults.pins.pinTexturePeacemakerDone.size end
	if not DestinationsSV.pins.pinTexturePeacemakerDone.tint then DestinationsSV.pins.pinTexturePeacemakerDone.tint = defaults.pins.pinTexturePeacemakerDone.tint end
	if not DestinationsSV.pins.pinTexturePeacemakerDone.textcolor then DestinationsSV.pins.pinTexturePeacemakerDone.textcolor = defaults.pins.pinTexturePeacemakerDone.textcolor end

	if not DestinationsSV.pins.pinTextureNosediver.maxDistance then DestinationsSV.pins.pinTextureNosediver.maxDistance = defaults.pins.pinTextureNosediver.maxDistance end
	if not DestinationsSV.pins.pinTextureNosediver.type then DestinationsSV.pins.pinTextureNosediver.type = defaults.pins.pinTextureNosediver.type end
	if not DestinationsSV.pins.pinTextureNosediver.level then DestinationsSV.pins.pinTextureNosediver.level = defaults.pins.pinTextureNosediver.level end
	if not DestinationsSV.pins.pinTextureNosediver.size then DestinationsSV.pins.pinTextureNosediver.size = defaults.pins.pinTextureNosediver.size end
	if not DestinationsSV.pins.pinTextureNosediver.tint then DestinationsSV.pins.pinTextureNosediver.tint = defaults.pins.pinTextureNosediver.tint end
	if not DestinationsSV.pins.pinTextureNosediver.textcolor then DestinationsSV.pins.pinTextureNosediver.textcolor = defaults.pins.pinTextureNosediver.textcolor end

	if not DestinationsSV.pins.pinTextureNosediverDone.maxDistance then DestinationsSV.pins.pinTextureNosediverDone.maxDistance = defaults.pins.pinTextureNosediverDone.maxDistance end
	if not DestinationsSV.pins.pinTextureNosediverDone.type then DestinationsSV.pins.pinTextureNosediverDone.type = defaults.pins.pinTextureNosediverDone.type end
	if not DestinationsSV.pins.pinTextureNosediverDone.level then DestinationsSV.pins.pinTextureNosediverDone.level = defaults.pins.pinTextureNosediverDone.level end
	if not DestinationsSV.pins.pinTextureNosediverDone.size then DestinationsSV.pins.pinTextureNosediverDone.size = defaults.pins.pinTextureNosediverDone.size end
	if not DestinationsSV.pins.pinTextureNosediverDone.tint then DestinationsSV.pins.pinTextureNosediverDone.tint = defaults.pins.pinTextureNosediverDone.tint end
	if not DestinationsSV.pins.pinTextureNosediverDone.textcolor then DestinationsSV.pins.pinTextureNosediverDone.textcolor = defaults.pins.pinTextureNosediverDone.textcolor end

	if not DestinationsSV.pins.pinTextureEarthlyPos.maxDistance then DestinationsSV.pins.pinTextureEarthlyPos.maxDistance = defaults.pins.pinTextureEarthlyPos.maxDistance end
	if not DestinationsSV.pins.pinTextureEarthlyPos.type then DestinationsSV.pins.pinTextureEarthlyPos.type = defaults.pins.pinTextureEarthlyPos.type end
	if not DestinationsSV.pins.pinTextureEarthlyPos.level then DestinationsSV.pins.pinTextureEarthlyPos.level = defaults.pins.pinTextureEarthlyPos.level end
	if not DestinationsSV.pins.pinTextureEarthlyPos.size then DestinationsSV.pins.pinTextureEarthlyPos.size = defaults.pins.pinTextureEarthlyPos.size end
	if not DestinationsSV.pins.pinTextureEarthlyPos.tint then DestinationsSV.pins.pinTextureEarthlyPos.tint = defaults.pins.pinTextureEarthlyPos.tint end
	if not DestinationsSV.pins.pinTextureEarthlyPos.textcolor then DestinationsSV.pins.pinTextureEarthlyPos.textcolor = defaults.pins.pinTextureEarthlyPos.textcolor end

	if not DestinationsSV.pins.pinTextureEarthlyPosDone.maxDistance then DestinationsSV.pins.pinTextureEarthlyPosDone.maxDistance = defaults.pins.pinTextureEarthlyPosDone.maxDistance end
	if not DestinationsSV.pins.pinTextureEarthlyPosDone.type then DestinationsSV.pins.pinTextureEarthlyPosDone.type = defaults.pins.pinTextureEarthlyPosDone.type end
	if not DestinationsSV.pins.pinTextureEarthlyPosDone.level then DestinationsSV.pins.pinTextureEarthlyPosDone.level = defaults.pins.pinTextureEarthlyPosDone.level end
	if not DestinationsSV.pins.pinTextureEarthlyPosDone.size then DestinationsSV.pins.pinTextureEarthlyPosDone.size = defaults.pins.pinTextureEarthlyPosDone.size end
	if not DestinationsSV.pins.pinTextureEarthlyPosDone.tint then DestinationsSV.pins.pinTextureEarthlyPosDone.tint = defaults.pins.pinTextureEarthlyPosDone.tint end
	if not DestinationsSV.pins.pinTextureEarthlyPosDone.textcolor then DestinationsSV.pins.pinTextureEarthlyPosDone.textcolor = defaults.pins.pinTextureEarthlyPosDone.textcolor end

	if not DestinationsSV.pins.pinTextureOnMe.maxDistance then DestinationsSV.pins.pinTextureOnMe.maxDistance = defaults.pins.pinTextureOnMe.maxDistance end
	if not DestinationsSV.pins.pinTextureOnMe.type then DestinationsSV.pins.pinTextureOnMe.type = defaults.pins.pinTextureOnMe.type end
	if not DestinationsSV.pins.pinTextureOnMe.level then DestinationsSV.pins.pinTextureOnMe.level = defaults.pins.pinTextureOnMe.level end
	if not DestinationsSV.pins.pinTextureOnMe.size then DestinationsSV.pins.pinTextureOnMe.size = defaults.pins.pinTextureOnMe.size end
	if not DestinationsSV.pins.pinTextureOnMe.tint then DestinationsSV.pins.pinTextureOnMe.tint = defaults.pins.pinTextureOnMe.tint end
	if not DestinationsSV.pins.pinTextureOnMe.textcolor then DestinationsSV.pins.pinTextureOnMe.textcolor = defaults.pins.pinTextureOnMe.textcolor end

	if not DestinationsSV.pins.pinTextureOnMeDone.maxDistance then DestinationsSV.pins.pinTextureOnMeDone.maxDistance = defaults.pins.pinTextureOnMeDone.maxDistance end
	if not DestinationsSV.pins.pinTextureOnMeDone.type then DestinationsSV.pins.pinTextureOnMeDone.type = defaults.pins.pinTextureOnMeDone.type end
	if not DestinationsSV.pins.pinTextureOnMeDone.level then DestinationsSV.pins.pinTextureOnMeDone.level = defaults.pins.pinTextureOnMeDone.level end
	if not DestinationsSV.pins.pinTextureOnMeDone.size then DestinationsSV.pins.pinTextureOnMeDone.size = defaults.pins.pinTextureOnMeDone.size end
	if not DestinationsSV.pins.pinTextureOnMeDone.tint then DestinationsSV.pins.pinTextureOnMeDone.tint = defaults.pins.pinTextureOnMeDone.tint end
	if not DestinationsSV.pins.pinTextureOnMeDone.textcolor then DestinationsSV.pins.pinTextureOnMeDone.textcolor = defaults.pins.pinTextureOnMeDone.textcolor end

	if not DestinationsSV.pins.pinTextureAyleid.maxDistance then DestinationsSV.pins.pinTextureAyleid.maxDistance = defaults.pins.pinTextureAyleid.maxDistance end
	if not DestinationsSV.pins.pinTextureAyleid.type then DestinationsSV.pins.pinTextureAyleid.type = defaults.pins.pinTextureAyleid.type end
	if not DestinationsSV.pins.pinTextureAyleid.level then DestinationsSV.pins.pinTextureAyleid.level = defaults.pins.pinTextureAyleid.level end
	if not DestinationsSV.pins.pinTextureAyleid.size then DestinationsSV.pins.pinTextureAyleid.size = defaults.pins.pinTextureAyleid.size end
	if not DestinationsSV.pins.pinTextureAyleid.tint then DestinationsSV.pins.pinTextureAyleid.tint = defaults.pins.pinTextureAyleid.tint end
	if not DestinationsSV.pins.pinTextureAyleid.textcolor then DestinationsSV.pins.pinTextureAyleid.textcolor = defaults.pins.pinTextureAyleid.textcolor end

	if not DestinationsSV.pins.pinTextureDwemer.maxDistance then DestinationsSV.pins.pinTextureDwemer.maxDistance = defaults.pins.pinTextureDwemer.maxDistance end
	if not DestinationsSV.pins.pinTextureDwemer.type then DestinationsSV.pins.pinTextureDwemer.type = defaults.pins.pinTextureDwemer.type end
	if not DestinationsSV.pins.pinTextureDwemer.level then DestinationsSV.pins.pinTextureDwemer.level = defaults.pins.pinTextureDwemer.level end
	if not DestinationsSV.pins.pinTextureDwemer.size then DestinationsSV.pins.pinTextureDwemer.size = defaults.pins.pinTextureDwemer.size end
	if not DestinationsSV.pins.pinTextureDwemer.tint then DestinationsSV.pins.pinTextureDwemer.tint = defaults.pins.pinTextureDwemer.tint end
	if not DestinationsSV.pins.pinTextureDwemer.textcolor then DestinationsSV.pins.pinTextureDwemer.textcolor = defaults.pins.pinTextureDwemer.textcolor end

	DestinationsSV.pins.pinTextureChampion.maxDistance = defaults.pins.pinTextureChampion.maxDistance
	if not DestinationsSV.pins.pinTextureChampion.type then DestinationsSV.pins.pinTextureChampion.type = defaults.pins.pinTextureChampion.type end
	if not DestinationsSV.pins.pinTextureChampion.level then DestinationsSV.pins.pinTextureChampion.level = defaults.pins.pinTextureChampion.level end
	if not DestinationsSV.pins.pinTextureChampion.size then DestinationsSV.pins.pinTextureChampion.size = defaults.pins.pinTextureChampion.size end
	if not DestinationsSV.pins.pinTextureChampion.tint then DestinationsSV.pins.pinTextureChampion.tint = defaults.pins.pinTextureChampion.tint end
	if not DestinationsSV.pins.pinTextureChampion.textcolor then DestinationsSV.pins.pinTextureChampion.textcolor = defaults.pins.pinTextureChampion.textcolor end

	if not DestinationsSV.pins.pinTextureBorder.maxDistance then DestinationsSV.pins.pinTextureBorder.maxDistance = defaults.pins.pinTextureBorder.maxDistance end
	if not DestinationsSV.pins.pinTextureBorder.type then DestinationsSV.pins.pinTextureBorder.type = defaults.pins.pinTextureBorder.type end
	if not DestinationsSV.pins.pinTextureBorder.level then DestinationsSV.pins.pinTextureBorder.level = defaults.pins.pinTextureBorder.level end
	if not DestinationsSV.pins.pinTextureBorder.size then DestinationsSV.pins.pinTextureBorder.size = defaults.pins.pinTextureBorder.size end
	if not DestinationsSV.pins.pinTextureBorder.tint then DestinationsSV.pins.pinTextureBorder.tint = defaults.pins.pinTextureBorder.tint end

	if not DestinationsSV.pins.pinTextureWWVamp.maxDistance then DestinationsSV.pins.pinTextureWWVamp.maxDistance = defaults.pins.pinTextureWWVamp.maxDistance end
	if not DestinationsSV.pins.pinTextureWWVamp.type then DestinationsSV.pins.pinTextureWWVamp.type = defaults.pins.pinTextureWWVamp.type end
	if not DestinationsSV.pins.pinTextureWWVamp.level then DestinationsSV.pins.pinTextureWWVamp.level = defaults.pins.pinTextureWWVamp.level end
	if not DestinationsSV.pins.pinTextureWWVamp.size then DestinationsSV.pins.pinTextureWWVamp.size = defaults.pins.pinTextureWWVamp.size end
	if not DestinationsSV.pins.pinTextureWWVamp.tint then DestinationsSV.pins.pinTextureWWVamp.tint = defaults.pins.pinTextureWWVamp.tint end
	if not DestinationsSV.pins.pinTextureWWVamp.textcolor then DestinationsSV.pins.pinTextureWWVamp.textcolor = defaults.pins.pinTextureWWVamp.textcolor end

	if not DestinationsSV.pins.pinTextureWWShrine.maxDistance then DestinationsSV.pins.pinTextureWWShrine.maxDistance = defaults.pins.pinTextureWWShrine.maxDistance end
	if not DestinationsSV.pins.pinTextureWWShrine.type then DestinationsSV.pins.pinTextureWWShrine.type = defaults.pins.pinTextureWWShrine.type end
	if not DestinationsSV.pins.pinTextureWWShrine.level then DestinationsSV.pins.pinTextureWWShrine.level = defaults.pins.pinTextureWWShrine.level end
	if not DestinationsSV.pins.pinTextureWWShrine.size then DestinationsSV.pins.pinTextureWWShrine.size = defaults.pins.pinTextureWWShrine.size end
	if not DestinationsSV.pins.pinTextureWWShrine.tint then DestinationsSV.pins.pinTextureWWShrine.tint = defaults.pins.pinTextureWWShrine.tint end
	if not DestinationsSV.pins.pinTextureWWShrine.textcolor then DestinationsSV.pins.pinTextureWWShrine.textcolor = defaults.pins.pinTextureWWShrine.textcolor end

	if not DestinationsSV.pins.pinTextureVampAltar.maxDistance then DestinationsSV.pins.pinTextureVampAltar.maxDistance = defaults.pins.pinTextureVampAltar.maxDistance end
	if not DestinationsSV.pins.pinTextureVampAltar.type then DestinationsSV.pins.pinTextureVampAltar.type = defaults.pins.pinTextureVampAltar.type end
	if not DestinationsSV.pins.pinTextureVampAltar.level then DestinationsSV.pins.pinTextureVampAltar.level = defaults.pins.pinTextureVampAltar.level end
	if not DestinationsSV.pins.pinTextureVampAltar.size then DestinationsSV.pins.pinTextureVampAltar.size = defaults.pins.pinTextureVampAltar.size end
	if not DestinationsSV.pins.pinTextureVampAltar.tint then DestinationsSV.pins.pinTextureVampAltar.tint = defaults.pins.pinTextureVampAltar.tint end
	if not DestinationsSV.pins.pinTextureVampAltar.textcolor then DestinationsSV.pins.pinTextureVampAltar.textcolor = defaults.pins.pinTextureVampAltar.textcolor end

	if not DestinationsSV.pins.pinTextureQuestsUndone.maxDistance then DestinationsSV.pins.pinTextureQuestsUndone.maxDistance = defaults.pins.pinTextureQuestsUndone.maxDistance end
	if not DestinationsSV.pins.pinTextureQuestsUndone.type then DestinationsSV.pins.pinTextureQuestsUndone.type = defaults.pins.pinTextureQuestsUndone.type end
	if not DestinationsSV.pins.pinTextureQuestsUndone.level then DestinationsSV.pins.pinTextureQuestsUndone.level = defaults.pins.pinTextureQuestsUndone.level end
	if not DestinationsSV.pins.pinTextureQuestsUndone.size then DestinationsSV.pins.pinTextureQuestsUndone.size = defaults.pins.pinTextureQuestsUndone.size end
	if not DestinationsSV.pins.pinTextureQuestsUndone.tint then DestinationsSV.pins.pinTextureQuestsUndone.tint = defaults.pins.pinTextureQuestsUndone.tint end
	if not DestinationsSV.pins.pinTextureQuestsUndone.textcolor then DestinationsSV.pins.pinTextureQuestsUndone.textcolor = defaults.pins.pinTextureQuestsUndone.textcolor end

	if not DestinationsSV.pins.pinTextureQuestsInProgress.maxDistance then DestinationsSV.pins.pinTextureQuestsInProgress.maxDistance = defaults.pins.pinTextureQuestsInProgress.maxDistance end
	if not DestinationsSV.pins.pinTextureQuestsInProgress.type then DestinationsSV.pins.pinTextureQuestsInProgress.type = defaults.pins.pinTextureQuestsInProgress.type end
	if not DestinationsSV.pins.pinTextureQuestsInProgress.level then DestinationsSV.pins.pinTextureQuestsInProgress.level = defaults.pins.pinTextureQuestsInProgress.level end
	if not DestinationsSV.pins.pinTextureQuestsInProgress.size then DestinationsSV.pins.pinTextureQuestsInProgress.size = defaults.pins.pinTextureQuestsInProgress.size end
	if not DestinationsSV.pins.pinTextureQuestsInProgress.tint then DestinationsSV.pins.pinTextureQuestsInProgress.tint = defaults.pins.pinTextureQuestsInProgress.tint end
	if not DestinationsSV.pins.pinTextureQuestsInProgress.textcolor then DestinationsSV.pins.pinTextureQuestsInProgress.textcolor = defaults.pins.pinTextureQuestsInProgress.textcolor end
	
	if not DestinationsSV.pins.pinTextureQuestsDone.maxDistance then DestinationsSV.pins.pinTextureQuestsDone.maxDistance = defaults.pins.pinTextureQuestsDone.maxDistance end
	if not DestinationsSV.pins.pinTextureQuestsDone.type then DestinationsSV.pins.pinTextureQuestsDone.type = defaults.pins.pinTextureQuestsDone.type end
	if not DestinationsSV.pins.pinTextureQuestsDone.level then DestinationsSV.pins.pinTextureQuestsDone.level = defaults.pins.pinTextureQuestsDone.level end
	if not DestinationsSV.pins.pinTextureQuestsDone.size then DestinationsSV.pins.pinTextureQuestsDone.size = defaults.pins.pinTextureQuestsDone.size end
	if not DestinationsSV.pins.pinTextureQuestsDone.tint then DestinationsSV.pins.pinTextureQuestsDone.tint = defaults.pins.pinTextureQuestsDone.tint end
	if not DestinationsSV.pins.pinTextureQuestsDone.textcolor then DestinationsSV.pins.pinTextureQuestsDone.textcolor = defaults.pins.pinTextureQuestsDone.textcolor end
	
	if not DestinationsSV.pins.pinTextureCollectible.maxDistance then DestinationsSV.pins.pinTextureCollectible.maxDistance = defaults.pins.pinTextureCollectible.maxDistance end
	if not DestinationsSV.pins.pinTextureCollectible.type then DestinationsSV.pins.pinTextureCollectible.type = defaults.pins.pinTextureCollectible.type end
	if not DestinationsSV.pins.pinTextureCollectible.level then DestinationsSV.pins.pinTextureCollectible.level = defaults.pins.pinTextureCollectible.level end
	if not DestinationsSV.pins.pinTextureCollectible.size then DestinationsSV.pins.pinTextureCollectible.size = defaults.pins.pinTextureCollectible.size end
	if not DestinationsSV.pins.pinTextureCollectible.tint then DestinationsSV.pins.pinTextureCollectible.tint = defaults.pins.pinTextureCollectible.tint end
	if not DestinationsSV.pins.pinTextureCollectible.textcolor then DestinationsSV.pins.pinTextureCollectible.textcolor = defaults.pins.pinTextureCollectible.textcolor end
	if not DestinationsSV.pins.pinTextureCollectible.textcolortitle then DestinationsSV.pins.pinTextureCollectible.textcolortitle = defaults.pins.pinTextureCollectible.textcolortitle end
	
	if not DestinationsSV.pins.pinTextureCollectibleDone.maxDistance then DestinationsSV.pins.pinTextureCollectibleDone.maxDistance = defaults.pins.pinTextureCollectibleDone.maxDistance end
	if not DestinationsSV.pins.pinTextureCollectibleDone.type then DestinationsSV.pins.pinTextureCollectibleDone.type = defaults.pins.pinTextureCollectibleDone.type end
	if not DestinationsSV.pins.pinTextureCollectibleDone.level then DestinationsSV.pins.pinTextureCollectibleDone.level = defaults.pins.pinTextureCollectibleDone.level end
	if not DestinationsSV.pins.pinTextureCollectibleDone.size then DestinationsSV.pins.pinTextureCollectibleDone.size = defaults.pins.pinTextureCollectibleDone.size end
	if not DestinationsSV.pins.pinTextureCollectibleDone.tint then DestinationsSV.pins.pinTextureCollectibleDone.tint = defaults.pins.pinTextureCollectibleDone.tint end
	if not DestinationsSV.pins.pinTextureCollectibleDone.textcolor then DestinationsSV.pins.pinTextureCollectibleDone.textcolor = defaults.pins.pinTextureCollectibleDone.textcolor end
	if not DestinationsSV.pins.pinTextureCollectibleDone.textcolortitle then DestinationsSV.pins.pinTextureCollectibleDone.textcolortitle = defaults.pins.pinTextureCollectibleDone.textcolortitle end
	
	if not DestinationsSV.pins.pinTextureFish.maxDistance then DestinationsSV.pins.pinTextureFish.maxDistance = defaults.pins.pinTextureFish.maxDistance end
	if not DestinationsSV.pins.pinTextureFish.type then DestinationsSV.pins.pinTextureFish.type = defaults.pins.pinTextureFish.type end
	if not DestinationsSV.pins.pinTextureFish.level then DestinationsSV.pins.pinTextureFish.level = defaults.pins.pinTextureFish.level end
	if not DestinationsSV.pins.pinTextureFish.size then DestinationsSV.pins.pinTextureFish.size = defaults.pins.pinTextureFish.size end
	if not DestinationsSV.pins.pinTextureFish.tint then DestinationsSV.pins.pinTextureFish.tint = defaults.pins.pinTextureFish.tint end
	if not DestinationsSV.pins.pinTextureFish.textcolor then DestinationsSV.pins.pinTextureFish.textcolor = defaults.pins.pinTextureFish.textcolor end
	if not DestinationsSV.pins.pinTextureFish.textcolortitle then DestinationsSV.pins.pinTextureFish.textcolortitle = defaults.pins.pinTextureFish.textcolortitle end
	if not DestinationsSV.pins.pinTextureFish.textcolorBait then DestinationsSV.pins.pinTextureFish.textcolorBait = defaults.pins.pinTextureFish.textcolorBait end
	if not DestinationsSV.pins.pinTextureFish.textcolorWater then DestinationsSV.pins.pinTextureFish.textcolorWater = defaults.pins.pinTextureFish.textcolorWater end
	
	if not DestinationsSV.pins.pinTextureFishDone.maxDistance then DestinationsSV.pins.pinTextureFishDone.maxDistance = defaults.pins.pinTextureFishDone.maxDistance end
	if not DestinationsSV.pins.pinTextureFishDone.type then DestinationsSV.pins.pinTextureFishDone.type = defaults.pins.pinTextureFishDone.type end
	if not DestinationsSV.pins.pinTextureFishDone.level then DestinationsSV.pins.pinTextureFishDone.level = defaults.pins.pinTextureFishDone.level end
	if not DestinationsSV.pins.pinTextureFishDone.size then DestinationsSV.pins.pinTextureFishDone.size = defaults.pins.pinTextureFishDone.size end
	if not DestinationsSV.pins.pinTextureFishDone.tint then DestinationsSV.pins.pinTextureFishDone.tint = defaults.pins.pinTextureFishDone.tint end
	if not DestinationsSV.pins.pinTextureFishDone.textcolor then DestinationsSV.pins.pinTextureFishDone.textcolor = defaults.pins.pinTextureFishDone.textcolor end
	if not DestinationsSV.pins.pinTextureFishDone.textcolortitle then DestinationsSV.pins.pinTextureFishDone.textcolortitle = defaults.pins.pinTextureFishDone.textcolortitle end
	if not DestinationsSV.pins.pinTextureFishDone.textcolorBait then DestinationsSV.pins.pinTextureFishDone.textcolorBait = defaults.pins.pinTextureFishDone.textcolorBait end
	if not DestinationsSV.pins.pinTextureFishDone.textcolorWater then DestinationsSV.pins.pinTextureFishDone.textcolorWater = defaults.pins.pinTextureFishDone.textcolorWater end
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--On "EVENT_POI_UPDATED" redraw map pins
local function OnPOIUpdate(zoneIndex, poiIndex)
	RedrawAllRealPins()
	LMP:RefreshPins(PINS_UNKNOWN)
	LMP:RefreshPins(PINS_KNOWN)
end
--On "EVENT_POI_DISCOVERED" redraw map pins
local function OnPOIDiscovered(zoneIndex, poiIndex)
	RedrawAllRealPins()
	LMP:RefreshPins(PINS_UNKNOWN)
	LMP:RefreshPins(PINS_KNOWN)
end
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--achievements
local function OnAchievementUpdate(eventCode, achievementId)
	if ACHids[achievementId] then
		LMP:RefreshPins(PINS_MAIQ)
		COMPASS_PINS:RefreshPins(PINS_MAIQ)
		LMP:RefreshPins(PINS_LB_GTTP_CP)
		COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP)
		LMP:RefreshPins(PINS_PEACEMAKER)
		COMPASS_PINS:RefreshPins(PINS_PEACEMAKER)
		LMP:RefreshPins(PINS_NOSEDIVER)
		COMPASS_PINS:RefreshPins(PINS_NOSEDIVER)
		LMP:RefreshPins(PINS_EARTHLYPOS)
		COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS)
		LMP:RefreshPins(PINS_ON_ME)
		COMPASS_PINS:RefreshPins(PINS_ON_ME)
		LMP:RefreshPins(PINS_MAIQ_DONE)
		COMPASS_PINS:RefreshPins(PINS_MAIQ_DONE)
		LMP:RefreshPins(PINS_LB_GTTP_CP_DONE)
		COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP_DONE)
		LMP:RefreshPins(PINS_PEACEMAKER_DONE)
		COMPASS_PINS:RefreshPins(PINS_PEACEMAKER_DONE)
		LMP:RefreshPins(PINS_NOSEDIVER_DONE)
		COMPASS_PINS:RefreshPins(PINS_NOSEDIVER_DONE)
		LMP:RefreshPins(PINS_EARTHLYPOS_DONE)
		COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS_DONE)
		LMP:RefreshPins(PINS_ON_ME_DONE)
		COMPASS_PINS:RefreshPins(PINS_ON_ME_DONE)
	end
	if FISHids[achievementId] then
		LMP:RefreshPins(PINS_FISHING)
		COMPASS_PINS:RefreshPins(PINS_FISHING)
		LMP:RefreshPins(PINS_FISHINGDONE)
		COMPASS_PINS:RefreshPins(PINS_FISHINGDONE)
	end
end
-- refresh compass after each loadscreen
local function RefreshOnCharacterLoad()
	COMPASS_PINS:RefreshPins(PINS_MAIQ)
	COMPASS_PINS:RefreshPins(PINS_MAIQ_DONE)
	COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP)
	COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP_DONE)
	COMPASS_PINS:RefreshPins(PINS_PEACEMAKER)
	COMPASS_PINS:RefreshPins(PINS_PEACEMAKER_DONE)
	COMPASS_PINS:RefreshPins(PINS_NOSEDIVER)
	COMPASS_PINS:RefreshPins(PINS_NOSEDIVER_DONE)
	COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS)
	COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS_DONE)
	COMPASS_PINS:RefreshPins(PINS_ON_ME)
	COMPASS_PINS:RefreshPins(PINS_ON_ME_DONE)
	COMPASS_PINS:RefreshPins(PINS_CHAMPION)
	COMPASS_PINS:RefreshPins(PINS_COLLECTIBLES)
	COMPASS_PINS:RefreshPins(PINS_COLLECTIBLES_DONE)
	COMPASS_PINS:RefreshPins(PINS_FISHING)
	COMPASS_PINS:RefreshPins(PINS_FISHING_DONE)
	COMPASS_PINS:RefreshPins(PINS_AYLEID)
	COMPASS_PINS:RefreshPins(PINS_WWVAMP)
end
--------------------------------------------------------------------------------------------------------------------------------
--Initialize the addon
--------------------------------------------------------------------------------------------------------------------------------
local function OnLoad(eventCode, name)
	if name ~= "Destinations" then
		return
	end

	DestinationsSV = ZO_SavedVars:New("Destinations_Settings", 1, nil, defaults)
	DestinationsCSSV = ZO_SavedVars:New("Destinations_Settings", 1, nil, defaults)
	DestinationsAWSV = ZO_SavedVars:NewAccountWide("Destinations_Settings", 1, nil, defaults)
	DestinationsAW = ZO_SavedVars:NewAccountWide("Destinations_Settings", 1, nil, defaults)

	--Check Language, Addon not yet localized
	localLanguage = GetCVar("language.2") or "en"
	if not (localLanguage == "en" or localLanguage == "es" or localLanguage == "de" or localLanguage == "fr" or localLanguage == "ru") then
		--chat messages aren't shown before player is activated
		EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_PLAYER_ACTIVATED,
		function()
			EVENT_MANAGER:UnregisterForEvent("Destinations", EVENT_PLAYER_ACTIVATED)
			d("Destinations is not properly localized for " .. localLanguage .. ".	English terms will be used and not all POIs may be properly classified.")
		end)
	end

	-- Initialize Settings
	InitVariables()
	if DestinationsAWSV.settings.useAccountWide then
		DestinationsSV = DestinationsAWSV
	else 
		DestinationsAWSV = DestinationsSV
	end

	--Establish Pin Configurations
	local pinLayout_unknown = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.Unknown[DestinationsSV.pins.pinTextureUnknown.type],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	local pinLayout_known = {
		maxDistance = DestinationsSV.pins.pinTextureKnown.maxDistance,
		level = DestinationsSV.pins.pinTextureKnown.level,
		texture = pinTextures.Known[DestinationsSV.pins.pinTextureKnown.type],
		size = DestinationsSV.pins.pinTextureKnown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureKnown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureKnown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	local pinTooltipCreator = {
		creator = function(pin)
			local _, pinTag = pin:GetPinTypeAndTag()
			for _, lineData in ipairs(pinTag) do
				SetTooltipText(InformationTooltip, lineData)
			end
		end,
		tooltip = 1,
	}

-------------------------------------------------------------------------------
----------------------------------SEMI-REAL------------------------------------
-------------------------------------------------------------------------------
	local pinLayout_RealUnknownWayshrine = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[1],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNWAYSHRINE, MapCallback_unknownWayshrine, nil, pinLayout_RealUnknownWayshrine, pinTooltipCreator)
	local pinLayout_RealUnknownAOI = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[2],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNAOI, MapCallback_unknownAOI, nil, pinLayout_RealUnknownAOI, pinTooltipCreator)
	local pinLayout_RealUnknownPublicDungeon = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[3],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNPUBLICDUNGEON, MapCallback_unknownPublicDungeon, nil, pinLayout_RealUnknownPublicDungeon, pinTooltipCreator)
	local pinLayout_RealUnknownMundus = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[4],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNMUNDUS, MapCallback_unknownMundus, nil, pinLayout_RealUnknownMundus, pinTooltipCreator)
	local pinLayout_RealUnknownDolmen = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[5],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNDOLMEN, MapCallback_unknownDolmen, nil, pinLayout_RealUnknownDolmen, pinTooltipCreator)
	local pinLayout_RealUnknownGroupBoss = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[6],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNGROUPBOSS, MapCallback_unknownGroupBoss, nil, pinLayout_RealUnknownGroupBoss, pinTooltipCreator)
	local pinLayout_RealUnknownGroupDungeon = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[7],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNGROUPDUNGEON, MapCallback_unknownGroupDungeon, nil, pinLayout_RealUnknownGroupDungeon, pinTooltipCreator)
	local pinLayout_RealUnknownQuestHub = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[8],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNQUESTHUB, MapCallback_unknownQuestHub, nil, pinLayout_RealUnknownQuestHub, pinTooltipCreator)
	local pinLayout_RealUnknownCrafting = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[9],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNCRAFTING, MapCallback_unknownCrafting, nil, pinLayout_RealUnknownCrafting, pinTooltipCreator)
	local pinLayout_RealUnknownSoloDungeon = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[10],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNSOLODUNGEON, MapCallback_unknownSoloDungeon, nil, pinLayout_RealUnknownSoloDungeon, pinTooltipCreator)
	local pinLayout_RealUnknownGroupEvent = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[11],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNGROUPEVENT, MapCallback_unknownGroupEvent, nil, pinLayout_RealUnknownGroupEvent, pinTooltipCreator)
	local pinLayout_RealUnknownGroupDelve = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[12],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNGROUPDELVE, MapCallback_unknownGroupDelve, nil, pinLayout_RealUnknownGroupDelve, pinTooltipCreator)
	local pinLayout_RealUnknownTrial = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[13],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNTRIAL, MapCallback_unknownTrial, nil, pinLayout_RealUnknownTrial, pinTooltipCreator)
	local pinLayout_RealUnknownWayshrineTrader = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[15],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNWAYSHRINETRADER, MapCallback_unknownWayshrineTrader, nil, pinLayout_RealUnknownWayshrineTrader, pinTooltipCreator)
	local pinLayout_RealUnknownGroupDungeon2 = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[16],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWNGROUPDUNGEON2, MapCallback_unknownGroupDungeon2, nil, pinLayout_RealUnknownGroupDungeon2, pinTooltipCreator)
	local pinLayout_RealUnknown = {
		maxDistance = DestinationsSV.pins.pinTextureUnknown.maxDistance,
		level = DestinationsSV.pins.pinTextureUnknown.level,
		texture = pinTextures.UnknownReal[22],
		size = DestinationsSV.pins.pinTextureUnknown.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureUnknown.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureUnknown.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}
	LMP:AddPinType(PINS_REALUNKNOWN, MapCallback_RealUnknown, nil, pinLayout_RealUnknown, pinTooltipCreator)
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
	--Create the Map Pins
	LMP:AddPinType(PINS_UNKNOWN, MapCallback_unknown, nil, pinLayout_unknown, pinTooltipCreator)
	LMP:AddPinType(PINS_KNOWN, MapCallback_known, nil, pinLayout_known, pinTooltipCreator)

	--Add filter check boxes
	LMP:AddPinFilter(PINS_UNKNOWN, GetString(DEST_FILTER_UNKNOWN), nil, DestinationsCSSV.filters)
	LMP:AddPinFilter(PINS_KNOWN, GetString(DEST_FILTER_KNOWN), nil, DestinationsCSSV.filters)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

	local pinLayout_other = {
		maxDistance = DestinationsSV.pins.pinTextureOther.maxDistance,
		level = DestinationsSV.pins.pinTextureOther.level,
		texture = pinTextures.Other[DestinationsSV.pins.pinTextureOther.type],
		size = DestinationsSV.pins.pinTextureOther.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOther.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureOther.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_LB_GTTP_CP, OtherpinTypeCallback, nil, pinLayout_other, pinTooltipCreator)
	LMP:AddPinFilter(PINS_LB_GTTP_CP, GetString(DEST_FILTER_OTHER), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_LB_GTTP_CP, AddAchievementCompassPins , pinLayout_other)
	COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP)

	local pinLayout_other_Done = {
		maxDistance = DestinationsSV.pins.pinTextureOtherDone.maxDistance,
		level = DestinationsSV.pins.pinTextureOtherDone.level,
		texture = pinTextures.OtherDone[DestinationsSV.pins.pinTextureOtherDone.type],
		size = DestinationsSV.pins.pinTextureOtherDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOtherDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureOtherDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_LB_GTTP_CP_DONE, OtherpinTypeCallbackDone, nil, pinLayout_other_Done, pinTooltipCreator)
	LMP:AddPinFilter(PINS_LB_GTTP_CP_DONE, GetString(DEST_FILTER_OTHER_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_LB_GTTP_CP_DONE, AddAchievementCompassPins , pinLayout_other_Done)
	COMPASS_PINS:RefreshPins(PINS_LB_GTTP_CP_DONE)

	local pinLayout_Maiq = {
		maxDistance = DestinationsSV.pins.pinTextureMaiq.maxDistance,
		level = DestinationsSV.pins.pinTextureMaiq.level,
		texture = pinTextures.Maiq[DestinationsSV.pins.pinTextureMaiq.type],
		size = DestinationsSV.pins.pinTextureMaiq.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureMaiq.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureMaiq.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_MAIQ, MaiqpinTypeCallback, nil, pinLayout_Maiq, pinTooltipCreator)
	LMP:AddPinFilter(PINS_MAIQ, GetString(DEST_FILTER_MAIQ), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_MAIQ, AddAchievementCompassPins , pinLayout_Maiq)
	COMPASS_PINS:RefreshPins(PINS_MAIQ)

	local pinLayout_Maiq_Done = {
		maxDistance = DestinationsSV.pins.pinTextureMaiqDone.maxDistance,
		level = DestinationsSV.pins.pinTextureMaiqDone.level,
		texture = pinTextures.MaiqDone[DestinationsSV.pins.pinTextureMaiqDone.type],
		size = DestinationsSV.pins.pinTextureMaiqDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureMaiqDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureMaiqDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_MAIQ_DONE, MaiqpinTypeCallbackDone, nil, pinLayout_Maiq_Done, pinTooltipCreator)
	LMP:AddPinFilter(PINS_MAIQ_DONE, GetString(DEST_FILTER_MAIQ_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_MAIQ_DONE, AddAchievementCompassPins , pinLayout_Maiq_Done)
	COMPASS_PINS:RefreshPins(PINS_MAIQ_DONE)

	local pinLayout_Peacemaker = {
		maxDistance = DestinationsSV.pins.pinTexturePeacemaker.maxDistance,
		level = DestinationsSV.pins.pinTexturePeacemaker.level,
		texture = pinTextures.Peacemaker[DestinationsSV.pins.pinTexturePeacemaker.type],
		size = DestinationsSV.pins.pinTexturePeacemaker.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTexturePeacemaker.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTexturePeacemaker.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_PEACEMAKER, PeacemakerpinTypeCallback, nil, pinLayout_Peacemaker, pinTooltipCreator)
	LMP:AddPinFilter(PINS_PEACEMAKER, GetString(DEST_FILTER_PEACEMAKER), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_PEACEMAKER, AddAchievementCompassPins , pinLayout_Peacemaker)
	COMPASS_PINS:RefreshPins(PINS_PEACEMAKER)

	local pinLayout_Peacemaker_Done = {
		maxDistance = DestinationsSV.pins.pinTexturePeacemakerDone.maxDistance,
		level = DestinationsSV.pins.pinTexturePeacemakerDone.level,
		texture = pinTextures.PeacemakerDone[DestinationsSV.pins.pinTexturePeacemakerDone.type],
		size = DestinationsSV.pins.pinTexturePeacemakerDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTexturePeacemakerDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTexturePeacemakerDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_PEACEMAKER_DONE, PeacemakerpinTypeCallbackDone, nil, pinLayout_Peacemaker_Done, pinTooltipCreator)
	LMP:AddPinFilter(PINS_PEACEMAKER_DONE, GetString(DEST_FILTER_PEACEMAKER_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_PEACEMAKER_DONE, AddAchievementCompassPins , pinLayout_Peacemaker_Done)
	COMPASS_PINS:RefreshPins(PINS_PEACEMAKER_DONE)

	local pinLayout_Nosediver = {
		maxDistance = DestinationsSV.pins.pinTextureNosediver.maxDistance,
		level = DestinationsSV.pins.pinTextureNosediver.level,
		texture = pinTextures.Nosediver[DestinationsSV.pins.pinTextureNosediver.type],
		size = DestinationsSV.pins.pinTextureNosediver.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureNosediver.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureNosediver.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_NOSEDIVER, NosediverpinTypeCallback, nil, pinLayout_Nosediver, pinTooltipCreator)
	LMP:AddPinFilter(PINS_NOSEDIVER, GetString(DEST_FILTER_NOSEDIVER), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_NOSEDIVER, AddAchievementCompassPins , pinLayout_Nosediver)
	COMPASS_PINS:RefreshPins(PINS_NOSEDIVER)

	local pinLayout_Nosediver_Done = {
		maxDistance = DestinationsSV.pins.pinTextureNosediverDone.maxDistance,
		level = DestinationsSV.pins.pinTextureNosediverDone.level,
		texture = pinTextures.NosediverDone[DestinationsSV.pins.pinTextureNosediverDone.type],
		size = DestinationsSV.pins.pinTextureNosediverDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureNosediverDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureNosediverDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_NOSEDIVER_DONE, NosediverpinTypeCallbackDone, nil, pinLayout_Nosediver_Done, pinTooltipCreator)
	LMP:AddPinFilter(PINS_NOSEDIVER_DONE, GetString(DEST_FILTER_NOSEDIVER_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_NOSEDIVER_DONE, AddAchievementCompassPins , pinLayout_Nosediver_Done)
	COMPASS_PINS:RefreshPins(PINS_NOSEDIVER_DONE)

	local pinLayout_EarthlyPos = {
		maxDistance = DestinationsSV.pins.pinTextureEarthlyPos.maxDistance,
		level = DestinationsSV.pins.pinTextureEarthlyPos.level,
		texture = pinTextures.Earthlypos[DestinationsSV.pins.pinTextureEarthlyPos.type],
		size = DestinationsSV.pins.pinTextureEarthlyPos.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureEarthlyPos.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureEarthlyPos.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_EARTHLYPOS, EarthlyPospinTypeCallback, nil, pinLayout_EarthlyPos, pinTooltipCreator)
	LMP:AddPinFilter(PINS_EARTHLYPOS, GetString(DEST_FILTER_EARTHLYPOS), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_EARTHLYPOS, AddAchievementCompassPins , pinLayout_EarthlyPos)
	COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS)

	local pinLayout_EarthlyPos_Done = {
		maxDistance = DestinationsSV.pins.pinTextureEarthlyPosDone.maxDistance,
		level = DestinationsSV.pins.pinTextureEarthlyPosDone.level,
		texture = pinTextures.EarthlyposDone[DestinationsSV.pins.pinTextureEarthlyPosDone.type],
		size = DestinationsSV.pins.pinTextureEarthlyPosDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureEarthlyPosDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureEarthlyPosDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_EARTHLYPOS_DONE, EarthlyPospinTypeCallbackDone, nil, pinLayout_EarthlyPos_Done, pinTooltipCreator)
	LMP:AddPinFilter(PINS_EARTHLYPOS_DONE, GetString(DEST_FILTER_EARTHLYPOS_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_EARTHLYPOS_DONE, AddAchievementCompassPins , pinLayout_EarthlyPos_Done)
	COMPASS_PINS:RefreshPins(PINS_EARTHLYPOS_DONE)

	local pinLayout_OnMe = {
		maxDistance = DestinationsSV.pins.pinTextureOnMe.maxDistance,
		level = DestinationsSV.pins.pinTextureOnMe.level,
		texture = pinTextures.OnMe[DestinationsSV.pins.pinTextureOnMe.type],
		size = DestinationsSV.pins.pinTextureOnMe.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOnMe.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureOnMe.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_ON_ME, OnMepinTypeCallback, nil, pinLayout_OnMe, pinTooltipCreator)
	LMP:AddPinFilter(PINS_ON_ME, GetString(DEST_FILTER_ON_ME), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_ON_ME, AddAchievementCompassPins , pinLayout_OnMe)
	COMPASS_PINS:RefreshPins(PINS_ON_ME)

	local pinLayout_OnMe_Done = {
		maxDistance = DestinationsSV.pins.pinTextureOnMeDone.maxDistance,
		level = DestinationsSV.pins.pinTextureOnMeDone.level,
		texture = pinTextures.OnMeDone[DestinationsSV.pins.pinTextureOnMeDone.type],
		size = DestinationsSV.pins.pinTextureOnMeDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureOnMeDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureOnMeDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_ON_ME_DONE, OnMepinTypeCallbackDone, nil, pinLayout_OnMe_Done, pinTooltipCreator)
	LMP:AddPinFilter(PINS_ON_ME_DONE, GetString(DEST_FILTER_ON_ME_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_ON_ME_DONE, AddAchievementCompassPins , pinLayout_OnMe_Done)
	COMPASS_PINS:RefreshPins(PINS_ON_ME_DONE)

	local pinLayout_QuestsUndone = {
		maxDistance = DestinationsSV.pins.pinTextureQuestsUndone.maxDistance,
		level = DestinationsSV.pins.pinTextureQuestsUndone.level,
		texture = pinTextures.Quests[DestinationsSV.pins.pinTextureQuestsUndone.type],
		size = DestinationsSV.pins.pinTextureQuestsUndone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsUndone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureQuestsUndone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_QUESTS_UNDONE, Quests_Undone_pinTypeCallback, nil, pinLayout_QuestsUndone, pinTooltipCreator)
	LMP:AddPinFilter(PINS_QUESTS_UNDONE, GetString(DEST_FILTER_QUESTGIVER), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_QUESTS_UNDONE, Quests_CompassPins, pinLayout_QuestsUndone)
	COMPASS_PINS:RefreshPins(PINS_QUESTS_UNDONE)

	local pinLayout_QuestsInProgress = {
		maxDistance = DestinationsSV.pins.pinTextureQuestsInProgress.maxDistance,
		level = DestinationsSV.pins.pinTextureQuestsInProgress.level,
		texture = pinTextures.Quests[DestinationsSV.pins.pinTextureQuestsInProgress.type],
		size = DestinationsSV.pins.pinTextureQuestsInProgress.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureQuestsInProgress.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_QUESTS_IN_PROGRESS, Quests_In_Progress_pinTypeCallback, nil, pinLayout_QuestsInProgress, pinTooltipCreator)
	LMP:AddPinFilter(PINS_QUESTS_IN_PROGRESS, GetString(DEST_FILTER_QUESTS_IN_PROGRESS), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_QUESTS_IN_PROGRESS, Quests_CompassPins, pinLayout_QuestsInProgress)
	COMPASS_PINS:RefreshPins(PINS_QUESTS_IN_PROGRESS)

	local pinLayout_QuestsDone = {
		maxDistance = DestinationsSV.pins.pinTextureQuestsDone.maxDistance,
		level = DestinationsSV.pins.pinTextureQuestsDone.level,
		texture = pinTextures.Quests[DestinationsSV.pins.pinTextureQuestsDone.type],
		size = DestinationsSV.pins.pinTextureQuestsDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureQuestsDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureQuestsDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_QUESTS_DONE, Quests_Done_pinTypeCallback, nil, pinLayout_QuestsDone, pinTooltipCreator)
	LMP:AddPinFilter(PINS_QUESTS_DONE, GetString(DEST_FILTER_QUESTS_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_QUESTS_DONE, Quests_CompassPins, pinLayout_QuestsDone)
	COMPASS_PINS:RefreshPins(PINS_QUESTS_DONE)

	local pinLayout_Collectible = {
		maxDistance = DestinationsSV.pins.pinTextureCollectible.maxDistance,
		level = DestinationsSV.pins.pinTextureCollectible.level,
		texture = pinTextures.collectible[DestinationsSV.pins.pinTextureCollectible.type],
		size = DestinationsSV.pins.pinTextureCollectible.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectible.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureCollectible.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_COLLECTIBLES, CollectiblepinTypeCallback, nil, pinLayout_Collectible, pinTooltipCreator)
	LMP:AddPinFilter(PINS_COLLECTIBLES, GetString(DEST_FILTER_COLLECTIBLE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_COLLECTIBLES, CollectibleFishCompassPins, pinLayout_Collectible)
	COMPASS_PINS:RefreshPins(PINS_COLLECTIBLES)

	local pinLayout_CollectibleDone = {
		maxDistance = DestinationsSV.pins.pinTextureCollectibleDone.maxDistance,
		level = DestinationsSV.pins.pinTextureCollectibleDone.level,
		texture = pinTextures.collectibledone[DestinationsSV.pins.pinTextureCollectibleDone.type],
		size = DestinationsSV.pins.pinTextureCollectibleDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureCollectibleDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureCollectibleDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_COLLECTIBLESDONE, CollectibleDonepinTypeCallback, nil, pinLayout_CollectibleDone, pinTooltipCreator)
	LMP:AddPinFilter(PINS_COLLECTIBLESDONE, GetString(DEST_FILTER_COLLECTIBLE_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_COLLECTIBLESDONE, CollectibleFishCompassPins, pinLayout_CollectibleDone)
	COMPASS_PINS:RefreshPins(PINS_COLLECTIBLESDONE)

	local pinLayout_Fish = {
		maxDistance = DestinationsSV.pins.pinTextureFish.maxDistance,
		level = DestinationsSV.pins.pinTextureFish.level,
		texture = pinTextures.fish[DestinationsSV.pins.pinTextureFish.type],
		size = DestinationsSV.pins.pinTextureFish.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFish.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureFish.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_FISHING, FishpinTypeCallback, nil, pinLayout_Fish, pinTooltipCreator)
	LMP:AddPinFilter(PINS_FISHING, GetString(DEST_FILTER_FISHING), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_FISHING, CollectibleFishCompassPins, pinLayout_Fish)
	COMPASS_PINS:RefreshPins(PINS_FISHING)

	local pinLayout_FishDone = {
		maxDistance = DestinationsSV.pins.pinTextureFishDone.maxDistance,
		level = DestinationsSV.pins.pinTextureFishDone.level,
		texture = pinTextures.fishdone[DestinationsSV.pins.pinTextureFishDone.type],
		size = DestinationsSV.pins.pinTextureFishDone.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureFishDone.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureFishDone.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_FISHINGDONE, FishDonepinTypeCallback, nil, pinLayout_FishDone, pinTooltipCreator)
	LMP:AddPinFilter(PINS_FISHINGDONE, GetString(DEST_FILTER_FISHING_DONE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_FISHINGDONE, CollectibleFishCompassPins, pinLayout_FishDone)
	COMPASS_PINS:RefreshPins(PINS_FISHINGDONE)

	local pinLayout_Ayleid = {
		maxDistance = DestinationsSV.pins.pinTextureAyleid.maxDistance,
		level = DestinationsSV.pins.pinTextureAyleid.level,
		texture = pinTextures.ayleid[DestinationsSV.pins.pinTextureAyleid.type],
		size = DestinationsSV.pins.pinTextureAyleid.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureAyleid.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureAyleid.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_AYLEID, AyleidpinTypeCallback, nil, pinLayout_Ayleid, pinTooltipCreator)
	LMP:AddPinFilter(PINS_AYLEID, GetString(DEST_FILTER_AYLEID), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_AYLEID, AddMiscCompassPins , pinLayout_Ayleid)
	COMPASS_PINS:RefreshPins(PINS_AYLEID)

	local pinLayout_Champion = {
		maxDistance = DestinationsSV.pins.pinTextureChampion.maxDistance,
		level = DestinationsSV.pins.pinTextureChampion.level,
		texture = pinTextures.champion[DestinationsSV.pins.pinTextureChampion.type],
		size = DestinationsSV.pins.pinTextureChampion.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureChampion.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureChampion.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_CHAMPION, ChampionpinTypeCallback, nil, pinLayout_Champion, pinTooltipCreator)
	LMP:AddPinFilter(PINS_CHAMPION, GetString(DEST_FILTER_CHAMPION), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_CHAMPION, AddMiscCompassPins , pinLayout_Champion)
	COMPASS_PINS:RefreshPins(PINS_CHAMPION)

	local pinLayout_WWVamp = {
		maxDistance = DestinationsSV.pins.pinTextureWWVamp.maxDistance,
		level = DestinationsSV.pins.pinTextureWWVamp.level,
		texture = pinTextures.wwvamp[DestinationsSV.pins.pinTextureWWVamp.type],
		size = DestinationsSV.pins.pinTextureWWVamp.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureWWVamp.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureWWVamp.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_WWVAMP, WWVamppinTypeCallback, nil, pinLayout_WWVamp, pinTooltipCreator)
	LMP:AddPinFilter(PINS_WWVAMP, GetString(DEST_FILTER_WWVAMP), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_WWVAMP, AddMiscCompassPins , pinLayout_WWVamp)
	COMPASS_PINS:RefreshPins(PINS_WWVAMP)

	local pinLayout_VampireAltar = {
		maxDistance = DestinationsSV.pins.pinTextureVampAltar.maxDistance,
		level = DestinationsSV.pins.pinTextureVampAltar.level,
		texture = pinTextures.vampirealtar[DestinationsSV.pins.pinTextureVampAltar.type],
		size = DestinationsSV.pins.pinTextureVampAltar.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureVampAltar.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureVampAltar.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_VAMPIRE_ALTAR, VampireAltarpinTypeCallback, nil, pinLayout_VampireAltar, pinTooltipCreator)
	LMP:AddPinFilter(PINS_VAMPIRE_ALTAR, GetString(DEST_FILTER_VAMPIRE_ALTAR), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_VAMPIRE_ALTAR, AddMiscCompassPins , pinLayout_VampireAltar)
	COMPASS_PINS:RefreshPins(PINS_VAMPIRE_ALTAR)

	local pinLayout_WereWolfShrine = {
		maxDistance = DestinationsSV.pins.pinTextureWWShrine.maxDistance,
		level = DestinationsSV.pins.pinTextureWWShrine.level,
		texture = pinTextures.werewolfshrine[DestinationsSV.pins.pinTextureWWShrine.type],
		size = DestinationsSV.pins.pinTextureWWShrine.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureWWShrine.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureWWShrine.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_WEREWOLF_SHRINE, WerewolfShrinepinTypeCallback, nil, pinLayout_WereWolfShrine, pinTooltipCreator)
	LMP:AddPinFilter(PINS_WEREWOLF_SHRINE, GetString(DEST_FILTER_WEREWOLF_SHRINE), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_WEREWOLF_SHRINE, AddMiscCompassPins , pinLayout_WereWolfShrine)
	COMPASS_PINS:RefreshPins(PINS_WEREWOLF_SHRINE)

	local pinLayout_Dwemer = {
		maxDistance = DestinationsSV.pins.pinTextureDwemer.maxDistance,
		level = DestinationsSV.pins.pinTextureDwemer.level,
		texture = pinTextures.dwemer[DestinationsSV.pins.pinTextureDwemer.type],
		size = DestinationsSV.pins.pinTextureDwemer.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureDwemer.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureDwemer.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_DWEMER, DwemerRuinpinTypeCallback, nil, pinLayout_Dwemer, pinTooltipCreator)
	LMP:AddPinFilter(PINS_DWEMER, GetString(DEST_FILTER_DWEMER), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_DWEMER, AddMiscCompassPins, pinLayout_Dwemer)
	COMPASS_PINS:RefreshPins(PINS_DWEMER)

	local pinLayout_Border = {
		maxDistance = DestinationsSV.pins.pinTextureBorder.maxDistance,
		level = DestinationsSV.pins.pinTextureBorder.level,
		texture = pinTextures.border[DestinationsSV.pins.pinTextureBorder.type],
		size = DestinationsSV.pins.pinTextureBorder.size,
		tint = ZO_ColorDef:New(unpack(DestinationsSV.pins.pinTextureBorder.tint)),
		additionalLayout = {
			function(pin)
				pin:GetNamedChild("Background"):SetColor(unpack(DestinationsSV.pins.pinTextureBorder.tint))
			end,
			function(pin)
				pin:GetNamedChild("Background"):SetColor(1,1,1,1)
			end,
		},
	}

	LMP:AddPinType(PINS_BORDER, BorderpinTypeCallback, nil, pinLayout_Border, nil)
	LMP:AddPinFilter(PINS_BORDER, GetString(DEST_FILTER_BORDER), nil, DestinationsCSSV.filters)
	COMPASS_PINS:AddCustomPin(PINS_BORDER, BorderCompassPins, pinLayout_Border)
	COMPASS_PINS:RefreshPins(PINS_BORDER)

	--Initialize Settings Menu
	InitSettings()
	--Set/Update Quest Data
	GetInProgressQuests()
	SetSpecialQuests()

	--Register Event Triggers
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_POI_DISCOVERED, OnPOIDiscovered)
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_POI_UPDATED, OnPOIUpdate)
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_PLAYER_ACTIVATED, RefreshOnCharacterLoad)
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_ACHIEVEMENT_UPDATED, OnAchievementUpdate)
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_QUEST_ADDED, RegisterQuest)
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_QUEST_OFFERED, RegisterNPC)
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_QUEST_COMPLETE, RegisterQuestDone)
	EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_QUEST_REMOVED, RegisterQuestCancelled)
	EVENT_MANAGER:UnregisterForEvent("Destinations", EVENT_ADD_ON_LOADED)
	
end

EVENT_MANAGER:RegisterForEvent("Destinations", EVENT_ADD_ON_LOADED, OnLoad)
